<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag article sell statistic table class
	 */

	load_f('pagination');
	load_f('mb_wrap');

	class ARTICALSTATISTIC	{

		var $COLUMN_names	=	array('code', 'name', 'unit', 'selled_quantity', 'enter_quantity', 'produced_quantity', 'defective_quantity');

		var $TABLE		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COMMAND		=	'';
		var $COLUMNS		=	'';
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;

		function __construct($INCREMENT, $LIMIT)	{

			$this->CONT1	=	'articaldetails';

			$this->INC	=	$INCREMENT;

			$this->LIMIT	=	$LIMIT;

			$COMMAND	=	'';

			$PAGE		=	0;
	
			global $__SQL, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BOX	=	&$__BOX;

			$this->BASE	=	$_SESSION['BASE'];

			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $this->BASE;

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			unset($_SESSION['ID']);
		}

		/**
		 * Adds limit to command
	 	 */

		public function FORMCOMMAND()	{

			$this->COMMAND 	= $_SESSION['COMMAND'] = "	SELECT 	deliverys_data.code, deliverys_data.name, deliverys_data.unit, COALESCE(SUM(quantity),0) AS `selled_quantity`,
										COALESCE(enter.enter_quantity,0) as enter_quantity, 
										COALESCE(production.produced_quantity, 0) AS produced_quantity, 
										COALESCE(production.defective_quantity, 0) AS defective_quantity
									FROM $this->BASE.deliverys_data 
									LEFT OUTER JOIN	(
												SELECT `code`, SUM(quantity) AS `enter_quantity` 
												FROM $this->BASE.finished_goods_stock_enter
												WHERE `deleted` IS NOT NULL GROUP BY `code`
											)
											AS `enter`
									ON enter.code=deliverys_data.code
									LEFT OUTER JOIN	(
											SELECT `code`, SUM(quantity) AS `produced_quantity`, SUM(defective_quantity) AS `defective_quantity`
											FROM $this->BASE.production_orders_header
											WHERE `deleted` IS NOT NULL AND `date_of_finishing` IS NOT NULL GROUP BY `code`
											)
											AS `production`
									ON production.code=deliverys_data.code

									WHERE deliverys_data.deleted IS NOT NULL 
									GROUP BY `code`
									ORDER BY `selled_quantity` DESC	";

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Create table header row
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names as $COLUMN)	{

				$this->ROW_LABEL .= "<td class=\"column-search\">".mb_wrap($this->LANG->get($COLUMN), 6, '<br>')."</td>\n";
			}

			$this->ROW_LABEL	.=	'<td class="filters">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" name="PRINT" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n"
							."</tr>\n";
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else	  { 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM	=	floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 1;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];
	
					if ($COLUMN == 'code')	{

						$this->SQL->query("	SELECT `personID` 
									FROM $this->STOCKBASE.finished_goods_stock
									WHERE `code`='".$this->SQL->r_escape($VALUE)."' AND `deleted` IS NOT NULL LIMIT 1");
						$ID	=	0;

						if ($this->SQL->num_rows())	{

							$ID	=	$this->SQL->RESULT->fetch_row();
							$ID	=	$ID[0];
						}
					}

					$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .= 	"<td class=\"link\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=".$this->CONT1."&amp;id=$ID\">$DETAILS</a>\n"
							."</td>\n";

				$this->TABLE_BODY .= "</tr>\n";
			}

			$this->SQL->free();

			unset($this->SQL->IT1_RESULT);
		}

		/**
		 * Read posts and set filter states
		 */
	
		private function GETPOST()	{

			if (isset($_GET['new'])) $_SESSION['LISTPAGE']	= 0;

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				if (isset($_SESSION['LISTPAGE'])) $this->PAGE = $_SESSION['LISTPAGE'];
			}
		}

		/**
		 * Displays the table;
		 */

		public function create()	{

			$this->GETPOST();

			$this->FORMCOMMAND();

			$this->TABLEHEADER();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->TABLE_BODY);
		}
	}
?>
