<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.0
	 */

	/**
	 * eBag feedstock usage (list of connected production orders)
	 */

	load_f('mb_wrap');

	class FEEDSTOCKUSAGE	{

		var $COLUMN_names	=	array(	'personID', 'usagetype', 'quantity', 'unit'	);

		var $COLUMN_names_AS	=	array();

		var $TABLE		=	'';

		function __construct()	{

			global $__SQL, $__CONF, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->LANG	=	&$__LANG;

			$this->BOX	=	&$__BOX;

			$this->BASE	=	$_SESSION['BASE'];

			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $_SESSION['BASE'];

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) 	{

				$this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($COLUMN);
			}
		}


		private function readfeedstock($ID)	{

			$this->SQL->query("	SELECT `code`, `feedstockname` as `name`, `unit`
						FROM $this->STOCKBASE.feedstock
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			$this->FEEDSTOCKDATA	=	$this->SQL->RESULT->fetch_assoc();

			$this->CODE		=	$this->SQL->r_escape($this->FEEDSTOCKDATA['code']);

			return TRUE;
		}

		public function create($ID)	{

			if (! $this->readfeedstock($ID)) return 'unexistentfeedstock';

			$this->TABLE	=	"<table class=\"list\" width=\"400\">\n"
						.'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				if ($key == 'personID') {$CLASS='class="personID-name"';} else {$CLASS='class="column-names"';}

				$this->TABLE .= "<td $CLASS height=\"35\">".mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->TABLE	.=	'</tr>'."\n";

			$this->SQL->query("	(
							SELECT `productionorderID` AS `personID`, 'production' AS `usagetype`, `quantity`, `unit`
							FROM $this->BASE.production_orders_data
							WHERE 	`code`='$this->CODE' AND `productionorderID` NOT IN (	SELECT `personID`
															FROM $this->BASE.production_orders_header
															WHERE `date_of_finishing` IS NOT NULL	)
								AND `deleted` IS NOT NULL
							ORDER BY `productionorderID`
						)
						UNION ALL
						(
							SELECT  `requestID` AS `personID`, 'request' AS `usagetype`, `quantity`, `unit`
							FROM 	$this->BASE.feedstock_requests
							WHERE 	`code`='$this->CODE' AND `deleted` IS NOT NULL
								AND `reversID` IN (	SELECT `personID` 
											FROM $this->BASE.services_header
											WHERE `date_of_finishing` IS NULL AND `deleted` IS NOT NULL	)
								AND `deleted` IS NOT NULL
							ORDER BY `requestID`
						)	");

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	return 'nofeedstockusage';
	
			$CLASS		=	'list-dark';
			
			$SUM		=	0;

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					if ($COLUMN == 'usagetype')	{

						if ($VALUE == 'production')	{

							$VALUE = $this->LANG->get('production_order');

						}	else	  {

							$VALUE = $this->LANG->get('feedstock_request');
						}
					}

					$this->TABLE .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
					
					if ($COLUMN == 'quantity') $SUM += $VALUE;
				}

				$this->TABLE .=	"</tr>\n";
			}
			
			$this->FEEDSTOCKDATA['sum'] = $SUM;
			
			$this->SQL->free();

			$this->TABLE .= '</table>'."\n";

			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n$this->TABLE\n</div>\n</div>\n";

			return TRUE;
		}
	}
?>
