<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 4.0.0
	 */

	/**
	 * eBag monthly statistic of working hours reader
	 */

	load_f('mb_wrap');

	class MONTHLYHOURS	{

		var $TABLE	=	'';

		var $COLUMNS	=	array(	'date', 'work_hours', 'overtime_work_hours', 'night_work', 'night_overtime_work', 
						'holiday_work', 'sick_leave', 'sick_leave_100', 'annual_leave', 'holiday'	);

		function __construct()	{

			global $__SQL, $__CONF, $__LANG, $__BOX;

			$this->SQL	=	&$__SQL;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->YESNO	=	array(0=>$__LANG->get('no'), 1=>$__LANG->get('yes'));

			$this->LANG	=	&$__LANG;

			$this->BOX	=	&$__BOX;

			for ($i=1; $i<=12; $i++) $this->MONTHS[$i] = $this->LANG->get("monthname$i");
		}

		private function lock()		{

			$this->SQL->query("LOCK TABLES $this->BASE.working_hours WRITE");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function HEADER()	{


			$this->TABLE	.=	'<tr class="list-column-names">';

			foreach ($this->COLUMNS as $COLUMN) $this->TABLE .= '<td>'.mb_wrap($this->LANG->get($COLUMN), 7, '<br>').'</td>';

			$this->TABLE	.=	'</tr>';

		}

		public function read($ID, $MONTH)	{

			$ID	=	$this->SQL->escape($ID);

			$MONTH	=	$this->SQL->escape($MONTH);

			$this->lock();

			# read one row for name

			$this->SQL->query("	SELECT `employeename` 
						FROM $this->BASE.working_hours
						WHERE `employeeID`='$ID' AND MONTH(date)='$MONTH' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return FALSE;
			}

			$this->HEADER();

			$RESULT	= $this->SQL->RESULT->fetch_row();

			$DATA['employeename'] = $RESULT[0];

			$DATA['month'] = $this->MONTHS[$MONTH]; unset($this->MONTHS);

			$this->SQL->query("	SELECT 	DATE_FORMAT(`date`, '$this->FORMAT') AS `date`,
							`work_hours`, `overtime_work_hours`, `night_work`, `night_overtime_work`, `holiday_work`, 
							`sick_leave`, `sick_leave_100`, `annual_leave`, `holiday` 
						FROM $this->BASE.working_hours
						WHERE `employeeID`='$ID' AND MONTH(date)='$MONTH' AND `deleted` IS NOT NULL ORDER BY `date`	");

			$CHECKBOXES	=	array('night_work', 'night_overtime_work', 'holiday_work', 'holiday', 'sick_leave', 'sick_leave_100', 'annual_leave');

			$E_work = $E_night_work = $E_overtime_work = $E_night_overtime_work = $E_holiday = $E_sick_leave = $E_sick_leave_100 = $E_annual_leave = 0;

			$CLASS 	= 'list-dark';

			while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

				# first create sums

				if ($RESULT['night_work'])	{

					$E_night_work	+=	$RESULT['work_hours'];

				}	else	  {

					$E_work		+=	$RESULT['work_hours'];
				}


				if ($RESULT['night_overtime_work'])	{

					$E_night_overtime_work	+= 	$RESULT['overtime_work_hours'];

				}	else	  {

					$E_overtime_work	+= 	$RESULT['overtime_work_hours'];
				}

				if ($RESULT['holiday'])		$E_holiday++;

				if ($RESULT['sick_leave'])	$E_sick_leave++;
				
				if ($RESULT['sick_leave_100'])	$E_sick_leave_100++;

				if ($RESULT['annual_leave'])	$E_annual_leave++;

				# then localize them

				foreach ($CHECKBOXES as $BOX) $RESULT[$BOX] = $this->YESNO[$RESULT[$BOX]];

				# add to table

				if ($CLASS=='list-dark') {$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE	.=	"<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMNS as $COLUMN) {

					$this->TABLE .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"".$RESULT[$COLUMN]."\"></td>\n";
				}

				$this->TABLE	.=	'</tr>';
			}

			$this->TABLE	=	"<table id=\"data\" class=\"list\">$this->TABLE</table>";

			$DATA['E_work']			=	number_format($E_work, 2, '.', '');

			$DATA['E_night_work']		=	number_format($E_night_work, 2, '.', '');

			$DATA['E_overtime_work']	=	number_format($E_overtime_work, 2, '.', '');

			$DATA['E_night_overtime_work']	=	number_format($E_night_overtime_work, 2, '.', '');

			$DATA['E_holiday']		=	$E_holiday;

			$DATA['E_sick_leave']		=	$E_sick_leave;
			
			$DATA['E_sick_leave_100']	=	$E_sick_leave_100;

			$DATA['E_annual_leave']		=	$E_annual_leave;

			$this->unlock();

			return $DATA;
		}
	}
?>

