<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag payments statistic for customer
	 */

	load_f('pagination');

	load_f('mb_wrap');

	class PAYMENTSTATISTICS	{

		var $SUMMARY		=	array();
		var $TABLE		=	'';
		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $COMMAND		=	'';

		function __construct($INCREMENT, $LIMIT)	{

			$this->INC	=	$INCREMENT;

			$this->LIMIT	=	$LIMIT;

			$this->BASE	=	$_SESSION['BASE'];

			global $__SQL, $__CONF, $__LANG;

			$this->SQL	=	&$__SQL;

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');

			$this->CURR	=	$__CONF->get('payments', 'currency');

			$this->LANG	=	&$__LANG;
		}

		public function customerID($ID)	{

			$this->ID	=	$this->SQL->escape($ID);
		}

		private function FORMCOMMAND()	{

			if (! $this->COMMAND)	{

				$this->COMMAND = "	(
								SELECT SQL_CALC_FOUND_ROWS ('claim') AS `type`, `billID` AS `ID_or_bank`, 
								DATE_FORMAT(`payment_deadline`, '$this->FORMAT') AS `date`, `sum` 
								FROM $this->BASE.claims
								WHERE `contactID`='$this->ID'
							)
							UNION ALL
							(	SELECT ('payment') AS `type`, `bank` AS `ID_or_bank`, 
								DATE_FORMAT(`date`, '$this->FORMAT') AS `date`, `sum` 
								FROM $this->BASE.customers_payments
								WHERE `contactID`='$this->ID'
							) 
							ORDER BY `date` DESC	";

				$_SESSION['COMMAND'] = $this->COMMAND;
			}

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$COLUMNS	=	array('payment_deadline'=>'', 'sum'=>'', 'billID'=>'', 'date'=>'', 'sum'=>'', 'bank'=>'', 'printview'=>'', 'printall'=>'');

			foreach ($COLUMNS as $key=>$val) $COLUMNS[$key] = mb_wrap($this->LANG->get($key), 7, '<br>');

			extract($COLUMNS); unset($COLUMNS);

			$PRINT	=	$this->LANG->get('PRINT_B');

			$this->ROW_LABEL	=	<<<"EOT"
							<tr class="list-column-names">
							<td class="column-names">$payment_deadline</td>
							<td class="column-names">$sum</td><td height="55"></td>
							<td class="column-names">$billID</td>
							<td class="column-names">$date</td>
							<td class="column-names">$sum</td><td></td>
							<td class="column-names">$bank</td>
							<td class="filters">
							<div id="print" class="list-print-div-hide">
							<a class="print-link" target="_blank" href="../controllers/paymentstatprint.php?id=view" onclick="Javascript: printhide()">$printview</a>&nbsp;&nbsp;&nbsp;
							<a class="print-link" target="_blank" href="../controllers/paymentstatprint.php?id=all" onclick="Javascript: printhide()">$printall</a></div>
						 	<input class="button-print" type="button" value="$PRINT" onclick="Javascript: printmenu();">
							</td>
							</tr>
EOT;
		}

		/**
		 * Count the pages
		 */


		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->SQL->IT1_RESULT	= $this->SQL->RESULT;

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"10\">$ERRTXT</td></tr>\n";

				return;
			}

			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');

			while ($IT_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$payment_deadline = $bill_sum = $bill_link = $date_of_pay = $payment_sum = $bank = $billcurr = $paycurr = '';
	
				if ($IT_RESULT['type']=='claim')	{

					$billID	= $bill_ID = $IT_RESULT['ID_or_bank'];

					$this->SQL->query("	SELECT `baseyear` 
								FROM $this->BASE.claims 
								WHERE `billID`='$billID' LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$RESULT		=	$this->SQL->RESULT->fetch_row();

						$year		=	$RESULT[0];

						$bill_link	=	"<a class=\"menu\" href=\"loader.php?cat=billdetails&amp;id=$billID&amp;year=$year\">$billID/$year</a>";
					}

					$payment_deadline	=	$IT_RESULT['date'];

					$bill_sum		=	$IT_RESULT['sum'];

					$billcurr		=	$this->CURR;


				}	else	  {

					$bank		=	$IT_RESULT['ID_or_bank'];

					$date_of_pay	=	$IT_RESULT['date'];

					$payment_sum	=	$IT_RESULT['sum'];

					$paycurr	=	$this->CURR;
				}

				$this->TABLE_BODY .= <<<"EOT"
								<tr class="$CLASS" onmouseover="Javascript: mark(this);" onmouseout="Javascript: unmark(this);">
								<td><input class="list-input" style="width: 100px" readonly value="$payment_deadline"></td>
								<td align="left">$bill_sum&nbsp;&nbsp;</td>
								<td align="left" width="40">$billcurr</td>
								<td width="70" align="left">$bill_link</td>
								<td><input class="list-input" style="width: 100px" readonly value="$date_of_pay"></td>
								<td align="left">$payment_sum&nbsp;&nbsp;</td><td align="left" width="40">$paycurr</td>
								<td colspan="2"><input class="list-input" style="width: 170px" readonly value="$bank"></td>
								</tr>
EOT;
			}

			unset($this->SQL->IT1_RESULT);
		} 

		/**
		 * Get pages 
	 	 */

		private function getpage()	{

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}

			if (isset($_SESSION['COMMAND'])) $this->COMMAND	= $_SESSION['COMMAND'];
		}

		/**
		 * Create table
		 */

		public function create()	{

			# read header data

			$this->SQL->query("	SELECT `contactname`, `city`
						FROM $this->BASE.addressbook
						WHERE `personID`='$this->ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) return FALSE;

			$RESULT			=	$this->SQL->RESULT->fetch_row();

			$this->SUMMARY['contactname']	=	$RESULT[0];

			$this->SUMMARY['city']		=	$RESULT[1];

			$this->SQL->query("	SELECT SUM(`sum`) 
						FROM $this->BASE.claims
						WHERE `contactID`='$this->ID'	");

			$RESULT			=	$this->SQL->RESULT->fetch_row();

			$this->SUMMARY['claims_sum']	=	$RESULT[0];

			if (! $this->SUMMARY['claims_sum']) $this->SUMMARY['claims_sum'] = '0.00';

			$this->SQL->query("	SELECT SUM(`sum`) 
						FROM $this->BASE.customers_payments
						WHERE `contactID`='$this->ID'	");

			$RESULT			=	$this->SQL->RESULT->fetch_row();

			$this->SUMMARY['payments_sum']	=	$RESULT[0];

			if (! $this->SUMMARY['payments_sum']) $this->SUMMARY['payments_sum'] = '0.00';

			# create table

			$this->getpage();

			$this->TABLEHEADER();

			$this->FORMCOMMAND();

			$this->TABLEBODY();

			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);

			return TRUE;
		} 
	}
?>
