<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag salary print
	 */

	load_f('id_explode');
	
	load_f('explode_textarea');

	class SALARYPRINT	{

		var $ID_s	=	array();

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->FONT_FAMILY = 	$__CONF->get('font', 'family');
			
			$this->FONT_N_FILE = 	$__CONF->get('font', 'normal_font_file');
			
			$this->FONT_B_FILE = 	$__CONF->get('font', 'bold_font_file');
			
			if ($this->FONT_B_FILE) {$this->BOLD = 'B';} else {$this->BOLD = '';}
		}

		public function ids($IDs=FALSE)	{

			if ($IDs) $this->ID_s = id_explode($IDs);
		}

		public function month($MONTH=FALSE, $PART=0)	{

			if (! $MONTH) return;
			
			if ($PART) {$PART_STR = " AND `month_part`='$PART' ";} else {$PART_STR = '';}

			$this->SQL->query("	SELECT `personID`
						FROM $this->BASE.salarys
						WHERE `month`='$MONTH' $PART_STR AND `deleted` IS NOT NULL ");

			if ($this->SQL->num_rows())	{

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->ID_s[] = $RESULT[0];
			}
		}
		
		private function lock()	{

			$this->SQL->query(" LOCK TABLES	$this->BASE.salarys WRITE, ebag.companydata WRITE ");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function setpage()	{

			if ($this->FONT_N_FILE) $this->PDF->AddFont($this->FONT_FAMILY,'',$this->FONT_N_FILE,true);
			if ($this->FONT_B_FILE) $this->PDF->AddFont($this->FONT_FAMILY,$this->BOLD,$this->FONT_B_FILE,true);

			$this->PDF->AliasNbPages();

			$this->PDF->SetCreator('eBag-TFPDF');
			$this->PDF->SetSubject($this->LANG->get('salary'));
			$this->PDF->SetTitle($this->LANG->get('salary'));

			$this->PDF->SetTextColor(0);
			$this->PDF->SetDrawColor(0);
			$this->PDF->SetFillColor(255);
			$this->PDF->SetMargins(12, 10, 10, 10);
		}

		private function addrow($LABEL, $VALUE, $UNIT)	{

			$this->PDF->eSetX(30);
			$this->PDF->eCell(10, 6, '', 0, 0, 'C', 0);
			$this->PDF->eCell(65, 6, $LABEL, 0, 0, 'L', 0);
			$this->PDF->eCell(10, 6, ':', 0, 0, 'C', 0);
			$this->PDF->eCell(20, 6, $VALUE, 0, 0, 'L', 0);
			$this->PDF->eCell(10, 6, $UNIT, 0, 0, 'L', 0);
			$this->PDF->Ln(5);
		}

		private function createpage($ID)	{

			$this->PDF->AddPage();

			$this->PDF->PAGE_NUMBER = 1;
			
			# Read company ID & check existens 
			
			$this->SQL->query("	SELECT `companyID` 
						FROM $this->BASE.salarys
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1 ");
						
			if (! $this->SQL->num_rows()) return FALSE;
			
			list($companyID) = $this->SQL->RESULT->fetch_row();

			# read company data (not must to be the same)

			$this->SQL->query("	SELECT 	`companyname`, `country`, `city`, `zip`, `street`, `telephone1`, 
							`fax`, `mail`, `website`, `account1`, `bank1`, `tax_id_number` 
						FROM ebag.companydata 
						WHERE `personID`='$companyID' LIMIT 1	");

			$COMPANY = $this->SQL->RESULT->fetch_assoc();

			foreach ($COMPANY as $key=>$val) $COMPANY[$key] = htmlspecialchars_decode($val, ENT_COMPAT);

			$this->PDF->Ln(6);
			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,9);

			$this->PDF->eCell(0, 10, $COMPANY['companyname'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->SetFont($this->FONT_FAMILY,'',9);	

			$this->PDF->eCell(0, 10, $COMPANY['country'].', '.$COMPANY['city'].' '.$COMPANY['zip'].', '.$COMPANY['street'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $this->LANG->get('telephone').': '.$COMPANY['telephone1'].' '.$this->LANG->get('fax').': '.$COMPANY['fax'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $COMPANY['mail'].'  '.$COMPANY['website'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $this->LANG->get('account').': '.$COMPANY['account1'].' '.$COMPANY['bank1'], 0, 0, 'L', 0);

			$this->PDF->Ln(4);
			$this->PDF->eCell(0, 10, $this->LANG->get('taxidno').': '.$COMPANY['tax_id_number'], 0, 0, 'L', 0);

			unset($COMPANY);
			
			# read salary data

			$this->SQL->query("	SELECT 	`employeeID`, `employeename`, `currency`, `salary_globals`, `fix_payment`, `working_hour_value`,
						`additionals`, `credits`, `month`, `month_part`, `bonus_config`,
						DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`, 
						`E_work`, `E_overtime_work`, `E_night_work`, `E_night_overtime_work`, `E_night_holiday_work`,
						`E_night_overtime_holiday_work`, `E_sick_leave`, `E_sick_leave_100`, `E_holiday_work`, `E_holiday_overtime_work`,
						`E_holiday`, `E_annual_leave`, `E_bonus_production`, `E_bonus_services`, `E_bonus_product_sell`,
						`E_bonus_service_sell`, `Salary_BASE`, `E_payment`, `annotation`
					FROM $this->BASE.salarys
					WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			$SALARY = $this->SQL->RESULT->fetch_assoc();
			
			if ($SALARY['month_part'])	{
			
				if ($SALARY['month_part'] == 1)	{
				
					$from_day = 1;
				  
					if ($SALARY['month'] == 2) {$to_day = 14;} else {$to_day = 15;}
			      
					$salary_part = 'I';
					
				}	else	  {
				
					if ($SALARY['month'] == 2) {$from_day = 15;} else {$from_day = 16;}
					
					$to_day = date('t', mktime(0, 0, 0, $SALARY['month'], 1, str_replace('ebagdata', '', $this->BASE)));
				
					$salary_part = 'II';
				}
				
				$salary_period = $this->LANG->get('month').' : '.$this->LANG->get('monthname'.$SALARY['month'])." $salary_part (".str_replace('ebagdata', '', $this->BASE).'/'.$SALARY['month']."/$from_day-$to_day.)";
				
			}	else	  {

				$salary_period = $this->LANG->get('month').' : '.$this->LANG->get('monthname'.$SALARY['month']).' ('.str_replace('ebagdata', '', $this->BASE).'/'.$SALARY['month'].')';
			}

			# print salary label

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,9);
			$this->PDF->eSetX(105);
			$this->PDF->PAGE_TITLE = $this->LANG->get('salarynumber_pdf', $ID.'/'.str_replace('ebagdata', '', $this->BASE).'/'.$SALARY['employeeID']);

			$this->PDF->eCell(0, 6, $this->PDF->PAGE_TITLE, 0, 0, 'L', 0);

			$this->PDF->Ln(5);
			$this->PDF->SetFont($this->FONT_FAMILY, '', 7);
			$this->PDF->eSetX(105);
			$this->PDF->eCell(80, 6, $this->LANG->get('employee').' : '.$SALARY['employeename'], 0, 0, 'L', 0);
			$this->PDF->Ln(5);
			$this->PDF->eSetX(105);
			$this->PDF->eCell(0, 6, $salary_period, 0, 0, 'L', 0);
			$this->PDF->Ln(5);
			$this->PDF->eSetX(105);
			$this->PDF->eCell(0, 6, $this->LANG->get('date_of_creation').' : '.$SALARY['date_of_creation'], 0, 0, 'L', 0);
			$this->PDF->Ln(5);

			$SALARY['salary_globals']	=	unserialize($SALARY['salary_globals']);
			$SALARY['additionals']		=	unserialize($SALARY['additionals']);
			$SALARY['credits']		=	unserialize($SALARY['credits']);
			$SALARY['bonus_config']		=	unserialize($SALARY['bonus_config']);
			

			# print elementary constans

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,7);
			$this->PDF->eSetX(30);
			$this->PDF->eCell(115, 6, $this->LANG->get('elementary_constans_for_calculations').'  ', 'B', 0, 'L', 0);
			$this->PDF->SetFont($this->FONT_FAMILY,'',7);
			$this->PDF->Ln(6);

			$BASE_COEFS		=	array('overtime_work', 'night_work', 'holiday_work', 'sick_leave', 'annual_leave', 'holiday');

			foreach ($BASE_COEFS as $COEF) 	{

				$this->addrow($this->LANG->get($COEF), $SALARY['salary_globals'][$COEF], '%');

				unset($SALARY['salary_globals'][$COEF]);
			}	

			# print payment type (fix/according to working hours);

			if ($SALARY['fix_payment'])		$PAYMENT_TYPE = 'fix_payment';
			if ($SALARY['working_hour_value'])	$PAYMENT_TYPE = 'working_hour_value';

			if (isset($PAYMENT_TYPE))	{

				$this->addrow($this->LANG->get($PAYMENT_TYPE), $SALARY[$PAYMENT_TYPE], $SALARY['currency']);

				unset($PAYMENT_TYPE);
			}

			# print used bonus type for all
			
			$UNITS = array(	'bonus_percent_' => '%',
					'bonus_fix_'	 => $SALARY['currency'] );
			    
			foreach(array('production', 'services', 'product_sell', 'service_sell') as $BONUS_TYPE)	{
			
				foreach(array('bonus_percent_', 'bonus_fix_') as $SUB)	{
				
					if ($SALARY['bonus_config'][$SUB.$BONUS_TYPE] > 0)	{
					
						   $this->addrow($this->LANG->get($SUB.$BONUS_TYPE), $SALARY['bonus_config'][$SUB.$BONUS_TYPE], $UNITS[$SUB]);
					}
				}
			}
			
			# print used bonus type specific
			
			foreach(array('production', 'services', 'product_sell', 'service_sell') as $BONUS_TYPE)	{
			
				if ($SALARY['bonus_config']["bonus_to_$BONUS_TYPE"] == 3)	{
				
					 $this->addrow($this->LANG->get("bonus_to_$BONUS_TYPE"), '', '+');
				}
			}

			# print working hours sheet

			$TYPES = array(	'E_work', 'E_overtime_work', 'E_night_work', 'E_night_overtime_work', 'E_night_holiday_work',
					'E_night_overtime_holiday_work', 'E_holiday_work', 'E_holiday_overtime_work', 'E_holiday', 'E_annual_leave', 'E_sick_leave', 'E_sick_leave_100');
					
			# change the days (text) to hours in printed salary
			
			$lang_correct = array(	'E_holiday'		=>	'E_holiday_hours',
						'E_annual_leave'	=>	'E_annual_leave_hours',
						'E_sick_leave'		=>	'E_sick_leave_hours',
						'E_sick_leave_100'	=>	'E_sick_leave_100_hours' );	

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,7);
			$this->PDF->eSetX(30);
			$this->PDF->eCell(115, 6, $this->LANG->get('workinghourssummary'), 'B', 0, 'L', 0);
			$this->PDF->SetFont($this->FONT_FAMILY,'',7);
			$this->PDF->Ln(6);	

			foreach ($TYPES as $TYPE)	{
			
				if (array_key_exists($TYPE, $lang_correct)) {$columnname = $lang_correct[$TYPE];} else {$columnname = $TYPE;}
			
				$this->addrow($this->LANG->get($columnname), $SALARY[$TYPE], $this->LANG->get('hoursign'));
			}

			unset($TYPES);

			# print calculated bonus sum values

			$BONUSES = array('E_bonus_production', 'E_bonus_services', 'E_bonus_product_sell', 'E_bonus_service_sell');

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,7);
			$this->PDF->eSetX(30);
			$this->PDF->eCell(115, 6, $this->LANG->get('bonusessummary'), 'B', 0, 'L', 0);
			$this->PDF->SetFont($this->FONT_FAMILY,'',7);
			$this->PDF->Ln(6);

			foreach ($BONUSES as $BONUS) $this->addrow($this->LANG->get($BONUS), $SALARY[$BONUS], $SALARY['currency']);

			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,7);
			$this->PDF->eSetX(30);
			$this->PDF->eCell(115, 6, $this->LANG->get('summary'), 'B', 0, 'L', 0);
			$this->PDF->SetFont($this->FONT_FAMILY,'',7);
			$this->PDF->Ln(6);

			# print calculated salary base

			$this->addrow($this->LANG->get('calculated_salary_base'), $SALARY['Salary_BASE'], $SALARY['currency']);

			# print personal adds

			if ((isset($SALARY['additionals']['additional_name'])) && (is_array($SALARY['additionals']['additional_name'])) && ($count = count($SALARY['additionals']['additional_name'])))	{

				for ($i=0; $i<$count; $i++) $this->addrow($SALARY['additionals']['additional_name'][$i],(string)$SALARY['additionals']['additional_value'][$i], $SALARY['currency']);
			}

			# print global adds

			if ((isset($SALARY['salary_globals']['additional_name'])) && (is_array($SALARY['salary_globals']['additional_name'])) && ($count = count($SALARY['salary_globals']['additional_name'])))	{

				for ($i=0; $i<$count; $i++) $this->addrow($SALARY['salary_globals']['additional_name'][$i], (string)$SALARY['salary_globals']['additional_value'][$i], $SALARY['currency']);
			}

			# print credits

			if ((isset($SALARY['credits']['credit_name'])) && (is_array($SALARY['credits']['credit_name'])) && ($count = count($SALARY['credits']['credit_name'])))	{

				for ($i=0; $i<$count; $i++) $this->addrow($SALARY['credits']['credit_name'][$i], (string)$SALARY['credits']['credit_value'][$i], $SALARY['currency']);
			}

			# print payment

			$this->PDF->eCell(10, 6, '', 0, 0, 'C', 0);	
			$this->PDF->SetFont($this->FONT_FAMILY,$this->BOLD,7);	
			$this->PDF->eSetX(40);
			$this->PDF->eCell(65, 6, $this->LANG->get('payment'), 0, 0, 'L', 0);
			$this->PDF->eCell(10, 6, ':', 0, 0, 'C', 0);
			$this->PDF->SetFont($this->FONT_FAMILY, $this->BOLD,7);
			$this->PDF->eCell(20, 6, $SALARY['E_payment'], 0, 0, 'L', 0);
			$this->PDF->eCell(10, 6, $SALARY['currency'], 0, 0, 'L', 0);
			$this->PDF->SetFont($this->FONT_FAMILY, '', 7);
			$this->PDF->Ln(6);
			$this->PDF->eSetX(30);
			$this->PDF->eCell(115,6,'','T', 0, 'L', 0);
			
			# annotation
			
			$first_row = TRUE;
			
			if ($LINES = explode_textarea($SALARY['annotation']))	  {
				
				foreach ($LINES as $LINE)	{

					if ($first_row) {$this->PDF->Ln(1); $first_row=FALSE;} else {$this->PDF->Ln(4);}
					
					$this->PDF->eSetX(27);
					$this->PDF->eCell(115, 6, $LINE, 0, 0, 'R', 0);
				}
			}
			
			return TRUE;
		}

		public function pdfprint()	{

			# create usable array

			if ((! $this->ID_s) or (! count($this->ID_s))) return FALSE;

			# first check te gived base exists or not

			$this->SQL->query("	SELECT SCHEMA_NAME FROM INFORMATION_SCHEMA.SCHEMATA WHERE SCHEMA_NAME = '$this->BASE'");

			if (! $this->SQL->num_rows()) return FALSE;

			# check existens for any case now after lock

			$this->IDs	=	array();

			foreach ($this->ID_s as $ID)	{

				$this->SQL->query("	SELECT `month`
							FROM $this->BASE.salarys
							WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows()) $this->IDs[] = $ID;
			}
			
			if (! count($this->IDs)) return FALSE;

			# set time limit

			set_time_limit(0);

			# create object

			$this->PDF = new ePDF('P','mm','A4');
			
			if (defined('TEXT_DIRECTION') && (TEXT_DIRECTION == 'rtl')) $this->PDF->RTL = TRUE;

			# sets elementary page data

			$this->setpage();
			
			$printed = FALSE;

			foreach ($this->IDs as $ID)	{
			
				$this->lock();
			
				if ($this->createpage($ID)) $printed = TRUE;
				
				$this->unlock();
				
				usleep(300000);
			}
			
			if (! $printed) return FALSE;

			# force download

			$this->PDF->Output('printed.pdf', 'D');

			return TRUE;
		}

	}

?>

