<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag stock artical details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('stock', 'r');

	load_c('SQL');

	$__SQL	= new SQL();

	load_m('articalread');

	$__ARTICAL	=	new ARTICALREAD();

	$ARTICALDATA	=	$__ARTICAL->read($_GET['id']);

	unset($__SQL, $__ARTICAL);

	if (! $ARTICALDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('articaldetails');

	$view	->	assign('SELF', backward());
	$view	->	assign('ARTICALDETAILS', $__LANG->get('articaldetails', $_GET['id']));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('NAME', $__LANG->get('feedstockname'));
	$view	->	assign('DIMENSIONS', $__LANG->get('dimensions'));
	$view	->	assign('UNIT', $__LANG->get('unit'));
	$view	->	assign('PRICE', $__LANG->get('price'));
	$view	->	assign('TAX', $__LANG->get('tax'));
	$view	->	assign('PRICEWITHTAX', $__LANG->get('price_with_tax'));
	$view	->	assign('DISCOUNTPRICE', $__LANG->get('discount_price'));
	$view	->	assign('DISCOUNTPRICEWITHTAX', $__LANG->get('discountprice_with_tax'));
	$view	->	assign('PURCHASEPRICE', $__LANG->get('purchase_price'));
	$view	->	assign('VALUTA', $__CONF->get('payments', 'valuta'));
	$view	->	assign('CURRENCY', $__CONF->get('payments', 'currency'));
	$view	->	assign('SUPPLIER', $__LANG->get('supplier'));
	$view	->	assign('SUPPLIERID', $__LANG->get('personID'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('QUANTITYORDERED', $__LANG->get('quantity_ordered'));
	$view	->	assign('QUANTITYORDEREDTOSTOCK', $__LANG->get('quantity_ordered_to_stock'));
	$view	->	assign('QUANTITYONEPENEDORDERTOSTOCK', $__LANG->get('quantity_on_opened_order_to_stock'));
	$view	->	assign('QUANTITYINPRODUCTION', $__LANG->get('quantity_in_production'));
	$view	->	assign('QUANTITYASPART', $__LANG->get('quantity_as_part'));
	$view	->	assign('EXCHANGE', $__LANG->get('exchange'));
	$view	->	assign('EXCHANGE_RATE', $__CONF->get('payments', 'exchange_rate'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ORIGIN', $__LANG->get('origin'));
	$view	->	assign('BAR_CODE', $__LANG->get('barcode'));
	$view	->	assign('USAGE', $__LANG->get('usage'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);

	/**
	 * Form values
	 */

	# localize origin

	$ARTICALDATA['origin'] = $__LANG->get('origin'.$ARTICALDATA['origin']);

	# add base64 encoded code for bar generator

	$ARTICALDATA['b64_code'] = base64_encode($ARTICALDATA['code']);

	# adds discountprice

	load_f('discountprice');

	$ARTICALDATA['discount_price']		= discountprice($ARTICALDATA['price']);
	$ARTICALDATA['discount_price_with_tax']	= discountprice($ARTICALDATA['price_with_tax']);

	$view	->	assign('DATA', $ARTICALDATA); unset($ARTICALDATA);
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('ID', $_GET['id']);

	$view	->	display();
?>
