<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag command line
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	pagepermission('settings', 'r');

	if (isset($_GET['new'])) unset($_SESSION['COMMAND']);

	if ((isset($_POST['command_set'])) && (isset($_POST['command'])) && ($_POST['command']))	{

		# only allow select

		$COMMAND	=	mb_eregi_replace('^\s*|\s*$', '', $_POST['command']);
		$PARTS		=	explode(' ', $COMMAND);

		if (strtoupper($PARTS[0])!='SELECT')	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('onlyselectallowed'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$_SESSION['COMMAND'] = $_POST['command'];

		$_GET['new']=1;
	}

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_SESSION['COMMAND']))	{

		load_c('COMMANDLINE');

		$table	=	new COMMANDLINE(PAGEINCREMENT);

		$RESULT = 	$table	->	create();

		if ($RESULT !== TRUE)	{

			unset($_SESSION['COMMAND'], $table, $__SQL);

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get($RESULT));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', backward());
			$view	->	display();
			exit;
		}

		$HTMLTABLE	=	&$table->TABLE;
		$PAGINATION	=	&$table->PAGINATION;

		$view	=	new View('commandlineresult');
		$view	->	assign('SELF', backward());
		$view	->	assign('PRINTVIEW', $__LANG->get('printview'));
		$view	->	assign('PRINTALL', $__LANG->get('printall'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view 	->	assign('HTMLTABLE', $HTMLTABLE);
		$view	->	assign('PAGINATION', $PAGINATION);
		
		unset($HTMLTABLE, $PAGINATION, $table, $__SQL);
		
		$view	->	display();

		exit;
	}

	load_m('commandlineread');

	$__COMMANDLINE	= new COMMANDLINEREAD();

	$DATA	=	$__COMMANDLINE->read();

	unset($__COMMANDLINE, $__SQL);

	if (! $DATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('fatalerror'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('commandline');

	$view	->	assign('SELF', backward());
	$view	->	assign('COMMAND_LINE', $__LANG->get('command_line'));
	$view	->	assign('YEAR', $__LANG->get('year'));
	$view	->	assign('EXIST_TABLES', $__LANG->get('tables'));
	$view	->	assign('EXIST_COLUMNS', $__LANG->get('columns'));
	$view	->	assign('DATA_BASES', $DATA['bases']);
	$view	->	assign('DATA_TABLES', $DATA['data']['tables']);
	$view	->	assign('STOCK_TABLES', $DATA['stock']['tables']);

	unset($DATA);

	$view	->	assign('RUN', $__LANG->get('run'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');
	
	$view	->	display();

?>

