<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag input company data controller
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');
	
	check_for_backup_in_progress('settings');

	load_c('SQL');

	$__SQL	= new SQL();

	load_m('companydataread');

	if (isset($_POST['submit']))	{

		load_m('companydatawrite');

		$__COMPANYDATA = new COMPANYDATAWRITE();
		
		if ((isset($_POST['update'])) && ($_POST['update']))	{

			$ID = $_POST['ID'];

			$RESULT = $__COMPANYDATA->update($ID, $_POST);

		}	else	 {

			$RESULT = $__COMPANYDATA->write($_POST);
		}
		
		# reset company_details cache after data change
		
		@unlink(BASEDIR.'tmp/c_view_companydetails.tmp');

		unset($__COMPANYDATA, $__SQL);
		
		if (! $RESULT)	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get('notenoughdata'));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', backward());
		$view	->	display();
		exit;
	}

	if (! isset($__COMPANYDATA))	{

		$__COMPANYDATA = new COMPANYDATAREAD();

		$ID = $__COMPANYDATA->getlastid();
	}

	if (isset($ID) && ($ID))	{

		$DATA = $__COMPANYDATA->read($ID);

	}	else	  {

		$ID = 0;
	}

	unset($__COMPANYDATA, $__SQL);

	$view = new View('companydata');

	$view	->	assign('SELF', backward());
	$view	->	assign('COMPANYDATA', $__LANG->get('companydata'));
	$view	->	assign('NAME', $__LANG->get('contactname'));
	$view	->	assign('COUNTRY', $__LANG->get('country'));
	$view	->	assign('CITY', $__LANG->get('city'));
	$view	->	assign('ZIP', $__LANG->get('zip'));
	$view	->	assign('STREET', $__LANG->get('street'));
	$view	->	assign('TELEPHONE1', $__LANG->get('telephone1'));
	$view	->	assign('TELEPHONE2', $__LANG->get('telephone2'));
	$view	->	assign('ACCOUNT1', $__LANG->get('account1'));
	$view	->	assign('ACCOUNT2', $__LANG->get('account2'));
	$view	->	assign('BANK1', $__LANG->get('bank1'));
	$view	->	assign('BANK2', $__LANG->get('bank2'));
	$view	->	assign('FAX', $__LANG->get('fax'));
	$view	->	assign('MAIL', $__LANG->get('mail'));
	$view	->	assign('WEBSITE', $__LANG->get('website'));
	$view	->	assign('TAXIDNO', $__LANG->get('taxidno'));
	$view	->	assign('TAXIDNO', $__LANG->get('taxidno'));
	$view	->	assign('REGISTRATIONNUMBER', $__LANG->get('registrationnumber'));
	$view	->	assign('COMPANYNUMBER', $__LANG->get('companynumber'));
	$view	->	assign('BUSINESSACTIVITYCODE', $__LANG->get('businessactivitycode'));
	$view	->	assign('CREATENEW', $__LANG->get('createnewcomp'));
	$view	->	assign('CHANGEEXISTS', $__LANG->get('changeexistscomp'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('WRITE', $__LANG->get('write'));

	if (! isset($DATA)) 	$DATA = array();

	$view	->	assign('ID', $ID);
	$view	->	assign('DATA', $DATA); unset($DATA);

	$view	->	display();
?>
