<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag system configuration
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	pagepermission('settings', 'w');

	$CONFS	= array (	'report_to' 			=>	'error',
				'host'				=>	'mail',
				'user'				=>	'mail',
				'password'			=>	'mail',
				'secure'			=>	'mail',
				'port'				=>	'mail',
				'dayscheck'			=>	'reminder',
				'currency'			=>	'payments',
				'valuta'			=>	'payments',
				'exchange_rate'			=>	'payments',
				'default_tax_for_service'	=>	'tax',
				'default_tax_for_sales'		=>	'tax',
				'directory'			=>	'backup',
				'daily_backup'			=>	'backup',
				'clamavpath'			=>	'virusscan',
				'increment'			=>	'display',
				'default_deadline_for_service'	=>	'delivery',
				'default_deadline_for_shipment'	=>	'delivery'	);

	if (isset($_POST['submit']))	{

		load_c('SQL');

		$__SQL	= new SQL();

		load_c('INICHANGE');

		load_m('configurationsave');

		$__CONF	= new CONFIGURATIONSAVE();

		$RESULT	= $__CONF->save($_POST, $CONFS);

		unset($__CONF, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR'] = $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		# reload the configuration
		# note:  $RELOAD = TRUE;

		$__CONF	=	new INI_load(BASEDIR.'conf/eBag.ini', TRUE);

		unset($__CONF);

		$view	=	new View('sucessbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('configurationsaved'));
		$view	->	assign('OK', $__LANG->get('ok'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');
		$view	->	display();
		exit;
	}

	$view	=	new View ('configuration');

	$view	->	assign('SELF', backward());
	$view	->	assign('EBAG_CONFIGURATION', $__LANG->get('ebagconfiguration'));
	$view	->	assign('CURRENCY', $__LANG->get('currency'));
	$view	->	assign('VALUTA', $__LANG->get('valuta'));
	$view	->	assign('EXCHANGE_RATE', $__LANG->get('exchange_rate'));
	$view	->	assign('DEFAULT_SERVICES_TAX', $__LANG->get('default_services_tax'));
	$view	->	assign('DEFAULT_SALES_TAX', $__LANG->get('default_sales_tax'));
	$view	->	assign('DEADLINE_TO_SERVICES', $__LANG->get('default_service_deadline'));
	$view	->	assign('DEADLINE_TO_DELIVERYS', $__LANG->get('default_shipment_deadline'));
	$view	->	assign('TABLE_ROWS_NUMBER', $__LANG->get('maximum_rows_in_table'));
	$view	->	assign('CHECK_REMIDER_BACKWARD', $__LANG->get('reminder_backward_check'));
	$view	->	assign('BACKUP_DIRECTORY', $__LANG->get('backup_directory'));
	$view	->	assign('DAILY_BACKUP', $__LANG->get('daily_backup'));
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('CLAMAV', $__LANG->get('clamav_with_path'));
	$view	->	assign('MAIL_HOST', $__LANG->get('mail_host'));
	$view	->	assign('MAIL_USER', $__LANG->get('mail_user'));
	$view	->	assign('MAIL_PASSWORD', $__LANG->get('mail_password'));
	$view	->	assign('RE_MAIL_PASSWORD', $__LANG->get('re_mail_password'));
	$view	->	assign('MAIL_SECURE', $__LANG->get('mail_secure'));
	$view	->	assign('MAIL_PORT', $__LANG->get('mail_port'));
	$view	->	assign('ERROR_REPORT_MAIL_TO', $__LANG->get('mail_report'));
	$view	->	assign('OK', $__LANG->get('ok'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=settings');

	$view 	->	assign('SECURETYPES', array('none'=>$__LANG->get('none'), 'ssl'=>'ssl', 'tls'=>'tls'));

	# assign form data from confugartion to

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		foreach ($CONFS as $key=>$val) $_POST[$key] = $__CONF->get($val, $key);
	}

	$view	->	display();

?>
