<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag feedstock request to service list details
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('service_lists');

	pagepermission('service_lists', 'w');
	
	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['YES']))	{

		load_m('feedstockrequest2listdelete');

		$__REQUEST	=	new FEEDSTOCKREQUEST2LISTDELETE();

		$RESULT		=	$__REQUEST -> delete($_POST['id'], $_POST['delete_reason']);

		unset($__REQUEST, $__SQL);

		if ($RESULT===TRUE)	{

			$view	=	new View('sucessbox');
			$view	->	assign('SELF', backward());
			$view	->	assign('MESSAGE', $__LANG->get('request2listdeleted', $_POST['id']));
			$view	->	assign('OK', $__LANG->get('ok'));
			$view	->	assign('BACKTO', $_SESSION['FROM']);
			$view	->	display();
			exit;
		}

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get($RESULT));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	load_m('requestexists');

	$check	=	new REQUESTEXISTS();

	$exists	=	$check->exists($_GET['id']);

	unset($check, $__SQL);

	if (! $exists)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('request2listnotexists'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('verifywithreason');
	$view	->	assign('SELF', backward());
	$view	->	assign('QUESTION', $__LANG->get('suretodelrequest2list', $_GET['id']));
	$view	->	assign('DELETE_REASON', $__LANG->get('deletereason').' :');
	$view	->	assign('YES', $__LANG->get('yes'));
	$view	->	assign('NO', $__LANG->get('no'));
	$view	->	assign('ID', $_GET['id']);
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	display();

	exit;
?>
