<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new feedstock request for service
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('services');

	pagepermission('services', 'w'); 

	if (isset($_GET['id']))		{

		$SERVICEID = $_SESSION['ID'] = $_GET['id'];
		
	}	else	  {

		$SERVICEID = $_SESSION['ID'];
	}
	
	if ((! isset($_GET['p_err'])) && isset($_SESSION['_POST_ERR'])) unset($_SESSION['_POST_ERR']);

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('feedstockrequestwrite');

		$__REQUEST = new FEEDSTOCKREQUESTWRITE();
		
		$RESULT = $__REQUEST->write($SERVICEID, $_POST);

		unset($__REQUEST, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('alertbox');
		$view	->	assign('SELF', 'loader.php?cat=feed_request_to_service');
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=services');
		$view	->	display();
		exit;
	}

	# Write back the post if error was

	if (post_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);
	}

	# read servicedata first

	load_m('serviceread');

	$__SERVICE	=	new SERVICEREAD();
	
	$SERVICEDATA	=	$__SERVICE->read($SERVICEID);
	
	unset($__SERVICE, $__SQL);

	if ($SERVICEDATA === FALSE)	{

		header('location: loader.php?cat=feed_request_to_service');

		exit;
	}

	$view	=	new View('feedstockrequesttoservice');

	$view	->	assign('SELF', backward());
	$view	->	assign('SERVICEID', $SERVICEID);
	$view	->	assign('NEWREQUEST', $__LANG->get('newfeedstockrequest', $SERVICEID));
	$view	->	assign('SERVICECODE', $__LANG->get('code'));
	$view	->	assign('SERVICENAME', $__LANG->get('servicename'));
	$view	->	assign('SERVICECODEVALUE', $SERVICEDATA['code']);
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('SERVICENAMEVALUE', $SERVICEDATA['servicename']); unset($SERVICEDATA);
	$view	->	assign('SEARCHBASE', $_SESSION['BASE']);


	$view	->	assign('BACKTO', 'loader.php?cat=feed_request_to_service');
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	$view	->	display();

?>
