<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag header
	 */

	ob_start('ob_gzhandler');
	
	define ('BASEDIR', '../');

	require(BASEDIR.'classes/INIload.class.php');
	require(BASEDIR.'classes/Language.class.php');

	/**
	 * Read the configuration
	 */

	$__CONF	= new INI_load(BASEDIR.'conf/eBag.ini');
	
	/**
	 * Set errorhandler
	 */

	require(BASEDIR.'classes/Errorhandler.class.php');

	$__HANDLER	=	new ERRHANDLER();
	$__HANDLER	->	start();


	require(BASEDIR.'classes/Sessionhandler.class.php');

	$__SESS		=	new MysqlSession();
	$__SESS		->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();

	if (! isset($_SESSION['permission'])) exit;
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	= new Lang(BASEDIR."lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	/**
	 * Redirect if the session is expired
	 */
	
	if (! isset($_SESSION['permission']))	{

		echo '<SCRIPT type="text/javascript">parent.location="../index.php"></SCRIPT>';
		exit;
	}

	if (! isset($_SESSION['logtime']))	{

		$DAYS	=	array(1=>$__LANG->get('day1'), 2=>$__LANG->get('day2'), 3=>$__LANG->get('day3'), 4=>$__LANG->get('day4'), 5=>$__LANG->get('day5'), 6=>$__LANG->get('day6'), 0=>$__LANG->get('day0'));

		$_SESSION['logtime']	=	$DAYS[date("w")]."&nbsp;".date($__CONF->get('date', 'dateformat'))."&nbsp;".date("h:i");

		unset($file, $DAYS);
	}

	require(BASEDIR.'classes/View.class.php');

	$view =	new View('header');

	$view->assign('LOGGED_IN', $__LANG->get('logged'));
	$view->assign('USER_NAME', $_SESSION['user']);
	$view->assign('LOGIN_TIME', $_SESSION['logtime']);
	$view->assign('CURRENT_YEAR', $__LANG->get('current_year'));
	$view->assign('YEAR', $_SESSION['year']);
	$view->assign('CURRENT_DISCOUNT', $__LANG->get('discount'));
	$view->assign('DISCOUNT',$_SESSION['discount']);
	$view->assign('USER', $_SESSION['user']);
	$view->assign('MD5USER', md5($_SESSION['user']));
	$view->assign('INVITATE', $__LANG->get('invitation'));

	unset($__LANG);

	$view->display();

?>
