<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new service
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('services');

	pagepermission('services', 'w');
	
	load_c('SQL');

	$__SQL	=  new SQL;

	if (isset($_POST['submit']))	{

		load_m('servicewrite');
	
		$__SERVICE	=	new SERVICEWRITE();
		$RESULT		=	$__SERVICE->write($_POST);

		unset($__SERVICE, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('alertbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=services');
		$view	->	display();
		exit;
	}

	$__UNITS	=	new UNITloader($__CONF->get('cache', 'use_apc_cache'));
	$UNITS	 	=	$__UNITS->getall();
	$DEFAULT	=	$__UNITS->getdefault();
	
	unset($__UNITS, $__SQL);

	# Write back the post if error was

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);
		
	}	else	  {
	
		$_POST['tax'] = str_replace('%', '', $__CONF->get('tax', 'default_tax_for_service'));
	}
	
	load_f('is_selected_unit');

	$view	=	new View('newservice');

	$view	->	assign('UNITS', $UNITS); unset($UNITS);
	$view	->	assign('DEFAULTUNIT', $DEFAULT); unset($DEFAULT);
	$view	->	assign('CURRENCY', $__CONF->get('payments', 'valuta'));
	$view	->	assign('NEWSERVICE', $__LANG->get('newservice'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('SERVICENAME', $__LANG->get('servicename'));
	$view	->	assign('UNIT', $__LANG->get('unit'));
	$view	->	assign('PRICE', $__LANG->get('price'));
	$view	->	assign('TAX', $__LANG->get('tax'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('WRITE', $__LANG->get('write'));

	$view	->	display(); 
?>
