<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new operating suplie request
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('operating_suplies');

	pagepermission('operating_suplies', 'w');

	load_c('SQL');

	$__SQL	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('suplierequestwrite');

		$__REQUEST	=	new SUPLIEREQUESTWRITE();

		unset($_POST['submit']);

		$RESULT		=	$__REQUEST->write($_POST);

		$NEWID 		=	$__REQUEST->getid();

		unset($__REQUEST, $__SQL);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  $_POST;

			# analize error type

			if (strpos($RESULT, '->') !== FALSE)	{

				list ($errtype, $point, $pointID)	= explode('->', $RESULT);

				$ERROR	=	$__LANG->get($errtype, $__LANG->get($point).': '.$pointID);

			}	else	 {

				$ERROR	= $__LANG->get($RESULT);
			}

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $ERROR);
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=suplierequestwrited&id=$NEWID");

		exit;
	}

	# display the search form

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEESDATA	=	$__EMPLOYEES->read();

	unset($__EMPLOYES);

	if (! $EMPLOYEESDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=operating_suplies');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('operating_suplie_request');

	$view	->	assign('SELF', backward());
	$view	->	assign('REQUESTLABEL', $__LANG->get('newsuplierequest'));
	$view	->	assign('TO_EMPLOYEE', $__LANG->get('employee'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=operating_suplies');
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('EMPLOYEES', $EMPLOYEESDATA); unset($EMPLOYEESDATA);

	# Write back the post if error was

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);
	}

	# new

	if ((! isset($_POST)) or (! count($_POST)))	{

		$_POST['date_of_creation']	= 	date($__CONF->get('date', 'dateformat'));
	}
	
	unset($__SQL);

	$view	->	display();

?>
