<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service list change
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('service_lists');

	pagepermission('service_lists', 'w');

	if (isset($_GET['id']))		{

		$SERVICELISTID = $_SESSION['ID'] = $_GET['id'];

	}	else	  {

		$SERVICELISTID = $_SESSION['ID'];
	}
	
	if ((! isset($_GET['p_err'])) && isset($_SESSION['_POST_ERR'])) unset($_SESSION['_POST_ERR']);

	load_c('SQL');

	$__SQL 	= new SQL;

	if (isset($_POST['submit']))	{

		load_m('servicelistupdate');

		$__SERVICELIST	=	new SERVICELISTUPDATE();

		unset($_POST['submit']);

		$RESULT		=	$__SERVICELIST->update($SERVICELISTID, $_POST);

		unset($__SQL, $__SERVICELIST);

		if ($RESULT !== TRUE)	{
		
			$_POST['_err_address'] = backward();

			$_SESSION['_POST_ERR']	=  	$_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address']."&amp;id=$SERVICELISTID&amp;p_err=1");
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=servicelistupdated&id=$SERVICELISTID");

		exit;
	}

	# read service list data

	if (post_data_verified())	{

		$_POST	= enc_quotes($_SESSION['_POST_ERR']);

		unset($_SESSION['_POST_ERR']);

	}	else	  {

		load_m('servicelistread');

		$__SERVICE	=	new	SERVICELISTREAD();
		$_POST		=	$__SERVICE->read($SERVICELISTID);

		unset($__SERVICE);

		if (! is_array($_POST))		{

			$view	=	new View('errorbox');
			$view	->	assign('SELF',  $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($_POST));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}
	}

	$__PAYMENTS	=	new PAYMENTloader($__CONF->get('cache', 'use_apc_cache'));

	$PAYMENT_FORMS		=	$__PAYMENTS->getnames();

	unset($__PAYMENTS);

	$view	=	new View('servicelist');

	$view	->	assign('SELF', backward());
	$view	->	assign('SERVICELISTLABEL', $__LANG->get('reverschange', $SERVICELISTID.'/'.$_POST['service_list_year']));
	$view	->	assign('SERVICELISTID', $SERVICELISTID);
	$view	->	assign('CONTACTID', $__LANG->get('contactID'));
	$view	->	assign('CONTACTNAME', $__LANG->get('contactname'));
	$view	->	assign('DATE_OF_CREATION', $__LANG->get('date_of_creation'));
	$view	->	assign('DATE_OF_DEADLINE', $__LANG->get('date_of_deadline'));
	$view	->	assign('PAYMENT_FORM', $__LANG->get('payment_form'));
	$view	->	assign('SESSIONDISCOUNT', $__LANG->get('session_discount'));
	$view	->	assign('SERVICEDISCOUNT', $__LANG->get('service_discount_in'));
	$view	->	assign('COLUMNCODE', $__LANG->get('columnname_code'));
	$view	->	assign('COLUMNNAME', $__LANG->get('columnname_name'));
	$view	->	assign('COLUMNQUANTITY', $__LANG->get('columnname_quantity'));
	$view	->	assign('COLUMNUNIT', $__LANG->get('columnname_unit'));
	$view	->	assign('COLUMNTAX', $__LANG->get('columnname_tax'));	
	$view	->	assign('COMMENT', $__LANG->get('comment'));
	$view	->	assign('ANNOTATION', $__LANG->get('annotation'));
	$view	->	assign('PAYMENT', $__LANG->get('payment_form'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('SEARCH', $__LANG->get('search'));
	$view	->	assign('SUMMARY', $__LANG->get('summary'));
	$view	->	assign('PRICETXT', $__LANG->get('price'));
	$view	->	assign('USED_SESSION_DISCOUNT', $__LANG->get('used_session_discount'));
	$view	->	assign('USED_SERVICE_DISCOUNT', $__LANG->get('used_service_discount'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);
	$view	->	assign('CANCEL', $__LANG->get('cancel'));

	# form data

	$view	->	assign('PAYMENT_FORMS', $PAYMENT_FORMS);
	
	unset($__SQL);

	$view	->	display();


?>
