<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag delivery single order item called from lists
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	check_year_for_write('deliverys');

	pagepermission('deliverys', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('singledelivery');

		$__DELIVERY	=	new SINGLEDELIVERY();

		$RESULT		=	$__DELIVERY->delivery($_POST);
	
		$DELIVERYID	=	$__DELIVERY->getid();

		unset($__DELIVERY, $__SQL);

		if (($RESULT != 'updated') && ($RESULT != 'writed'))	{

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_SESSION['FROM']);
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		header("location: loader.php?cat=delivery$RESULT&id=$DELIVERYID");

		exit;
	}

	# read orderID & lineID by datapersonID

	load_m('singledeliverydefaults');

	$__ORDERID	=	new SINGLEDELIVERYDEFAULTS();

	$DATA		=	$__ORDERID->readdefaults($_GET['id']);

	unset($__ORDERID);

	if (! $DATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', $_SESSION['FROM']);
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('cannotread'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('singleorderdelivery');

	$view	->	assign('SINGLE_DELIVERI_NO', $__LANG->get('singledelivery'));
	$view	->	assign('ORDER', $__LANG->get('ordernumber'));
	$view	->	assign('LINENUMBER', $__LANG->get('linenumber'));
	$view	->	assign('CODE', $__LANG->get('code'));
	$view	->	assign('NAME', $__LANG->get('articalname'));
	$view	->	assign('QUANTITY', $__LANG->get('quantity'));
	$view	->	assign('ADD_COMMENT', $__LANG->get('addcomment'));
	$view	->	assign('ADD_ANNOTATION', $__LANG->get('addannotation'));
	$view	->	assign('ADD_TO_DELIVERY', $__LANG->get('addtodelivery'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', $_SESSION['FROM']);

	# form data

	$view	->	assign('DATA', $DATA); unset($DATA, $__SQL);

	$view	->	display();

?>
