<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag working hours to employee
	 */

	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	 
	check_year_for_write('employees');

	pagepermission('employees', 'w');

	load_c('SQL');

	$__SQL	= new SQL();

	if (isset($_POST['submit']))	{

		load_m('workinghourswrite');

		$__HOURS	=	new WORKINGHOURSWRITE();

		$RESULT		=	$__HOURS->write($_POST);

		unset($__HOURS, $__SQL);

		if ($RESULT !== TRUE)	{

			$_POST['_err_address'] = backward();
		
			$_SESSION['_POST_ERR'] = $_POST;

			$view	=	new View('errorbox');
			$view	->	assign('SELF', $_POST['_err_address'].'&amp;p_err=1');
			$view	->	assign('ERROR', $__LANG->get('error'));
			$view	->	assign('ERRTXT', $__LANG->get($RESULT));
			$view	->	assign('BACK', $__LANG->get('back'));
			$view	->	display();
			exit;
		}

		$view	=	new View('alertbox');
		$view	->	assign('SELF', backward());
		$view	->	assign('MESSAGE', $__LANG->get('datawritten'));
		$view	->	assign('NEW', $__LANG->get('new'));
		$view	->	assign('CANCEL', $__LANG->get('cancel'));
		$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');
		$view	->	display();
		exit;
	}

	load_m('employeesread');

	$__EMPLOYEES	=	new EMPLOYEESREAD();

	$EMPLOYEESDATA	=	$__EMPLOYEES->read();

	unset($__EMPLOYES, $__SQL);

	if (! $EMPLOYEESDATA)	{

		$view	=	new View('errorbox');
		$view	->	assign('SELF', 'loader.php?cat=section&amp;id=employees');
		$view	->	assign('ERROR', $__LANG->get('error'));
		$view	->	assign('ERRTXT', $__LANG->get('noemployees'));
		$view	->	assign('BACK', $__LANG->get('back'));
		$view	->	display();
		exit;
	}

	$view	=	new View('employee_working_hours');

	$view	->	assign('SELF', backward());
	$view	->	assign('EMPLOYEE_WORKING_HOURS', $__LANG->get('employeeworkinghours'));
	$view	->	assign('EMPLOYEE_NAME', $__LANG->get('employeename'));
	$view	->	assign('DATE', $__LANG->get('date'));
	$view	->	assign('WORKING_HOURS', $__LANG->get('work_hours'));
	$view	->	assign('OVERTIME_WORKING_HOURS', $__LANG->get('overtime_work_hours'));
	$view	->	assign('NIGHT_WORK', $__LANG->get('night_work'));
	$view	->	assign('NIGHT_OVERTIME_WORK', $__LANG->get('night_overtime_work'));
	$view	->	assign('HOLIDAY_WORK', $__LANG->get('holiday_work'));
	$view	->	assign('HOLIDAY', $__LANG->get('holiday'));
	$view	->	assign('SICK_LEAVE', $__LANG->get('sick_leave'));
	$view	->	assign('SICK_LEAVE_100', $__LANG->get('sick_leave_100'));
	$view	->	assign('ANNUAL_LEAVE', $__LANG->get('annual_leave'));
	$view	->	assign('WRITE', $__LANG->get('write'));
	$view	->	assign('RESET', $__LANG->get('reset'));
	$view	->	assign('CANCEL', $__LANG->get('cancel'));
	$view	->	assign('BACKTO', 'loader.php?cat=section&amp;id=employees');

	# form data

	if (post_get_data_verified())	{

		$_POST = enc_quotes($_SESSION['_POST_ERR']);
		
		unset($_SESSION['_POST_ERR']);

	}	else	 {

		$_POST['date'] 			=	date($__CONF->get('date', 'dateformat'));
		$_POST['work_hours']		=	'8.00';
		$_POST['overtime_work_hours']	=	'0.00';
	}

	$view	->	assign('EMPLOYEES', $EMPLOYEESDATA); unset($EMPLOYEESDATA);

	$view	->	display();
?>
