	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */
	
	/**
	 * Request chat window data
	 */

	function xmlHttpGet()	{
	  
		// Do not read if the board is not displayed
		
		if (isChatDisplayed())	{
		  
			var xmlHttp = createXmlHttpRequestObject();

			xmlHttp.onreadystatechange=function()	{

				if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

					var data = xmlHttp.responseText;

					if (data) document.getElementById('chattable').innerHTML = data;

					scrolldown();
				}
			}

			xmlHttp.open('GET','../requests/getchat.php?auth=true&nc=' + (new Date().getTime()).toString(),true);

			xmlHttp.send();
		}
	}

	/**
	 * Post chat line
	 */

	function xmlHttpPost()	{

		var xmlHttp	=	createXmlHttpRequestObject();

		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				var data = xmlHttp.responseText;

				if (data) document.getElementById('chattable').innerHTML = data;

				scrolldown();
	    		}
	  	}

		var GET	= '../requests/postchat.php?user=' + encodeURIComponent(document.chatform.user.value) + '&msg=' + encodeURIComponent(document.chatform.textarea.value) + '&nc=' + (new Date().getTime()).toString();

		document.chatform.textarea.value='';
		
		xmlHttp.open('GET',GET ,true);

		xmlHttp.send();
	}

	/**
	 * Scrolls down the chat window
	 */

	function scrolldown()	{

		var div	= document.getElementById('chat-list');

		try {div.scrollTop = div.scrollHeight;} catch (e) {}
	}

	/**
	 * Reads chat continuosly
    	 */

	function chatread()	{

		xmlHttpGet();
		setTimeout("chatread();", 2000);
	}
	
	/**
	 * Checks chat is displayed or not
	 */
	
	function isChatDisplayed()	{
	  
		var Board = document.getElementById("chatboard");
	  
		if ((Board.style.display) && (Board.style.display != 'none')) return true;
		
		return false;
	}
	
	/**
	 * Shows or hides chat board
	 */

	function showHideChat()	{
	  
		var Board	= document.getElementById("chatboard");
		var Container	= document.getElementById("chatcontainer");
		var Arrow	= document.getElementById("chatarrow");
		
		if (isChatDisplayed())	{
		  
			Board.style.display	=	'none';
			Board.style.visibility	=	'hidden';
			
			Container.style.width	=	'';
			Container.style.height	=	'';
			
			Arrow.innerHTML		=	'&#187;';
			
		}	else	  {

			Board.style.display	=	'block';
			Board.style.visibility	=	'visible';	
			
			Container.style.width	=	'228px';
			Container.style.height	=	'312px';
			
			Arrow.innerHTML		=	'&#171;';
			
			xmlHttpGet();
			
			scrolldown();
		}
	}
	
	/**
	 * Displays chat window if the reminder refreshed the page
	 */
	
	function checkForRefresh()	{
	  
		if (document.cookie.indexOf('eBagChatWindow') != -1)	{
		  
			showHideChat();
		  
			document.cookie = 'eBagChatWindow=; expires=Thu, 01 Jan 1970 00:00:00 UTC';
		}
	}
	

