	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * send request for code, unit and quantity
	 */

	function typesearch(field, table)	{
	  
		var i;
	  
		var Fields	=	[];
	  
		var fieldnames 	= 	["code", "name", "unit", "quantity",  "newquantity"];

		var xmlHttp	=	createXmlHttpRequestObject();

		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				if (xmlHttp.responseText)	{
				  
					var xmldoc = xmlHttp.responseXML;
					
					for (i=1; i<4; i++) {
						
						xmltag = xmldoc.getElementsByTagName(fieldnames[i]);
						
						if ((Fields[i] != null) && (xmltag[0].childNodes[0] != null) && (typeof xmltag[0].childNodes[0] != 'undefined')) {

							 Fields[i].value = xmltag[0].childNodes[0].nodeValue;
						}
					}
					
					Fields[4].focus();

				}	else	   {
				  
					reset_form();
				}
	    		}
	  	}
	  	
		for (i=0; i<5; i++) {
		  
			Fields[i] = document.getElementById(fieldnames[i]);
		}
	
		var code = field.value;
		
		function reset_form()	{
		  
			for (i=0; i<5; i++) {
			  
				Fields[i].value = '';
			}
			
			field.focus();
		}

		if (! code)	{

			reset_form();
			
			return;
		}

		var link = '../requests/inventoryread.php?table=' + table + '&code=' + encodeURIComponent(code) + '&nc=' + (new Date().getTime()).toString();

		xmlHttp.open('GET', link, true);

		xmlHttp.send();
	}

	/**
	 * send request to write item into inventory table
	 */

	function additem (inv_table, table)	{
	  
		var i;
	  
		var Fields	=	[];
	  
		var fieldnames 	= 	["code", "name", "unit", "quantity", "newquantity"];

		var xmlHttp	=	createXmlHttpRequestObject();

		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				var response = xmlHttp.responseText;

				if (response)	{

					// note: response is one line of div					

					document.getElementById('inventorylist').innerHTML += response;
				}
				
				reset_form();
	    		}
	  	}
		
		for (i=0; i<5; i++) {
		  
			Fields[i] = document.getElementById(fieldnames[i]);
		}

		var code		=	Fields[0].value;
		var newquantity		=	Fields[4].value;
		
		function reset_form()	{
		  
			for (i=0; i<5; i++) {
			  
				Fields[i].value='';
			}
			
			Fields[0].focus();
		}

		if ((! code) || (! newquantity))	{

			reset_form();
			
			return;
		}
		
		postvalues = 'invtable=' + inv_table + '&table=' + table + '&quantity=' + newquantity + '&code=' + encodeURIComponent(code);

		xmlHttp.open('POST', '../requests/inventorywrite.php', true);

		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", postvalues.length);
		xmlHttp.setRequestHeader("Connection", "close");

		xmlHttp.send(postvalues);
	}

	function invmake()	{

		var msg	= document.forms[0].submitmsg.value;

		var response =	confirm(msg);

		if (response==true)	{

			document.forms[0].action.value = 'submit';

			document.forms[0].submit();
		}
	}

	function destroyinv()	{

		var msg	= document.forms[0].destroymsg.value;

		var response =	confirm(msg);

		if (response==true)	{

			document.forms[0].action.value = 'destroy';

			document.forms[0].submit();
		}
	}
