	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * Read data & fill bonuses form
	 */

	
	// Form fields handler
	
	var Field = function () {
	  
		var Names = [	"employee_id", "stock_type", "stock_id", "code", "item_name", "bonus_type", "bonus_value", "status_message", 
				"not_found_msg", "set_msg", "unset_msg", "invalid_bonus_msg", "type_mismatch_msg", "not_product_msg"];
		var i;
		
		for (i=0; i<14; i++) {
		  
			this[Names[i]] = document.getElementById(Names[i]);
		}
	};
	
	function reset_form(exept)	{
	  
		var count;
	  
		var inputs = document.forms[0].getElementsByTagName("input");
		
		count = inputs.length;

		for (i=0; i<count; i++) {
		  
			inputs[i].value = inputs[i].defaultValue;
		}
		
		var selects = document.forms[0].getElementsByTagName("select");
		
		count = selects.length;

		for (i=0; i<count; i++) {
		    
			if (selects[i].name == exept) continue;
		  
			selects[i].selectedIndex = 0;
		}
	}
	
	// Data read & form fill
	
	function bonus_data_read(call) {
	  
		var i, key, xmlData, getValue;
	  
		var Fields 	=	new Field();
	  
		var xmlHttp	=	createXmlHttpRequestObject();

		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				if (xmlHttp.responseText)	{

					if (xmlHttp.responseText == '1')	{
					  
						reset_form('stock_type');
						
						Fields.stock_type.focus();

						Fields.status_message.innerHTML = Fields.not_found_msg.value;
						
						setTimeout(function(){Fields.status_message.innerHTML = "&nbsp;";}, 600);
						
						return;
					}
					
					if ((xmlHttp.responseXML == null) || (typeof xmlHttp.responseXML == 'undefined')) return;
					
					var xmlDoc = xmlHttp.responseXML;
					
					var Requesteds = ["stock_id", "code", "item_name", "bonus_value"];
					
					for (i=0; i<4; i++) {
			
						  xmlData = xmlDoc.getElementsByTagName(Requesteds[i]);
						  
						  getValue = '';

						  if ((xmlData[0].childNodes[0] != null) && (typeof xmlData[0].childNodes[0] != 'undefined')) {

							    getValue = xmlData[0].childNodes[0].nodeValue;
						  }
						  
						  if (((call.name == 'stock_id') || (call.name == 'code')) && (call.name == Requesteds[i])) {continue;}
						  
						  Fields[Requesteds[i]].value = getValue;
					}
				}
	    		}
	  	}
		
		if ((! Fields.stock_id.value) && (! Fields.code.value)) return;

		var postvalues = '';
		
		var Names = ["employee_id", "bonus_type", "stock_type", "stock_id", "code"];

		for (i=0; i<5; i++) {

			FieldValue = Fields[Names[i]].value;
			
			if (FieldValue)	{

				if (postvalues) {postvalues += '&';}

				postvalues += Names[i] + '=' + encodeURIComponent(FieldValue);
			}
		}
		
		if (! postvalues) return;
		
		if ((call.name == 'stock_id') || (call.name == 'code')) postvalues += '&call=' + call.name;

		xmlHttp.open('POST', '../requests/bonusitemread.php', true);
		
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", postvalues.length);
		xmlHttp.setRequestHeader("Connection", "close");

		xmlHttp.send(postvalues);
	}

	// Data write
	
	function bonus_data_write()	{
	  
		var i, key, message;
		
		var Msg		=	["set_msg", "unset_msg", "not_found_msg", "invalid_bonus_msg", "type_mismatch_msg", "not_product_msg"];
	  
		var Fields 	=	new Field();
	  
		var xmlHttp	=	createXmlHttpRequestObject();
		
		xmlHttp.onreadystatechange=function()	{

			if (xmlHttp.readyState==4 && xmlHttp.status==200)	{

				if (xmlHttp.responseText)	{

					key = Number(xmlHttp.responseText) - 1;
					
					message = '';
					
					if (typeof Msg[key] != 'undefined')	{

						message = Fields[Msg[key]].value;
					}
					
					Fields.status_message.innerHTML = message;
					
					setTimeout(function(){Fields.status_message.innerHTML = "&nbsp;";}, 600);
				}
	    		}
	  	}
		
		if ((! Fields.stock_id.value) && (! Fields.code.value)) return;
		
		var postvalues = '';
		
		var Names = ["employee_id", "bonus_type", "bonus_value", "stock_type", "stock_id", "code"];

		for (i=0; i<6; i++) {

			FieldValue = Fields[Names[i]].value;
			
			if (FieldValue)	{

				if (postvalues) {postvalues += '&';}

				postvalues += Names[i] + '=' + encodeURIComponent(FieldValue);
			}
		}
		
		if (! postvalues) return;

		xmlHttp.open('POST', '../requests/bonusitemwrite.php', true);
		
		xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlHttp.setRequestHeader("Content-length", postvalues.length);
		xmlHttp.setRequestHeader("Connection", "close");

		xmlHttp.send(postvalues);
	}
	
	

	
