<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag artical delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ARTICALDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;
			
			$this->BASE		=	$_SESSION['BASE'];
			
			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR)	{

				$TO_LOCK	.=	",  ebagdata$YEAR.finished_goods_stock_enter WRITE, 
							    ebagdata$YEAR.production_orders_header WRITE, 
							    ebagdata$YEAR.production_orders_data WRITE, 
							    ebagdata$YEAR.orders_to_stock_data WRITE ";
			}

			$this->SQL->query("LOCK TABLES	ebag.years WRITE,
							$this->BASE.employees_items_bonuses WRITE,
							$this->BASE.employees_phases_bonuses WRITE,
							$this->STOCKBASE.finished_goods_stock WRITE".$TO_LOCK);
		}
		
		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL	');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row())	$this->OPENED[] = $RESULT[0];
		}

		public function delete($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			# check the feedstock is not deleted in meantime

			$this->SQL->query("	SELECT `code` 
						FROM $this->STOCKBASE.finished_goods_stock 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				
				return 'deletedinmeantime';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			$code =	$this->SQL->r_escape($RESULT['code']);

			# check the stock
			
			$this->SQL->query("	SELECT 	quantity+quantity_ordered+quantity_ordered_to_stock+quantity_on_opened_order_to_stock+quantity_in_production+quantity_as_part
							AS SUM
					  	FROM 	$this->STOCKBASE.finished_goods_stock WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

			$SUM	=	$this->SQL->RESULT->fetch_row();

			if ($SUM[0] > 0) $errtxt = 'ordered_or_entered_item'; 
			
			# check employees_bonuses
			
			if (! isset($errtxt))	{
			
				$this->SQL->query("	SELECT `personID`
							FROM $this->BASE.employees_items_bonuses
							WHERE `stock_type`='1' AND `stockID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
							
				if ($this->SQL->num_rows()) $errtxt = 'bonusdefined2item';
				
				$this->SQL->query("	SELECT `personID`
							FROM $this->BASE.employees_phases_bonuses
							WHERE `stockID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
							
				if ($this->SQL->num_rows()) $errtxt = 'bonusdefined2item';
			}

			# check enter to stock for open years

			if (! isset($errtxt))	{

				foreach ($this->OPENED as $YEAR)	{

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.finished_goods_stock_enter 
								WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt = "ordered_or_entered->year->$YEAR";

						break;
					}

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.production_orders_header
								WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt = "item_in_production->year->$YEAR";

						break;
					}

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.production_orders_data
								WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt = "item_used_as_part->year->$YEAR";

						break;
					}
					
					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.orders_to_stock_data
								WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt = "ordered_to_stock->personIDlong->$YEAR";

						break;
					}
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}

			$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock 
						SET `deleted`=NULL 
						WHERE `personID`='$ID' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}
	}

?>
