<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag stock write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('addtax');

	load_f('is_real_positive');
	
	load_f('is_real_tax');
	
	load_f('is_longer');

	class ARTICALUPDATE 	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function prepare($DATA)	 {

			# Check user input

			if ((is_empty($DATA['articalname'])) or 
			    (is_empty($DATA['code'])) or
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['unit'])) or
			    (is_empty($DATA['price'])) or
			    (is_empty($DATA['dimensions'])) or
			    (is_empty($DATA['tax']))) return FALSE;

			if ((! is_real_positive($DATA['price'])) or
			    (! is_real_tax($DATA['tax'])) or
			    ((! is_empty($DATA['purchase_price'])) && ((! is_numeric($DATA['purchase_price'])) or ($DATA['purchase_price'] < 0)))) return FALSE;
			    
			# Change empty purchase_price to zero
			
			if (is_empty($DATA['purchase_price'])) $DATA['purchase_price'] = 0;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;			
		}

		private function lock()	{

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR)	{

				$TO_LOCK	.=	", ebagdata$YEAR.finished_goods_stock_enter WRITE, 
							   ebagdata$YEAR.production_orders_header WRITE, 
							   ebagdata$YEAR.production_orders_data WRITE, 
							   ebagdata$YEAR.orders_to_stock_data WRITE ";
			}

			$this->SQL->query("	LOCK TABLES ebag.years WRITE, 
							    $this->BASE.addressbook WRITE, 
							    $this->BASE.employees_items_bonuses WRITE,
							    $this->BASE.employees_phases_bonuses WRITE,
							    $this->STOCKBASE.finished_goods_stock WRITE".$TO_LOCK);
		}
		
		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL	');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row())	$this->OPENED[] = $RESULT[0];
		}

		public function update($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			$this->lock();

			if (! count($this->OPENED)) return 'noopenyearsfound';

			extract($DATA); unset($DATA);

			# if is not product check supplier, origin1=>product

			if (str_replace("'", '', $origin) != 1)		{

				$this->SQL->query("	SELECT `city` 
							FROM $this->BASE.addressbook 
							WHERE `personID`=$supplierID AND `contactname`=$supplier AND `deleted` is NOT NULL LIMIT 1	");

				if (! $this->SQL->num_rows())	{

					$this->unlock();
					return 'suppliernotmatch';
				}
			}	 else		{

				# if is product set supplier to company production

				$supplierID	=	"'0'";
				$supplier	=	"'Production'";
			}

			# check the new artical code exists

			$this->SQL->query("	SELECT `articalname` 
						FROM $this->STOCKBASE.finished_goods_stock 
						WHERE `personID`!='$ID' AND `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();
				return 'articalexists';
			}

			# check the feedstock is not deleted in meantime

			$this->SQL->query("	SELECT `code` 
						FROM $this->STOCKBASE.finished_goods_stock 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return 'deletedinmeantime';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			# if the artical name and code is changed, see is possible to change or not

			if ($code != "'".$RESULT['code']."'")	{

				$OLDCODE	=	$this->SQL->r_escape($RESULT['code']);

				# check the stock
				
				$this->SQL->query("	SELECT 	quantity+quantity_ordered+quantity_ordered_to_stock+quantity_on_opened_order_to_stock+quantity_in_production+quantity_as_part
								AS SUM
						  	FROM 	$this->STOCKBASE.finished_goods_stock WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

				$SUM	=	$this->SQL->RESULT->fetch_row();

				if ($SUM[0] > 0) $errtxt = 'ordered_or_entered_item';
				
				# check employees_bonuses
				
				if (! isset($errtxt))	{
				
					$this->SQL->query("	SELECT `personID`
								FROM $this->BASE.employees_items_bonuses
								WHERE `stock_type`='1' AND `stockID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
								
					if ($this->SQL->num_rows()) $errtxt = 'bonusdefined2item';
				
					$this->SQL->query("	SELECT `personID`
								FROM $this->BASE.employees_phases_bonuses
								WHERE `stockID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
								
					if ($this->SQL->num_rows()) $errtxt = 'bonusdefined2item';
				}

				# check enter to stock for open years

				if (! isset($errtxt))	{

					foreach ($this->OPENED as $YEAR)	{

						$this->SQL->query("	SELECT `personID` 
									FROM ebagdata$YEAR.finished_goods_stock_enter 
									WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$errtxt = "ordered_or_entered->year->$YEAR";

							break;
						}

						$this->SQL->query("	SELECT `personID` 
									FROM ebagdata$YEAR.production_orders_header
									WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$errtxt = "item_in_production->year->$YEAR";

							break;
						}
						
						$this->SQL->query("	SELECT `personID` 
									FROM ebagdata$YEAR.production_orders_data
									WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$errtxt = "item_used_as_part->year->$YEAR";

							break;
						}

						$this->SQL->query("	SELECT `personID` 
									FROM ebagdata$YEAR.orders_to_stock_data
									WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

						if ($this->SQL->num_rows())	{

							$errtxt = "ordered_to_stock->personIDlong->$YEAR";

							break;
						}
					}
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}

			$price_with_tax =	addtax(str_replace("'", '', $price), str_replace("'", '', $tax));

			$COMMAND = "	UPDATE $this->STOCKBASE.finished_goods_stock SET	`code`=$code, `articalname`=$articalname, `dimensions`=$dimensions, 
												`unit`=$unit, `price`=$price, `tax`=$tax, `price_with_tax`='$price_with_tax', 
												`purchase_price`=$purchase_price, `origin`=$origin, `supplier`=$supplier, 
												`supplierID`=$supplierID, `comment`=$comment
					WHERE `personID`='$ID' LIMIT 1";

			$this->SQL->query($COMMAND);

			$this->unlock();

			return TRUE;
		}
	}

?>
