<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag change, delete, add or set to default delivery form	
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	load_f('is_longer');

	class DELIVERYFORMS	{

		function __construct()	{

			global $__SQL;

			$this->SQL	=	&$__SQL;

			$this->readyears();
		}

		private function lock()	 {

			$TOLOCK	= '';

			foreach ($this->YEARS as $YEAR)	$TOLOCK .= ", ebagdata$YEAR.offers_header WRITE, ebagdata$YEAR.orders_header WRITE ";

			$this->SQL->query('LOCK TABLES ebag.years WRITE, ebag.deliverys WRITE'.$TOLOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function readyears()	{

			$this->SQL->query("	SELECT `year` 
						FROM ebag.years 
						ORDER BY `year`	");
						
			$this->YEARS = array();

			while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[] = $RESULT[0];

		}

		private function is_in_use($deliveryID)	{

			$FOUND = FALSE;

			foreach ($this->YEARS as $YEAR)	{

				$this->SQL->query("	(
								SELECT `personID` 
								FROM ebagdata$YEAR.offers_header 
								WHERE `delivery_form`='$deliveryID' AND `deleted` IS NOT NULL LIMIT 1
							)
							UNION ALL
							(
								SELECT `personID` 
								FROM ebagdata$YEAR.orders_header 
								WHERE `delivery_form`='$deliveryID' AND `deleted` IS NOT NULL LIMIT 1
							)	");

				if ($this->SQL->num_rows())	{

					$FOUND = TRUE;

					break;
				}
			}

			return $FOUND;
		}

		public function defaultdelivery($deliveryID)	{

			$this->SQL->transaction();

			# note: no need to lock all tables

			$this->SQL->query('LOCK TABLES ebag.deliverys WRITE');

			$this->SQL->query("	UPDATE ebag.deliverys
						SET `default`=NULL
						WHERE `default` IS NOT NULL	");

			$this->SQL->query("	UPDATE ebag.deliverys
						SET `default`='1' 
						WHERE `personID`='$deliveryID'	LIMIT 1");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;		
		}

		public function change($deliveryID, $NAME)	{

			if (is_empty($NAME) or is_longer($NAME, 40)) return 'usererror';

			$this->lock();

			if ($this->is_in_use($deliveryID))	{

				$this->unlock();

				return 'cannotchangeuseddelivery';
			}
		
			$NAME = $this->SQL->n_escape($NAME);

			# check the new name not exists once

			$this->SQL->query("	SELECT `personID`
						FROM ebag.deliverys
						WHERE `type`=$NAME LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'deliveryformexists';
			}

			$this->SQL->query("	UPDATE ebag.deliverys
						SET `type`=$NAME
						WHERE `personID`='$deliveryID'	LIMIT 1");

			$this->unlock();
	
			return TRUE;
		}

		public function delete($deliveryID)	{

			$this->lock();

			if ($this->is_in_use($deliveryID))	{

				$this->unlock();

				return 'cannotdeleteuseddelivery';
			}

			# check that is not default

			$this->SQL->query("	SELECT `personID` 
						FROM ebag.deliverys
						WHERE `personID`='$deliveryID' AND `default` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'cannotdeletedefaultdelivery';
			}

			# check that is not the last

			$this->SQL->query("	SELECT `type`
						FROM ebag.deliverys	");

			if ($this->SQL->num_rows()==1)	{

				$this->unlock();

				return 'cannotdeletelastdelivery';
			}

			$this->SQL->query("	DELETE 
						FROM ebag.deliverys
						WHERE `personID`='$deliveryID' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}

		public function addnew($NAME)	{

			if (is_empty($NAME) or is_longer($NAME, 40)) return 'usererror';

			# note: no need to lock all tables

			$this->SQL->query('LOCK TABLES ebag.deliverys WRITE');

			$NAME	=	$this->SQL->n_escape($NAME);

			# check the new name not exists once

			$this->SQL->query("	SELECT `personID`
						FROM ebag.deliverys
						WHERE `type`=$NAME LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'deliveryformexists';
			}

			$this->SQL->query("	INSERT INTO ebag.deliverys
						VALUES
						(NULL, $NAME, NULL)	");

			$this->unlock();
	
			return TRUE;
		}
	}

?>
