<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag direct enter into stock artical, feedstock artical or operating_suplie
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_real_positive');

	load_f('is_int_positive');

	class DIRECTSTOCKENTER	{

		function __construct($STOCKTABLE)	{

			global $__SQL, $__UNIT, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->UNIT		=	new UNITloader($__CONF->get('cache', 'use_apc_cache'));

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->STOCKTABLE	=	$STOCKTABLE;

			$this->ENTERTABLE	=	$this->STOCKTABLE.'_enter';
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES $this->STOCKBASE.$this->STOCKTABLE WRITE, $this->BASE.$this->ENTERTABLE WRITE");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}


		public function enter($DATA)	{

			# check data

			if (is_empty($DATA['ID']))	return 'usererror';

			if ((is_empty($DATA['bill_number'])) && (is_empty($DATA['delivery_list_number']))) return 'usererror';

			if ($this->UNIT->is_int_unit($this->SQL->escape($DATA['unit'])))	{

				if (! is_int_positive($DATA['quantity'])) return 'usererror';

			}	else	 {

				if (! is_real_positive($DATA['quantity'])) return 'usererror';
			}

			# escape data

			foreach ($DATA as $key=>$val) 	{

				if ($key == 'quantity')	{

					$DATA[$key] = $this->SQL->escape($val);

				}	else	   {

					$DATA[$key] = $this->SQL->n_escape($val);
				}
			}

			extract($DATA); unset($DATA);

			# start transaction

			$this->SQL->transaction();

			$this->lock();

			# check the item exists yet

			$this->SQL->query("	SELECT `personID` 
						FROM $this->STOCKBASE.$this->STOCKTABLE 
						WHERE `personID`=$ID AND `code`=$code AND `deleted` IS NOT NULL LIMIT 1");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'deletedinmeantime';
			}

			$date		=	date("Y-m-d");
			$username	=	$this->SQL->escape($_SESSION['username']);

			# insert

			$this->SQL->query("	INSERT INTO $this->BASE.$this->ENTERTABLE 
						VALUES 
						(NULL, $delivery_list_number, $bill_number, NULL, $code, '$quantity', '$date', '$username', '0')");

			# update the stock item quantity

			$this->SQL->query("	UPDATE $this->STOCKBASE.$this->STOCKTABLE 
						SET quantity=quantity+$quantity 
						WHERE `personID`=$ID AND `deleted` IS NOT NULL LIMIT 1	");
			
			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}

?>
