<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag stock enter update (stock, feedstock, operating_suplies)
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('is_real_positive');

	load_f('is_int_positive');

	class STOCKENTERUPDATE	{

		function __construct($STOCKTABLE)	{

			global $__SQL, $__UNIT, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->UNIT		=	new UNITloader($__CONF->get('cache', 'use_apc_cache'));

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';

			$this->STOCKTABLE	=	$STOCKTABLE;

			$this->ENTERTABLE	=	$this->STOCKTABLE.'_enter';
			
			$this->newID		=	FALSE;
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->STOCKBASE.$this->STOCKTABLE WRITE, 
							$this->BASE.$this->ENTERTABLE WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}
		
		public function getnewID()	{
		
			return $this->newID;
		}

		public function update($ENTERID, $DATA)	{

			# check data

			if (is_empty($DATA['ID']))	return 'usererror';

			if ((is_empty($DATA['bill_number'])) && (is_empty($DATA['delivery_list_number']))) return 'usererror';

			if ($this->UNIT->is_int_unit($this->SQL->escape($DATA['unit'])))	{

				if (! is_int_positive($DATA['quantity'])) return 'usererror';

			}	else	 {

				if (! is_real_positive($DATA['quantity'])) return 'usererror';
			}

			# escape data

			$ENTERID	=	$this->SQL->escape($ENTERID);

			foreach ($DATA as $key=>$val) 	{

				if (($key == 'quantity') or ($key=='old_quantity'))	{

					$DATA[$key] = $this->SQL->escape($val);

				}	else	   {

					$DATA[$key] = $this->SQL->n_escape($val);
				}
			}

			extract($DATA);

			# note: the item will exists because is not possible to delete it if is entered into stock

			# case 1 : if the quantity was not changed

			if ($DATA['quantity'] == $DATA['old_quantity'])	{

				$this->SQL->query("	UPDATE $this->BASE.$this->ENTERTABLE
							SET `delivery_list_number`=$delivery_list_number, `bill_number`=$bill_number
				  			WHERE `personID`='$ENTERID' AND `deleted` IS NOT NULL LIMIT 1");
				return TRUE;
			}

			unset($DATA);

			# case 2: if the quantity was changed

			$this->SQL->transaction();

			$this->lock();

			# check the record exists

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.$this->ENTERTABLE 
						WHERE `personID`='$ENTERID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'deletedinmeantime';
			}

			# delete the old record

			$this->SQL->query("	UPDATE $this->BASE.$this->ENTERTABLE 
						SET `deleted`=NULL 
						WHERE `personID`='$ENTERID' LIMIT 1");

			# write new one

			$date		=	date("Y-m-d");

			$username	=	$this->SQL->escape($_SESSION['username']);

			$this->SQL->query("	INSERT INTO $this->BASE.$this->ENTERTABLE
						VALUES 
						(NULL, $delivery_list_number, $bill_number, NULL, $code, '$quantity', '$date', '$username', '0')"	);
						
			$this->newID = $this->SQL->lastid();

			# update quantity in stock

			$difference=(double)$quantity-(double)$old_quantity;

			$this->SQL->query("	UPDATE $this->STOCKBASE.$this->STOCKTABLE 
						SET quantity=quantity+$difference 
						WHERE `personID`=$ID LIMIT 1	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;

		}
	}

?>
