<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag ordered enter to stock
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ENTERBYORDER	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$this->SQL->query("	LOCK TABLES	$this->BASE.orders_to_stock_header WRITE, 
								$this->BASE.orders_to_stock_data WRITE,
								$this->STOCKBASE.finished_goods_stock WRITE, 
								$this->BASE.finished_goods_stock_enter WRITE, 
								$this->STOCKBASE.feedstock WRITE, 
								$this->BASE.feedstock_enter WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function write($DATA)	{

			if (! $order2stockID = $DATA['order2stockID']) return 'unexistentorder2stock';

			$order2stockID		=	$this->SQL->escape($order2stockID);

			if ((! $DATA['bill_number']) && (! $DATA['delivery_list_number'])) return 'usererror';

			$bill_number		=	$this->SQL->n_escape($DATA['bill_number']);

			$delivery_list_number	=	$this->SQL->n_escape($DATA['delivery_list_number']);

			unset($DATA);

			$now		=	date("Y-m-d");

			$username	=	$this->SQL->escape($_SESSION['username']);

			$this->SQL->transaction();
		
			$this->lock();

			# verify the order exists, is ordered (closed) and is not delivered yet

			$this->SQL->query("	SELECT `date_of_order`, `delivered`
						FROM $this->BASE.orders_to_stock_header
				  		WHERE  `personID`='$order2stockID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->SQL->rollback();

				$this->unlock();

				return 'unexistentorder2stock';
			}

			$RESULT	= $this->SQL->RESULT->fetch_assoc();

			if (! $RESULT['date_of_order'])	$errtxt = 'unclosedorder2stock';

			if ($RESULT['delivered']) $errtxt = 'deliveredonceorder2stock';

			if (isset($errtxt))	{

				$this->SQL->rollback();

				$this->unlock();

				return $errtxt;
			}

			# read items from order

			# note: type stores in which stock is (a=>finished_goods_stock, f=>feedstock)

			$STOCKS	=	array(	'a'	=>	'finished_goods_stock',
						'f'	=>	'feedstock'	);

			$this->SQL->query("	SELECT `code`, `quantity`, `type`
						FROM $this->BASE.orders_to_stock_data
			  			WHERE  `order2stockID`='$order2stockID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

			if ($this->SQL->num_rows())	{

				$this->SQL->IT1_RESULT = $this->SQL->RESULT;

				while ($IT1_RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

					$STOCK		=	$STOCKS[$IT1_RESULT['type']];

					$code		=	$this->SQL->nr_escape($IT1_RESULT['code']);

					$item_quantity	=	$IT1_RESULT['quantity'];

					# update the stock

					$this->SQL->query("	UPDATE $this->STOCKBASE.$STOCK
								SET	quantity_ordered_to_stock=quantity_ordered_to_stock-$item_quantity, 
									quantity=quantity+$item_quantity
								WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

					# update stock enter

					$STOCKENTER = $STOCK.'_enter';

					$this->SQL->query("	INSERT INTO $this->BASE.$STOCKENTER
								VALUES 
				  				(NULL, $delivery_list_number, $bill_number, '$order2stockID', $code, '$item_quantity', '$now', '$username', '0')	");
				}
			}

			unset($this->SQL->IT1_RESULT);

			# update order to stock items set to delivered

			$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_data
						SET	`date_of_delivery`='$now',
							`delivery_list_number`=$delivery_list_number,
							`bill_number`=$bill_number
						WHERE `order2stockID`='$order2stockID' AND `deleted` IS NOT NULL	");

			# update order to stock header to

			$this->SQL->query("	UPDATE $this->BASE.orders_to_stock_header
						SET `delivered`='1'
						WHERE `personID`='$order2stockID' AND `deleted` IS NOT NULL LIMIT 1	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}
	}
?>
