<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag feedstock delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class FEEDSTOCKDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	  {

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR) $TO_LOCK .= ", ebagdata$YEAR.feedstock_enter WRITE, ebagdata$YEAR.feedstock_requests WRITE";

			$this->SQL->query("LOCK TABLES ebag.years WRITE, ebagstock.feedstock WRITE".$TO_LOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL	');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row())	$this->OPENED[] = $RESULT[0];
		}

		public function delete($ID)	{

			$ID = $this->SQL->escape($ID);

			$this->lock();

			# check the feedstock is not deleted in meantime

			$this->SQL->query("	SELECT `code` 
						FROM $this->STOCKBASE.feedstock 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return 'deletedinmeantime';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			$code	=	$this->SQL->r_escape($RESULT['code']);

			# check the stock

			$this->SQL->query("	SELECT `quantity`, `quantity_ordered_to_stock`, `quantity_on_opened_order_to_stock`, `quantity_in_production`
						FROM $this->STOCKBASE.feedstock 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

			$RESULT	=	$this->SQL->RESULT->fetch_row();

			if (($RESULT[0] > 0) or ($RESULT[1] > 0) or ($RESULT[2] > 0) or ($RESULT[3] > 0)) $errtxt = 'ordered_or_entered_item';

			if (! isset($errtxt))	{

				foreach ($this->OPENED as $YEAR)	{

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.feedstock_enter 
								WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt	= "ordered_or_entered->year->$YEAR";

						break;
					}

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.feedstock_requests 
								WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt	= "feedstock_requested->year->$YEAR";

						break;
					}
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}

			$this->SQL->query("	UPDATE $this->STOCKBASE.feedstock 
						SET `deleted`=NULL 
						WHERE `personID`='$ID' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}
	}

?>
