<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag feedstock request for service lists details read 
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class FEEDSTOCKREQUEST2LISTREAD	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;
			
			$this->FORMAT		=	$__CONF->get('date', 'sql_format');
			
			$this->BASE		=	$_SESSION['BASE'];
		}

		private function lock()		{

			$this->SQL->query("LOCK TABLES	$this->BASE.feedstock_requests WRITE, 
							$this->BASE.services_data WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			$this->SQL->query("	SELECT 	DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation` 
							FROM $this->BASE.feedstock_requests
							WHERE `requestID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return FALSE;
			}
		
			$RESULT				=	$this->SQL->RESULT->fetch_assoc();
			$DATA['date_of_creation']	=	$RESULT['date_of_creation'];

			$this->SQL->query("	SELECT `reversID`, `servicedataID`, `code`, `feedstockname`, `unit`, `quantity`
						FROM $this->BASE.feedstock_requests
						WHERE `requestID`='$ID' AND `deleted` IS NOT NULL ORDER BY `personID`	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();
				return FALSE;
			}

			$this->SQL->IT1_RESULT	=	$this->SQL->RESULT;

			$INC	=	0;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	  {

				$DATA['reversID'][$INC]		=	$RESULT['reversID'];
				$DATA['code'][$INC]		=	$RESULT['code'];
				$DATA['feedstockname'][$INC]	=	$RESULT['feedstockname'];
				$DATA['unit'][$INC]		=	$RESULT['unit'];
				$DATA['quantity'][$INC]		=	$RESULT['quantity'];

				$servicedataID	= $RESULT['servicedataID'];

				$this->SQL->query("	SELECT `personID` 
							FROM $this->BASE.services_data 
							WHERE `reversID`='".$DATA['reversID'][$INC]."'");

				if ($this->SQL->num_rows())	{

					$i	=	1;

					while ($COUNTER	= $this->SQL->RESULT->fetch_row())	{

						if ($servicedataID == $COUNTER[0]) {break;} else {$i++;}
					}
				}

				$DATA['reversID_with_serviceID'][$INC]	=	$DATA['reversID'][$INC].'/'.$_SESSION['year'].'-->'.$i;

				$INC++;
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
