<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */
	 
	/**
	 * eBag script to migrate version 5.0.0 to 6.0.0
	 */

	 set_time_limit(0);
	 
	 error_reporting(E_ALL);

	 if (isset($_POST['proceed']))	{
	 
		include('../helpers/basichelpers.php');
		include('../classes/INIload.class.php');
		include('../classes/SQL.class.php');
		
		$__CONF = new INI_load('../conf/eBag.ini');
			  
		$__SQL =  new SQL();
		
		class INI_EXTEND	{

			var $DATA		=	FALSE;

			function __construct()	{
			
				$this->FILE = dirname(dirname(__FILE__)).DIRECTORY_SEPARATOR.'conf'.DIRECTORY_SEPARATOR.'eBag.ini';
			
				$this->DATA = @file($this->FILE);
			}

			public function add($section=FALSE, $key=FALSE, $val=FALSE)	{
			
				if (! $this->DATA) return;
			
				$EOL 	= PHP_EOL;

				$copy	= array();
				
				$sucess	= FALSE;
				
				$count	= count($this->DATA);

				$section = mb_eregi_replace('\s|\n', '', $section);

				for ($i=0; $i<$count; $i++)	{

					$copy[]	= $this->DATA[$i];

					$line	=  mb_eregi_replace('\s|\n', '', $this->DATA[$i]);

					if ($line == "[$section]")	{
						
						$copy[] = "{$EOL}$key\t=\t$val{$EOL}";

						$sucess	= TRUE;
					}
				}

				if (! $sucess)	{

					$copy[] = "{$EOL}[$section]{$EOL}";

					$copy[] = "{$EOL}$key\t=\t$val{$EOL}";
				}

				$this->DATA = $copy;
			}
			
			public function save()	{
			
				if (! $this->DATA) return;

				if ($fh = @fopen($this->FILE, 'w'))	{

					foreach ($this->DATA as $line)	{

						fwrite($fh, $line);
					}

					flock($fh, LOCK_UN);

					fclose ($fh);
					
					return TRUE;
				}
				
				return FALSE;
			}
		}
		
		class Migrate5to6	{
		
			function __construct()	{
			  
				global $__CONF, $__SQL;
			  
				$this->CONF = &$__CONF;
			  
				$this->SQL =  &$__SQL;
				
				$this->WARNING = '';
				  
				$this->yearsread();
			}
			  
			private function yearsread()	{

				$this->SQL->query("	SELECT `year`, `closed` 
							FROM ebag.years 
							ORDER BY `year`	");
							
				$this->YEARS = array();

				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[$RESULT[0]] = $RESULT[1];

			}
			  
			private function column_exists($table, $column)	{
			  
				$exists = false;
				
				$this->SQL->query("SHOW COLUMNS FROM $table");
				
				while ($RESULT = $this->SQL->RESULT->fetch_assoc()) {
				
					if ($column == $RESULT['Field'])	{
					
						$exists = TRUE;
						
						break;
					}
				}
				
				return $exists;
			}
			
			function copy_to_tmp($year)	{
			
				$this->SQL->query(" CREATE TEMPORARY TABLE IF NOT EXISTS ebagtemp.temptable (  	`salaryID` int NOT NULL,
														`employeeID` int NOT NULL,
														`bonus_percent_production` decimal(12,2),
														`bonus_fix_production` decimal(12,2),
														`bonus_percent_services` decimal(12,2),
														`bonus_fix_services` decimal(12,2),
														`bonus_percent_product_sell` decimal(12,2),
														`bonus_fix_product_sell` decimal(12,2),
														`bonus_percent_service_sell` decimal(12,2),
														`bonus_fix_service_sell` decimal(12,2),
														`services_with_bonus_to_finisher` text,
														`orders_with_bonus_to_finisher` text,
														`services_with_bonus_to_sell` text,
														`deliverys_with_bonus_to_sell` text
													     ) engine=innodb	"	);
				$this->SQL->query(" DELETE FROM ebagtemp.temptable ");

				# copied once
				
				if ($this->column_exists("ebagdata$year.salarys", 'bonus_config')) return; 
			
				$this->SQL->query(" INSERT INTO ebagtemp.temptable(  `salaryID`, `employeeID`, `bonus_percent_production`, `bonus_fix_production`, `bonus_percent_services`, `bonus_fix_services`,
										      `bonus_percent_product_sell`, `bonus_fix_product_sell`, `bonus_percent_service_sell`, `bonus_fix_service_sell`,
										      `services_with_bonus_to_finisher`, `orders_with_bonus_to_finisher`, `services_with_bonus_to_sell`, `deliverys_with_bonus_to_sell`)
			
						    SELECT  `personID`, `employeeID`, `bonus_percent_production`, `bonus_fix_production`, `bonus_percent_services`, `bonus_fix_services`,
							    `bonus_percent_product_sell`, `bonus_fix_product_sell`, `bonus_percent_service_sell`, `bonus_fix_service_sell`,
							    `services_with_bonus_to_finisher`, `orders_with_bonus_to_finisher`, `services_with_bonus_to_sell`, `deliverys_with_bonus_to_sell`
						    FROM 	ebagdata$year.salarys	");
			}
			
			function restore_from_tmp($year)	{
			
				# restore bonuses
			
				$this->SQL->query(" SELECT `salaryID`, `bonus_percent_production`, `bonus_fix_production`, `bonus_percent_services`, `bonus_fix_services`,
							   `bonus_percent_product_sell`, `bonus_fix_product_sell`, `bonus_percent_service_sell`, `bonus_fix_service_sell`
						    FROM ebagtemp.temptable ");
						    
				if ($this->SQL->num_rows())	{
				
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;
				
					while ($result = $this->SQL->IT1_RESULT->fetch_assoc())	{
					
						$personID = $result['salaryID'];
					
						$bonus_settings = array();
						
						$global_type = 0;

						foreach (array('production', 'services', 'product_sell', 'service_sell') as $type)	{
						
							$bonus_settings["bonus_to_$type"] = 0;
						
							foreach (array(1=>'fix',2=>'percent') as $subval=>$sub)	{
							
								$key = 'bonus_'.$sub.'_'.$type;
								
								$bonus_settings[$key] = $result[$key];
									
								if ($bonus_settings[$key] > 0) $bonus_settings["bonus_to_$type"] = $subval;
							}
						}
						
						$bonus_config = $this->SQL->mysqli->real_escape_string(serialize($bonus_settings)); 
						
						unset($bonus_settings);
						
						$this->SQL->query("	UPDATE ebagdata$year.salarys
									SET `bonus_config`='$bonus_config'
									WHERE `personID`='$personID' LIMIT 1	");
					}
				}
				
				# restore linked production orders/orders/services numbers
				
				$this->SQL->query(" SELECT `salaryID`, `employeeID`, `services_with_bonus_to_finisher`, 
							   `orders_with_bonus_to_finisher`, `services_with_bonus_to_sell`, 
							   `deliverys_with_bonus_to_sell`
						    FROM ebagtemp.temptable ");
						    
				if ($this->SQL->num_rows())	{
				
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;
				
					while ($result = $this->SQL->IT1_RESULT->fetch_assoc())	{
					
						$bonus_to_production = $bonus_to_services =  $bonus_to_product_sell = $bonus_to_service_sell = FALSE;
					
						foreach ( array(	'services'=>'services_with_bonus_to_finisher', 
									'service_sell'=>'services_with_bonus_to_sell', 
									'product_sell'=>'deliverys_with_bonus_to_sell') as $key=>$val) 	{
						  
							if ($result[$val])	{
							
								$tmp = array();
						
								foreach (explode('-', $result[$val]) as $single)	{
								  
									 if (! $single) continue;
									 
									 $tmp[]= $year.'_'.$single;
								}
								
								if (count($tmp)) { ${"bonus_to_$key"} = "'".$this->SQL->mysqli->real_escape_string('-'.implode('-', array_unique($tmp)).'-')."'"; }
							}
							      
							if (! ${"bonus_to_$key"}) ${"bonus_to_$key"} = 'NULL';
						}
						
						if ($result['orders_with_bonus_to_finisher'])	{
						
							$tmp = array();
						
							foreach (explode('-', $result['orders_with_bonus_to_finisher']) as $rowID)	{
							
								if (! $rowID) continue;
							
								$this->SQL->query("	SELECT `productionorderID`
											FROM ebagdata$year.orders_data
											WHERE `personID`='$rowID' LIMIT 1 ");
											
								if ($this->SQL->num_rows())	{
								
									list($prodID) = $this->SQL->RESULT->fetch_row();

									if ($prodID) $tmp[] = $year.'_'.$prodID;
								}
							}
							
							if (count($tmp)) { $bonus_to_production = "'".$this->SQL->mysqli->real_escape_string('-'.implode('-', array_unique($tmp)).'-')."'"; }
						}
						
						if (! $bonus_to_production) $bonus_to_production = 'NULL';
						
						$this->SQL->query("	INSERT INTO ebagdata$year.salary_bonuses
									VALUES
									( '{$result['salaryID']}', '{$result['employeeID']}', $bonus_to_production, $bonus_to_services,
									    $bonus_to_product_sell, $bonus_to_service_sell, '0')	");

					}
				}
			}
			
			function rewrite_credits_column($year)	{
			
				$this->SQL->query(" SELECT `personID`, `credits` FROM ebagdata$year.salarys ");
				
				if ($this->SQL->num_rows())	{
				
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;
				
					while (list($personID, $credits) = $this->SQL->IT1_RESULT->fetch_row())	{
					
						if ($credits)	{
						
							$rewrited = array();
						  
							$credits = unserialize($credits);
							  
							if ((! isset($credits['additional_name'])) or (! count($credits['additional_name']))) continue;
								
							$rewrited['credit_name'] = $credits['additional_name']; 
							$rewrited['credit_value'] = $credits['additional_value'];
							
							$credits = $this->SQL->mysqli->real_escape_string(serialize(array('credit_name'=>$rewrited['credit_name'], 'credit_value'=>$rewrited['credit_value'])));
							
							$this->SQL->query("	UPDATE ebagdata$year.salarys
										SET `credits`='$credits'
										WHERE `personID`='$personID' LIMIT 1	");
						}
					}
				}
			}
			
			function copy_credits($year)	{
			
				# table exists ?
				
				$this->SQL->query(" SHOW TABLES FROM ebagdata$year LIKE 'salarys_personal_credits' ");
				
				if (! $this->SQL->num_rows()) return;
				
				# copy
			
				$this->SQL->query(" SELECT * FROM ebagdata$year.salarys_personal_credits ");
				
				if ($this->SQL->num_rows())	{
				
					$this->SQL->IT1_RESULT = $this->SQL->RESULT;
				
					while (list($employeeID, $credits) = $this->SQL->IT1_RESULT->fetch_row())	{
					
						$credits = unserialize($credits);
						  
						$this->SQL->query(" SELECT `value` 
								    FROM ebagdata$year.salarys_personal_data
								    WHERE `employeeID`='$employeeID' LIMIT 1 ");
								      
						if (! $this->SQL->num_rows()) continue;
						
						list($data) = $this->SQL->RESULT->fetch_row();
						
						$data = unserialize($data);
						
						$data['credit_name']  = $credits['additional_name'];
						$data['credit_value'] = $credits['additional_value'];
						
						unset($credits);
	
						$data = $this->SQL->mysqli->real_escape_string(serialize($data));
						
						$this->SQL->query(" UPDATE ebagdata$year.salarys_personal_data
								    SET `value`='$data'
								    WHERE `employeeID`='$employeeID' LIMIT 1 ");
					}
				}
			}
			
			function add_bonus_to_personal_data($year)	{
			
				$this->SQL->query(" SELECT * FROM ebagdata$year.salarys_personal_data ");
				
				if (! $this->SQL->num_rows()) return;
				
				$this->SQL->IT1_RESULT = $this->SQL->RESULT;
				
				while (list($employeeID, $data) = $this->SQL->IT1_RESULT->fetch_row())	{
					
					$data = unserialize($data);
					
					foreach (array('production', 'services', 'product_sell', 'service_sell') as $type)	{
					
						$data["bonus_to_$type"] = 0;
					
						foreach (array(1=>'fix',2=>'percent') as $subval=>$sub)	{
								
							if ($data['bonus_'.$sub.'_'.$type] > 0) $data["bonus_to_$type"] = $subval;
						}
					}
					
					$data = $this->SQL->mysqli->real_escape_string(serialize($data));
						
					$this->SQL->query(" UPDATE ebagdata$year.salarys_personal_data
							    SET `value`='$data'
							    WHERE `employeeID`='$employeeID' LIMIT 1 ");
				}
			}
			
			function convert_fields_precisions()	{
	
				# new corrected definitions
			
				$tables = array();
				
				$tables['uploads'] = array('filesize' => '`filesize` bigint NOT NULL' );

				$tables['finished_goods_stock'] = array('quantity'				=>	'`quantity` decimal(14,2) NOT NULL',
									'quantity_ordered'			=>	'`quantity_ordered` decimal(14,2)',
									'quantity_ordered_to_stock'		=>	'`quantity_ordered_to_stock` decimal(14,2)',
									'quantity_on_opened_order_to_stock'	=>	'`quantity_on_opened_order_to_stock` decimal(14,2)',
									'quantity_in_production'		=>	'`quantity_in_production` decimal(14,2)',
									'quantity_as_part'			=>	'`quantity_as_part` decimal(14,2)',
									'price'					=>	'`price` decimal(12,2) NOT NULL',
									'price_with_tax'			=>	'`price_with_tax` decimal(12,2) NOT NULL',
									'purchase_price' 			=>	'`purchase_price` decimal(12,2)' );

				$tables['feedstock'] = array(		'quantity'				=>	'`quantity` decimal(14,2) NOT NULL',
									'quantity_ordered_to_stock'		=>	'`quantity_ordered_to_stock` decimal(14,2)',
									'quantity_in_production'		=>	'`quantity_in_production` decimal(14,2)',
									'quantity_on_opened_order_to_stock'	=>	'`quantity_on_opened_order_to_stock` decimal(14,2)',
									'purchase_price'			=>	'`purchase_price` decimal(12,2)',
									'calculation_price'			=>	'`calculation_price` decimal(12,2)' );

				$tables['operating_suplies'] = array(	'quantity' 				=>	'`quantity` decimal(14,2) NOT NULL',
									'quantity_in_production'		=>	'`quantity_in_production` decimal(14,2)',
									'purchase_price'			=>	'`purchase_price` decimal(12,2) NOT NULL' );
									
				$tables['services'] = array(		'price'					=>	'`price` decimal(12,2) NOT NULL',
									'price_with_tax'			=>	'`price_with_tax` decimal(12,2) NOT NULL' );

				$tables['feedstock_requests_list'] = array('quantity' 				=> 	'`quantity` decimal(11,2) NOT NULL' );

				$tables['inventory_data'] = array(	'quantity_before'			=>	'`quantity_before` decimal(14,2) NOT NULL',
									'quantity_after'			=>	'`quantity_after` decimal(14,2) NOT NULL' );
									
				$tables['services_data']= array(	'quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'price'					=>	'`price` decimal(12,2) NOT NULL' );

				$tables['offers_data'] = array(		'quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'price' 				=>	'`price` decimal(12,2) NOT NULL' );
									
				$tables['orders_data'] = array(		'quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'price'					=>	'`price` decimal(12,2) NOT NULL' );

				$tables['production_orders_header'] = array(	
									'quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'defective_quantity'			=>	'`defective_quantity` decimal(11,2) NOT NULL' );
										
				$tables['production_orders_data'] = array('quantity'				=> 	'`quantity` decimal(11,2) NOT NULL');

				$tables['orders_to_stock_data'] = array('quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'price'					=>	'`price` decimal(12,2) NOT NULL' );

				$tables['deliverys_data'] = array(	'quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'price' 				=>	'`price` decimal(14,2) NOT NULL' );
										
				$tables['bills_data'] = array(		'quantity'				=>	'`quantity` decimal(11,2) NOT NULL',
									'price'					=>	'`price` decimal(14,2) NOT NULL' );

				$tables['claims'] = array(		'personID' 				=>	'`personID` bigint NOT NULL AUTO_INCREMENT',
									'sum' 					=>	'`sum` decimal(14,2) NOT NULL' );

				$tables['customers_payments'] = array(	'personID'				=>	'`personID` bigint NOT NULL AUTO_INCREMENT',
									'sum'					=>	'`sum` decimal(14,2) NOT NULL' );
										
				$tables['feedstock_requests'] = array(	'quantity'				=>	'`quantity` decimal(11,2) NOT NULL' );

				$tables['suplie_request_data'] = array(	'quantity'				=>	'`quantity` decimal(11,2) NOT NULL' );
					
				$tables['salarys'] = array( 		'personID'				=>	'`personID` bigint NOT NULL AUTO_INCREMENT',
									'Salary_BASE'				=>	'`Salary_BASE` decimal(12,2) NOT NULL',
									'E_payment'				=>	'`E_payment` decimal(12,2) NOT NULL' );

				$tables['finished_goods_stock_enter'] = $tables['feedstock_enter'] = $tables['operating_suplies_enter'] = array( 'quantity' => '`quantity` decimal(11,2) NOT NULL');
			
				$BASES = array('ebag', 'ebagstock', 'ebagtemp');

				foreach ($this->YEARS as $year=>$closed) $BASES[] = "ebagdata$year";

				foreach ($BASES as $base)	{
				
					$this->SQL->query(" SHOW TABLES FROM `$base` ");

					if (! $this->SQL->num_rows()) continue;
					
					$existing_tables = array();

					while ($result = $this->SQL->RESULT->fetch_row()) $existing_tables[]=$result[0];

					foreach($existing_tables as $table)	{
					
						if (isset($tables[$table]))	{
						
							foreach($tables[$table] as $column=>$modify_def)	{
							  
								if ($this->column_exists("$base.$table", $column))	{
								  
									 $this->SQL->query(" ALTER TABLE $base.$table MODIFY $modify_def ");
								}
							}
						}
					}
				}
				
				# Note: temporary inventory tables if exists will be closed as before
				#	and new will be created with new definition
			}
			
			function extend_bank_columns()	{

				# modify companydata
				
				$this->SQL->query(" ALTER TABLE ebag.companydata MODIFY `bank1` varchar(40) ");
				
				$this->SQL->query(" ALTER TABLE ebag.companydata MODIFY `bank2` varchar(40) ");
				
				# modify addressbook, headers & payments

				foreach ($this->YEARS as $year=>$closed)	{
			    
					foreach (array('addressbook', 'services_header', 'offers_header', 'orders_header', 'orders_to_stock_header', 'deliverys_header', 'bills_header', 'customers_payments') as $table)	{
					
						$base_table = "ebagdata$year.$table";
						
						foreach (array('bank', 'bank1', 'bank2') as $column)	{
				      
							if ($this->column_exists($base_table, $column))	{
							
								$this->SQL->query(" ALTER TABLE $base_table MODIFY `$column` varchar(40) ");
							}
						}
					}
				}
			}
			
			function configuration_update()	{
			
				if ($this->CONF->get('version', 'version_number')) return;

				$ini = new INI_EXTEND();
				
				$ini->add('version', 'version_number', '6.0.0');
				$ini->add('download', 'speed_kbs', 192);
				$ini->add('backup', 'daily_backup', 1);
				$ini->add('language', 'direction', 'ltr');
				$ini->add('font', 'directory', 'DejaVu');
				$ini->add('font', 'family', 'DejaVu');
				$ini->add('font', 'normal_font_file', 'DejaVuSansCondensed.ttf');
				$ini->add('font', 'bold_font_file', 'DejaVuSansCondensed-Bold.ttf');
				$ini->add('font', 'bar_code_font', 'DejaVuSansMono-Bold.ttf');
$append = <<<"EOT"

[version]

version_number	=	6.0.0

[download]

speed_kbs	=	192

[font]

directory			=	DejaVu

family				=	DejaVu
normal_font_file		=	DejaVuSansCondensed.ttf
bold_font_file			=	DejaVuSansCondensed-Bold.ttf
bar_code_font			=	DejaVuSansMono-Bold.ttf

EOT;
				if (! $ini->save()) $this->WARNING = '<br><br>Updating configuration file failed. Please add to sections <pre>[language] direction = ltr</pre> <pre>[backup] daily_backup =1 </pre>manually'
								    .' and copy and paste text below into eBag/conf/eBag.ini to use the application.'."\r\n<pre>$append</pre>";
			}
			
			function proceed()	{
			
				foreach ($this->YEARS as $year=>$closed)	{
				
					# add annotation columns to service orders
					
					$table = "ebagdata$year.services_header";
					
					if (! $this->column_exists($table, 'annotation'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `annotation` text AFTER `comment` ");
					}
				
					# add columns comment and annotation 
					# to bills_header table
				
					$table = "ebagdata$year.bills_header";
				
					if (! $this->column_exists($table, 'comment'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `comment` text AFTER `payment_deadline` ");
					}
					
					if ($this->column_exists($table, 'comment') && (! $this->column_exists($table, 'annotation')))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `annotation` text AFTER `comment` ");
					}
					
					# add account column to customers_payments
					
					$table = "ebagdata$year.customers_payments";
					
					if (! $this->column_exists($table, 'account'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `account` varchar(40) AFTER `bank` ");
					}
					
					# create employees_items_bonuses table
			
					$table 	= "ebagdata$year.employees_items_bonuses";
					
					$this->SQL->query(" CREATE TABLE IF NOT EXISTS	$table (  `personID` bigint NOT NULL AUTO_INCREMENT,
												   PRIMARY KEY(`personID`),
												  `employeeID` int NOT NULL,
												  `stock_type` int NOT NULL,
												  `stockID` int NOT NULL,
												  `code` varchar(25) NOT NULL,
												  `percent_production` decimal(12,2),
												  `fix_production` decimal(12,2),
												  `percent_services` decimal(12,2),
												  `fix_services` decimal(12,2),
												  `percent_product_sell` decimal(12,2),
												  `fix_product_sell` decimal(12,2),
												  `percent_service_sell` decimal(12,2),
												  `fix_service_sell` decimal(12,2),
												  `userID` int NOT NULL,
												  `deleted` boolean,
												  INDEX(`employeeID`, `stock_type`, `stockID`)
												) engine=innodb	 ");
					# create employees_phases_bonuses table
					
					$table 	= "ebagdata$year.employees_phases_bonuses";
					
					$this->SQL->query(" CREATE TABLE IF NOT EXISTS	$table (  `personID` bigint NOT NULL AUTO_INCREMENT,
												   PRIMARY KEY(`personID`),
												  `employeeID` int NOT NULL,
												  `setting_type`int NOT NULL,
												  `stockID` int,
												  `code` varchar(25),
												  `phaseID` int NOT NULL,
												  `production_phase` varchar(40) NOT NULL,
												  `percent_phases` decimal(12,2),
												  `fix_phases` decimal(12,2),
												  `userID` int NOT NULL,
												  `deleted` boolean,
												  INDEX(`employeeID`, `setting_type`, `phaseID`)
												) engine=innodb	");

					# create salary_bonuses table
					
					$table 	= "ebagdata$year.salary_bonuses";
					
					$this->SQL->query(" CREATE TABLE IF NOT EXISTS	$table (  `salaryID` bigint NOT NULL,
												  `employeeID` int NOT NULL,
												  `bonus_to_production` text,
												  `bonus_to_services` text,
												  `bonus_to_product_sell` text,
												  `bonus_to_service_sell` text,
												  `deleted` boolean,
												  INDEX(`employeeID`, `salaryID`)
												) engine=innodb	");
					
					# rewrite to new serialized var column credits in salary
					
					$this->rewrite_credits_column($year);
					
					# copy columns data into temporary table before deleting them
					
					$this->copy_to_tmp($year);
					
					# create new salary table structure
					
					$table 	= "ebagdata$year.salarys";
					
					# add column month_part & fill with zeros
					
					if (! $this->column_exists($table, 'month_part'))	{
					
						$this->SQL->query("	ALTER TABLE $table
									ADD `month_part`  int NOT NULL AFTER `month` ");
									
						$this->SQL->query("	UPDATE $table
									SET `month_part`='0' 
									WHERE `personID`!=0 ");
					}
					
					foreach ( array(  'bonus_percent_production', 'bonus_fix_production', 'bonus_percent_services', 
							  'bonus_fix_services', 'bonus_percent_product_sell', 'bonus_fix_product_sell', 
							  'bonus_percent_service_sell', 'bonus_fix_service_sell', 'services_with_bonus_to_finisher', 
							  'orders_with_bonus_to_finisher', 'services_with_bonus_to_sell', 'deliverys_with_bonus_to_sell') as $column)	{
					
						if ($this->column_exists($table, $column)) $this->SQL->query("	ALTER TABLE $table DROP `$column` ");
					}
					
					if (! $this->column_exists($table, 'bonus_config'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `bonus_config` text AFTER `working_hour_value` ");
					}
					
					if (! $this->column_exists($table, 'comment'))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `comment` text AFTER `E_payment` ");
					}
					
					if ($this->column_exists($table, 'comment') && (! $this->column_exists($table, 'annotation')))	{
				
						$this->SQL->query("	ALTER TABLE $table 
									ADD `annotation` text AFTER `comment` ");
					}
					
					# copy backuped data in new form into salary_bonuses table & into bonus_config column in salary table

					$this->restore_from_tmp($year);
					
					# copy data from salarys_personal_credits to salarys_personal_data & drop the table
					
					$this->copy_credits($year);
					
					$this->SQL->query(" DROP TABLE IF EXISTS ebagdata$year.salarys_personal_credits ");
					
					# update salary personal data add bonus_to_ (bonus type, select state) 0 values 
					
					$this->add_bonus_to_personal_data($year);
				}
				
				$this->SQL->query(" DROP TEMPORARY TABLE IF EXISTS ebagtemp.temptable ");
				
				# convert ebagtemp.loggeds user column to integer
				
				$this->SQL->query(" ALTER TABLE ebagtemp.loggeds MODIFY `user` int NOT NULL ");
				
				# extend ebag.users username column to varchar(30)
				
				$this->SQL->query(" ALTER TABLE ebag.users MODIFY `username` varchar(30) NOT NULL ");
				
				# convert decimals to (11,2) & (14,2) & some int to bigint
				
				$this->convert_fields_precisions();
				
				# extend bank columns to char(40)
				
				$this->extend_bank_columns();
				
				# append eBag.ini
			
				$this->configuration_update();
			}
		}
		
		$migrate = new Migrate5to6();
		$migrate -> proceed();
		
		$MESSAGE = 'Migration completed. Please restart the server before the first log in !'.$migrate->WARNING;
		
	}	else	{
	
		$MESSAGE = '<form action="'.$_SERVER['PHP_SELF'].'" name="migration" method="post" target="_self">eBag migration script from 5.0.0 to 6.0.0<br><br>Please backup your data before running this script!<br><br><input value="Proceed" type="submit" name="proceed"></form>';
	}
	 
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head> 
		<meta HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
 		<meta name="robots" content="noindex,nofollow" />
		<title>eBag</title>
	</head>

	<body bgcolor="#FFFFFF">

			<table width=100% height="200" cellpadding="0" cellspacing="0">
				<tr><td align="center" valign="center">
					<font face="verdana, arial, helvetica" size="2"> <?php echo $MESSAGE; ?></font>
				</td></tr>
			</table>
	</body>
</html>