<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag new salary 
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	} 
	
	/**
	 *	BONUSES CALCULATION
	 */

	class BONUSES	{
	
		function __construct()	{
		 
			global $__SQL;
		
			$this->SQL		=	&$__SQL;
			
			$this->YEAR		=	$_SESSION['year'];
			
			$this->BASE		=	$_SESSION['BASE'];
			
			$this->MONTH 		= 	FALSE;

			$this->DAY 		= 	FALSE;
			
			$this->YEARS 		=	array();
			
			$this->BONUS_SETTINGS 	= 	FALSE;
			
			$this->TYPES		=	array('production', 'services', 'product_sell', 'service_sell');
			
			foreach ($this->TYPES as $type)	{
			
				$this->{"bonus_to_{$type}_linked"} = array();
				
				$this->BONUSES_SUM["E_bonus_{$type}"] = 0;
			}
		}

		function read_settings()	{

			foreach ($this->TYPES as $type)	{
			
				foreach (array('percent', 'fix', 'to') as $sub)	{
				
					$key = 'bonus_'.$sub.'_'.$type;
				
					if ($this->SETTINGS[$key]) {$this->BONUS_SETTINGS[$key] = $this->SETTINGS[$key];} else {$this->BONUS_SETTINGS[$key] = 0;}
				}
			}
			
			unset($this->SETTINGS);
		}
		
		function calculate($employeeID)	{
		
			$this->employeeID = $employeeID;
		
			$this->read_settings();
			
			$this->date_period();
			
			foreach ($this->YEARS as $year) $this->calculate_by_year($year);
			
			$this->write_link_columns();
			
			return array($this->SQL->mysqli->real_escape_string(serialize($this->BONUS_SETTINGS)), $this->BONUSES_STR, $this->BONUSES_SUM);
		}
		
		# Note : the bonus will be calculated according 
		#	 to current year bonus settings for all years 
		
		# stock_type 1=finished_goods_stock; 2=services
	
		function form_bonus_by_code($data, $stock_type, $bonus_type, $exchange_rate=1)	{
		
			list($code, $price, $quantity) = $data;
			
			$price = $price * $exchange_rate;
		
			$code = $this->SQL->r_escape($code);
			
			$this->SQL->query("	SELECT 	`percent_$bonus_type`, `fix_$bonus_type`
						FROM 	$this->BASE.employees_items_bonuses
						WHERE  	`employeeID`='$this->employeeID'
						  AND 	`stock_type`='$stock_type'
						  AND	`code`='$code'
						  AND 	`deleted` IS NOT NULL
						LIMIT 1		" );
						
			if (! $this->SQL->num_rows()) return 0;
			
			extract($this->SQL->RESULT->fetch_assoc());
			
			$percent = ${'percent_'.$bonus_type};
			
			$fix 	 = ${'fix_'.$bonus_type};
			
			$value = 0;
			
			if ($percent) $value = $quantity * ($price*$percent/100);
			
			if ($fix) $value = $quantity*$fix;
			
			return $value;
		} 
		
		private function form_phase_bonus_by_code($data, $productionID, $year, $exchange_rate=1)	{
	      
			list($code, $price, $quantity) = $data;
			
			$price = $price * $exchange_rate;
			
			$code = $this->SQL->r_escape($code);
						
			$this->SQL->query("	SELECT `production_phase`
						FROM ebagdata$year.production_orders_phases
						WHERE `finisher`='employee_$this->employeeID'
						AND `productionorderID`= '$productionID'	");
			$sum = 0;
						
			if ($this->SQL->num_rows())	{

				$phaseIDs = array();
				
				while($result = $this->SQL->RESULT->fetch_row()) $phaseIDs[] = $result[0];
				
				foreach($phaseIDs as $phaseID)	{
				
					# setting_type 1=all products, 2=specific product
				
					$this->SQL->query("	SELECT `percent_phases`, `fix_phases` 
								FROM $this->BASE.employees_phases_bonuses
								WHERE `employeeID`='$this->employeeID' AND `phaseID`='$phaseID'
								AND ((`setting_type`='1') OR (`setting_type`='2' AND `code`='$code')) LIMIT 1	");
								
					if (! $this->SQL->num_rows()) continue;
					
					extract($this->SQL->RESULT->fetch_assoc());
					
					if ($percent_phases)	{
					
						$sum += $quantity * ($price*$percent_phases/100);
					}
					
					if ($fix_phases)	{
					
						$sum += $quantity*$fix;
					}
				}
			}
			
			return $sum;
		}
		
		function link_id($type, $id) {
		
			$this->{"bonus_to_{$type}_linked"}[] = $id;
		}
		
		function E($type, $value) {
		
			$this->BONUSES_SUM["E_bonus_{$type}"] += $value;
		}
		
		function calculated_once($id, $type)	{
		
			$found = FALSE;
			
			# Note: if the seller is changed, do not calculate everything again to second seller
			
			if (($type == 'service_sell') or ($type == 'product_sell')) {$EMPLOYEE = ' ';} else {$EMPLOYEE ="AND `employeeID`=' {$this->employeeID}' ";}
			
			foreach($this->YEARS as $year)	{

				$this->SQL->query("	SELECT `salaryID` 
							FROM ebagdata{$year}.salary_bonuses
							WHERE `bonus_to_{$type}` REGEXP '-$id-' 
							  $EMPLOYEE
							  AND `deleted` IS NOT NULL LIMIT 1	");
							
				if ($this->SQL->num_rows()) {$found = TRUE; break;}
			}
			
			return $found;
		}
		
		function date_period()	{
		
			if (! $this->DAY) $this->DAY = date('t', mktime(0, 0, 0, $this->MONTH, 1, $this->YEAR));
			
			$this->TO_DATE = @date("Y-m-d", mktime(0,0,0, $this->MONTH, $this->DAY, $this->YEAR));
		}
		
		function form_date_interval($date)	{
		
			if ($this->TO_DATE) return " AND `$date`<='$this->TO_DATE' ";
			
			return '';
		}
		
		function calculate_by_year($year)	{
			
			extract($this->BONUS_SETTINGS);
		
			$BASE = "ebagdata{$year}";
			
			if ($bonus_percent_production or $bonus_fix_production or ($bonus_to_production == 3))	{
			
				if ($year == $this->YEAR) {$DATE_INTERVAL = $this->form_date_interval('date_of_finishing');} else {$DATE_INTERVAL = '';}
			
				$this->SQL->query("	SELECT `personID`, `code`, (quantity - defective_quantity) as `real_quantity`
							FROM   $BASE.production_orders_header
					  		WHERE  `deleted` IS NOT NULL
							  AND  `date_of_finishing` IS NOT NULL
							  $DATE_INTERVAL
							  AND  `stocktype`='1'
							  AND  `personID` IN (	SELECT `productionorderID`
										FROM $BASE.production_orders_phases
										WHERE `finisher`='employee_{$this->employeeID}' GROUP BY `productionorderID` )
							ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while (list($productionorderID, $code, $quantity) = $this->SQL->IT1_RESULT->fetch_row())	{
					
						$fullID = "{$year}_{$productionorderID}";

						# calculate bonus only once
						
						if ($this->calculated_once($fullID, 'production')) continue;
						
						# Read separated and use LIMIT
						
						$this->SQL->query("	SELECT `orderID`, `price` 
									FROM 	$BASE.orders_data
									WHERE	`productionorderID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1	");

						if (! $this->SQL->num_rows()) continue;
						
						list($orderID, $price) = $this->SQL->RESULT->fetch_row();
						
						$this->SQL->query("	SELECT `exchange_rate`
									FROM 	$BASE.orders_header
									WHERE	`personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");
									
						if (! $this->SQL->num_rows()) continue;
						
						list($exchange_rate) = $this->SQL->RESULT->fetch_row();
					
						if ($bonus_percent_production)	{
						
							$this->link_id('production', $fullID);
						
							$this->E('production', ($price*$exchange_rate*$bonus_percent_production/100));
						}
						
						if ($bonus_fix_production)	{
						
							$this->link_id('production', $fullID);
							
							$this->E('production', ($quantity*$bonus_fix_production));
						}
						
						if ($bonus_to_production == 3)	{
						
							if ($bonus_value = $this->form_bonus_by_code(array($code, $price, $quantity), 1, 'production', $exchange_rate))	{
							
								$this->link_id('production', $fullID);
								
								$this->E('production', $bonus_value);
							}
							
							if ($bonus_value = $this->form_phase_bonus_by_code(array($code, $price, $quantity), $productionorderID, $year, $exchange_rate))	{
							
								$this->link_id('production', $fullID);
						
								$this->E('production', $bonus_value);
							}
						}

					}
				}
			}
			
			if ($bonus_percent_services or $bonus_fix_services or ($bonus_to_services == 3))	{
			
				if ($year == $this->YEAR) {$DATE_INTERVAL = $this->form_date_interval('date_of_finishing');} else {$DATE_INTERVAL = '';}

				$this->SQL->query("	SELECT `personID`, `exchange_rate` 
							FROM $BASE.services_header 
							WHERE `finisher`='employee_$this->employeeID' $DATE_INTERVAL AND `deleted` IS NOT NULL
							ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while (list($reversID, $exchange_rate) = $this->SQL->IT1_RESULT->fetch_row())	{
					
						$fullID = "{$year}_{$reversID}";
						
						# calculate bonus only once
					
						if ($this->calculated_once($fullID, 'services')) continue;
						
						if ($bonus_percent_services)	{
						
							$this->SQL->query("	SELECT SUM(`price`*`quantity`) AS `price_s` 
										FROM $BASE.services_data
										WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{

								$this->link_id('services', $fullID);
								
								list($price) = $this->SQL->RESULT->fetch_row();

								$this->E('services', ($price*$exchange_rate*$bonus_percent_services/100));
							}
						}
						
						if ($bonus_fix_services)	{
						
							$this->SQL->query("	SELECT SUM(`quantity`) AS `quantity` 
										FROM $BASE.services_data 
										WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{

								$this->link_id('services', $fullID);
								
								list($quantity) = $this->SQL->RESULT->fetch_row();
								
								$this->E('services', ($quantity * $bonus_fix_services));
							}
						}
						
						if ($bonus_to_services == 3)	{
						
							$this->SQL->query("	SELECT `code`, `price`, `quantity` 
										FROM $BASE.services_data
										WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->SQL->itemRESULT = $this->SQL->RESULT;
							
								while ($itemData = $this->SQL->itemRESULT->fetch_row())	{
								
									if ($bonus_value = $this->form_bonus_by_code($itemData, 2, 'services', $exchange_rate))	{
									
										$this->link_id('services', $fullID);
								
										$this->E('services', $bonus_value);
									}
								}
								
								unset($this->SQL->itemRESULT);
							}
						}

					}
				}
			}
			
			if ($bonus_percent_product_sell or $bonus_fix_product_sell or ($bonus_to_product_sell == 3))	{
			
				if ($year == $this->YEAR) {$DATE_INTERVAL = $this->form_date_interval('date_of_creation');} else {$DATE_INTERVAL = '';}

				$this->SQL->query("	SELECT `personID` 
							FROM $BASE.deliverys_header 
							WHERE `billID` IS NOT NULL 
							      AND `billID` IN ( SELECT `personID` FROM $BASE.bills_header WHERE `deleted` IS NOT NULL $DATE_INTERVAL )
							      AND `seller`='$this->employeeID' AND `deleted` IS NOT NULL
							ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while (list($deliveryID) = $this->SQL->IT1_RESULT->fetch_row())	{
					
						$fullID = "{$year}_{$deliveryID}";

						# calculate only once
						
						if ($this->calculated_once($fullID, 'product_sell')) continue;

						if ($bonus_percent_product_sell)	{
						
							$this->SQL->query("	SELECT SUM(`price`*`quantity`) AS `price_s` 
										FROM $BASE.deliverys_data
										WHERE `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->link_id('product_sell', $fullID);
								
								list($price) = $this->SQL->RESULT->fetch_row();
								
								$this->E('product_sell', ($price*$bonus_percent_product_sell/100));
							}
						}
						
						if ($bonus_fix_product_sell)	{
						
							$this->SQL->query("	SELECT SUM(`quantity`) AS `quantity` 
										FROM $BASE.deliverys_data
										WHERE `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->link_id('product_sell', $fullID);
								
								list($quantity) = $this->SQL->RESULT->fetch_row();
								
								$this->E('product_sell', ($quantity*$bonus_fix_product_sell));
							}
						}
						
						if ($bonus_to_product_sell == 3)	{
						
							$this->SQL->query("	SELECT `code`, `price`, `quantity` 
										FROM $BASE.deliverys_data
										WHERE `deliveryID`='$deliveryID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->SQL->itemRESULT = $this->SQL->RESULT;
							
								while ($itemData = $this->SQL->itemRESULT->fetch_row())	{
								
									if ($bonus_value = $this->form_bonus_by_code($itemData, 1, 'product_sell'))	{
									
										$this->link_id('product_sell', $fullID);
										
										$this->E('product_sell', $bonus_value);
									}
								}
								
								unset($this->SQL->itemRESULT);
							}
						}
					}
				}
			}			
			
			if ($bonus_percent_service_sell or $bonus_fix_service_sell or ($bonus_to_service_sell == 3))	{
				
				if ($year == $this->YEAR) {$DATE_INTERVAL = $this->form_date_interval('date_of_creation');} else {$DATE_INTERVAL = '';}

				$this->SQL->query("	SELECT `personID`, `exchange_rate` 
							FROM $BASE.services_header
							WHERE `billID` IS NOT NULL 
							      AND `billID` IN ( SELECT `personID` FROM $BASE.bills_header WHERE `deleted` IS NOT NULL $DATE_INTERVAL )
							      AND `seller`='$this->employeeID' AND `deleted` IS NOT NULL
							ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{

					$this->SQL->IT1_RESULT = $this->SQL->RESULT;

					while (list($reversID, $exchange_rate) = $this->SQL->IT1_RESULT->fetch_row())	{

						$fullID = "{$year}_{$reversID}";

						# calculate only once
						
						if ($this->calculated_once($fullID, 'service_sell')) continue;

						if ($bonus_percent_service_sell)	{
						
							$this->SQL->query("	SELECT SUM(`price`*`quantity`) AS `price_s` 
										FROM $BASE.services_data 
										WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->link_id('service_sell', $fullID);

								list($price) = $this->SQL->RESULT->fetch_row();
								
								$this->E('service_sell', ($price*$exchange_rate*$bonus_percent_service_sell/100));
							}
						}
						
						if ($bonus_fix_service_sell)	{
						
							$this->SQL->query("	SELECT SUM(`quantity`) AS `quantity` 
										FROM $BASE.services_data
										WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->link_id('service_sell', $fullID);

								list($quantity) = $this->SQL->RESULT->fetch_row();
								
								$this->E('service_sell', ($quantity*$bonus_fix_service_sell));
							}
						}
						
						if ($bonus_to_service_sell == 3)	{
						
							$this->SQL->query("	SELECT `code`, `price`, `quantity` 
										FROM $BASE.services_data
										WHERE `reversID`='$reversID' AND `deleted` IS NOT NULL	");

							if ($this->SQL->num_rows())	{
							
								$this->SQL->itemRESULT = $this->SQL->RESULT;
							
								while ($itemData = $this->SQL->itemRESULT->fetch_row())	{
								
									if ($bonus_value = $this->form_bonus_by_code($itemData, 2, 'service_sell', $exchange_rate))	{

										$this->link_id('service_sell', $fullID);
								
										$this->E('service_sell', $bonus_value);
									}
								}
								
								unset($this->SQL->itemRESULT);
							}
						}
					}
				}
			}
		}
		
		function write_link_columns()	{
		
			$this->BONUSES_STR = array();
		
			foreach ($this->TYPES as $type)	{
			
				$key = "bonus_to_{$type}_linked";
				
				if (! count($this->{$key})) {$this->BONUSES_STR[$key] = 'NULL'; continue;}
				
				$this->BONUSES_STR[$key] = "'".$this->SQL->mysqli->real_escape_string('-'.implode('-', array_unique($this->{$key})).'-')."'";
				
				unset($this->{$key});
			}
		}
	}
	
	/**
	 *	SALARY CALCULATION
	 */

	class NEWSALARY		{

		var $employeeIDs	=	FALSE;
		var $DELETE_PREVIOUS	=	FALSE;
		var $MONTH_PART		=	0;
		var $FROM_DAY		=	FALSE;
		var $TO_DAY		=	FALSE;
		var $report_msg		=	array();

		function __construct()	{

			global $__SQL, $__CONF, $__LANG;
		
			$this->SQL	=	&$__SQL;
			
			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];
			
			$this->YEAR	=	$_SESSION['year'];
			
			$this->YEARS	=	FALSE;

			if (! $this->CURRENCY = $__CONF->get('payments', 'currency')) return 'fatalerror'; 
		}

		public function employeeID($ID)	{

			$this->employeeIDs = array($ID);
		}

		public function deleteprevious()	{

			$this->DELETE_PREVIOUS = TRUE;
		}

		public function month($NO)	{

			$this->MONTH	=	$NO;
			
			$this->MONTHLY_IS_SET = TRUE;
		}
		
		public function semimonth($NO)	{
		
			# set month and part
			
			$this->MONTH = ceil($NO/2);
		
			if ($NO % 2)	{
			
				$this->MONTH_PART = 1;
				
				$this->FROM_DAY = 1; 
				
				$this->TO_DAY	= 14;
			
				if ($this->MONTH != 2) $this->TO_DAY++;
				
			}	else	  {
			
				$this->MONTH_PART = 2;
				
				$this->FROM_DAY	= 15;
			
				if ($this->MONTH != 2) $this->FROM_DAY++;
				
				$this->TO_DAY = date('t', mktime(0, 0, 0, $this->MONTH, 1, $this->YEAR));
			}
		}
		
		private function form_date_interval($date)	{
		
			$interval = " MONTH(`$date`)='$this->MONTH' ";
		
			if ($this->MONTH_PART) $interval .= " AND DAY(`$date`)>=$this->FROM_DAY AND DAY(`$date`)<=$this->TO_DAY ";
			
			return $interval;
		}
		
		function read_open_years()	{
		
			$this->SQL->query("	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL
						ORDER BY `year` ");
						
			if ($this->SQL->num_rows())	{
			
				while ($result = $this->SQL->RESULT->fetch_row()) $this->YEARS[] = $result[0];
			}
		}

		private function lock()	{
		
			$OPEN_YEARS_LOCK = '';
		
			foreach($this->YEARS as $year) 		{
			
				$base = 'ebagdata'.$year;
			
				$OPEN_YEARS_LOCK .= " ,	$base.salary_bonuses WRITE, $base.deliverys_header WRITE, $base.deliverys_data WRITE, 
							$base.services_header WRITE, $base.services_data WRITE,
							$base.orders_header WRITE, $base.orders_data WRITE,
							$base.bills_header WRITE, 
							$base.production_orders_header WRITE, $base.production_orders_phases WRITE, 
							$base.employees_items_bonuses WRITE, $base.employees_phases_bonuses WRITE	";
			}

			$this->SQL->query("	LOCK TABLES 	$this->BASE.salarys WRITE, $this->BASE.employees WRITE,
								$this->BASE.salarys_personal_data WRITE, $this->BASE.working_hours WRITE
								$OPEN_YEARS_LOCK	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function employees_read()	{

			# note: read employees whichs have salary personal settings

			$this->SQL->query("SELECT `employeeID` FROM $this->BASE.salarys_personal_data");

			if ($this->SQL->num_rows())	{
			
				$this->employeeIDs = array();
			
				while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->employeeIDs[] = $RESULT[0];
				
				if (! count($this->employeeIDs)) $this->employeeIDs = FALSE;
			}
		}
		
		private function second_type_exists($employeeID)	{
		
			if ($this->MONTH_PART)	{
			
				$month_part = " `month_part`='0' ";
			
			}	else	  {
			
				$month_part = " `month_part`!='$this->MONTH_PART' ";
			}
		
			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.salarys 
						WHERE  `month`='$this->MONTH' AND $month_part AND `employeeID`='$employeeID' LIMIT 1	");
						
			if ($this->SQL->num_rows()) return TRUE;
			
			return FALSE;
		}

		private function delete_previous($employeeID)	{
			
			$this->SQL->query("	SELECT `personID` INTO @tmp_salaryID
						FROM $this->BASE.salarys 
						WHERE `month`='$this->MONTH' AND `month_part`='$this->MONTH_PART' AND `employeeID`='$employeeID' LIMIT 1	");

			$this->SQL->query("	DELETE FROM $this->BASE.salarys 
						WHERE `personID`=@tmp_salaryID LIMIT 1	");
						
			$this->SQL->query("	DELETE FROM $this->BASE.salary_bonuses
							WHERE `salaryID`=@tmp_salaryID LIMIT 1	");
		}

		private function check_for_previous($employeeID)	{

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.salarys 
						WHERE `month`='$this->MONTH' AND `month_part`='$this->MONTH_PART' AND `employeeID`='$employeeID' LIMIT 1	");

			if ($this->SQL->num_rows()) return TRUE;
			
			return FALSE;
		}
		
		private function calculate($employeeID)		{

			# clone globals because it will be changed 

			$GLOBALS	=	$this->GLOBALS;

			# read employeename

			$this->SQL->query("	SELECT `employeename` 
						FROM $this->BASE.employees
						WHERE `personID`='$employeeID' AND `deleted` IS NOT NULL LIMIT 1	");

			# prevent: if somehow this happends step over

			if (! $this->SQL->num_rows())	return "deletedemployee->$employeeID";

			$RESULT		=	$this->SQL->RESULT->fetch_row();
			$employeename	=	$this->SQL->nr_escape($RESULT[0]);

			# read personal settings

			$this->SQL->query("	SELECT `value`
						FROM $this->BASE.salarys_personal_data
						WHERE `employeeID`='$employeeID' LIMIT 1	");

			if (! $this->SQL->num_rows()) return "nosalarydata2employee->$employeeID";

			$RESULT		=	$this->SQL->RESULT->fetch_row();

			$SETTINGS	=	unserialize($RESULT[0]);

			# read working hours
			
			$DATE_INTERVAL  = $this->form_date_interval('date');

			$this->SQL->query("	SELECT 	`work_hours`, `overtime_work_hours`, `night_work`, `night_overtime_work`, 
							`holiday_work`, `sick_leave`, `sick_leave_100`, `annual_leave`, `holiday`
						FROM $this->BASE.working_hours
						WHERE $DATE_INTERVAL AND `employeeID`='$employeeID' AND `deleted` IS NOT NULL	");

			$E_work = $E_overtime_work = $E_night_work = $E_night_overtime_work = $E_night_holiday_work = $E_night_overtime_holiday_work = 0;
			$E_sick_leave = $E_sick_leave_100 = $E_holiday_work = $E_holiday_overtime_work = $E_holiday = $E_annual_leave = 0;

			# note:	Working hours values are 0, 1 or decimal, never null

			if ($this->SQL->num_rows())	{

				while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

					extract($RESULT);

					if ($holiday)	{
	
						$E_holiday	+=	$work_hours;
						continue;
					}

					if ($annual_leave)	{

						$E_annual_leave	+=	$work_hours;
						continue;
					}		

					if ($sick_leave)	{

						$E_sick_leave	+=	$work_hours;
						continue;
					}
					
					if ($sick_leave_100)	{

						$E_sick_leave_100 +=	$work_hours;
						continue;
					}

					if ($holiday_work)	{

						if ($night_work) 	{

							$E_night_holiday_work	+=	$work_hours;

						}	else	 {

							$E_holiday_work 	+=	$work_hours;
						}

						if ($night_overtime_work) 	{

							$E_night_overtime_holiday_work	+=	$overtime_work_hours;

						}	else	  {

							$E_holiday_overtime_work 	+=	$overtime_work_hours;
						}

						continue;
					}

					if ($night_work)	{

						$E_night_work 		+=	$work_hours;

					}	else	{

						$E_work 		+=	$work_hours;
					}

					if ($night_overtime_work)	{

						$E_night_overtime_work 	+=	$overtime_work_hours;

					}	else	{

						$E_overtime_work 	+= 	$overtime_work_hours;
					}
				}
			}
	
			# read bonuses
			
			$__BONUSES = new BONUSES();
			
			$__BONUSES->SETTINGS = $SETTINGS;
			
			$__BONUSES->YEARS = $this->YEARS;
			
			$__BONUSES->MONTH = $this->MONTH;
			
			if ($this->MONTH_PART) $__BONUSES->DAY=$this->TO_DAY;
			
			list($BONUSES_CONF, $BONUSES_STR, $BONUSES_SUM) = $__BONUSES->calculate($employeeID);
			
			unset($__BONUSES);
			
			extract($BONUSES_STR); unset($BONUSES_STR);
			
			extract($BONUSES_SUM); unset($BONUSES_SUM);
			
			# calculate salary base

			$SALARY_BASE = $E_payment = 0;

			if ($SETTINGS['fix_payment'])	{
			
				if ($this->MONTH_PART == 1)	{
				
					$semi_fix_coef = $SETTINGS['fix_payment_first_part']/100;
				
				} elseif ($this->MONTH_PART == 2) {
				
					$semi_fix_coef = (100 - $SETTINGS['fix_payment_first_part'])/100;
				
				}	else	  {
				
					$semi_fix_coef = 1;
				}

				$SALARY_BASE 		=	$semi_fix_coef * $SETTINGS['fix_payment'];
				$fix_payment 		=	"'".$SETTINGS['fix_payment']."'";
				$working_hour_value 	=	'NULL';

			}	else	  {
	
				$overtime_work_coef	=	$GLOBALS['overtime_work']/100;
				$night_work_coef	=	$GLOBALS['night_work']/100;
				$holiday_work_coef	=	$GLOBALS['holiday_work']/100;
				$sick_leave_coef	=	$GLOBALS['sick_leave']/100;
				$sick_leave_100_coef	=	1;
				$annual_leave_coef	=	$GLOBALS['annual_leave']/100;
				$holiday_coef		=	$GLOBALS['holiday']/100;
				$working_hour_value	=	"'".$SETTINGS['working_hour_value']."'";
				$fix_payment		=	'NULL';

				$SALARY_BASE	=	($E_work +
							($E_overtime_work * $overtime_work_coef) + 
							($E_night_work * $night_work_coef) +
							($E_night_overtime_work * $night_work_coef * $overtime_work_coef) +
							($E_night_holiday_work * $night_work_coef * $holiday_work_coef) +
							($E_night_overtime_holiday_work * $night_work_coef * $overtime_work_coef * $holiday_work_coef) + 
							($E_holiday_work * $holiday_work_coef) + 
							($E_holiday_overtime_work * $overtime_work_coef * $holiday_work_coef) +
							($E_sick_leave * $sick_leave_coef) + 
							($E_sick_leave_100 * $sick_leave_100_coef) + 
							($E_annual_leave * $annual_leave_coef) +
							($E_holiday * $holiday_coef)) * $SETTINGS['working_hour_value'];
			}

			$SALARY_BASE	+= ($E_bonus_production + $E_bonus_services + $E_bonus_product_sell + $E_bonus_service_sell);

			$SUM		=	$SALARY_BASE;

			# add personal additionals

			if (isset($SETTINGS['additional_name']))	{

				$count = count($SETTINGS['additional_name']);

				for ($i=0; $i<$count; $i++)	{

					$value		=	$SETTINGS['additional_value'][$i];
					$type		=	$SETTINGS['additional_type'][$i];
					$basetype	=	$SETTINGS['additional_base'][$i];

					# note: types f=>fix, p=>%, basetypes s=>start, p=>previous

					if ($type == 'p')	{

						if ($basetype == 's') {

							$value	=	$SALARY_BASE*$value/100;

						}	else	  {

							$value	=	$SUM*$value/100;
						}
					}

					# after calculating store rel value

					$SETTINGS['additional_value'][$i]	=	$value;

					$SUM += $value;
				}

				# serialize only personal additionals to rewrite them

				$PERSONAL_ADDS_UN	=	array('additional_name'=>$SETTINGS['additional_name'], 'additional_value'=>$SETTINGS['additional_value']);

				$PERSONAL_ADDS		=	"'".$this->SQL->mysqli->real_escape_string(serialize($PERSONAL_ADDS_UN))."'";

				unset($PERSONAL_ADDS_UN);

			}	else	{

				$PERSONAL_ADDS		=	'NULL';
			}

			# add global additionals

			if (isset($GLOBALS['additional_name']))	{

				$count = count($GLOBALS['additional_name']);

				for ($i=0; $i<$count; $i++)	{

					$value		=	$GLOBALS['additional_value'][$i];
					$basetype	=	$GLOBALS['additional_base'][$i];

					# note: basetypes s=>start, p=>previous

					if ($basetype == 's') {

						$value	=	$SALARY_BASE*$value/100;

					}	else	  {

						$value	=	$SUM*$value/100;
					}

					# after calculating store the real value

					$GLOBALS['additional_value'][$i]	=	$value;

					$SUM += $value;
				}

				# and unset base array, not need animore

				unset($GLOBALS['additional_base']);
			}

			# serialize to write into base

			$GLOBALS = $this->SQL->mysqli->real_escape_string(serialize($GLOBALS));

			# minus credits at the end
			
			if (isset($SETTINGS['credit_name']) && count($SETTINGS['credit_name']))	{
			
				$PERSONAL_CREDITS = "'".$this->SQL->mysqli->real_escape_string(serialize(array('credit_name'=>$SETTINGS['credit_name'], 'credit_value'=>$SETTINGS['credit_value'])))."'";

				foreach ($SETTINGS['credit_value'] as $creditvalue) $SUM = $SUM - $creditvalue;
				
			}	else 	  {
			
				$PERSONAL_CREDITS	=	'NULL';
			}

			$E_payment	= 	$SUM;

			# insert salary data

			$now	=	date("Y-m-d");			

			$this->SQL->query("	INSERT INTO $this->BASE.salarys
						VALUES
						(NULL, '$this->companyID', '$employeeID', $employeename, '$this->CURRENCY', '$GLOBALS', $fix_payment, 
						$working_hour_value, '$BONUSES_CONF', $PERSONAL_ADDS, $PERSONAL_CREDITS, '$this->MONTH', '$this->MONTH_PART', '$now', '$E_work', 
						'$E_overtime_work', '$E_night_work', '$E_night_overtime_work', '$E_night_holiday_work', '$E_night_overtime_holiday_work', 
						'$E_sick_leave', '$E_sick_leave_100', '$E_holiday_work', '$E_holiday_overtime_work', '$E_holiday', '$E_annual_leave', 
						'$E_bonus_production', '$E_bonus_services', '$E_bonus_product_sell', '$E_bonus_service_sell', '$SALARY_BASE', '$E_payment', NULL, NULL, '0')	");
						
			# insert bonuses
			
			$salaryID = $this->SQL->lastid();
			
			$this->SQL->query("	INSERT INTO $this->BASE.salary_bonuses
						VALUES
						( '$salaryID', '$employeeID', $bonus_to_production_linked, $bonus_to_services_linked,
						   $bonus_to_product_sell_linked, $bonus_to_service_sell_linked, '0')	");

			return TRUE;
		}
		
		function rollback_and_wait()	{
		
			# release the Kraken
		
			$this->SQL->rollback();

			$this->unlock();

			usleep(500000);
		}
		
		function report($str)	{
		
			if (strpos($str, '->') !== FALSE)	{
		
				list($msg, $id)  = explode('->', $str);
				  
				$msg = $this->LANG->get($msg, $id);
				  
			}	else 	  {
			
				$msg = $this->LANG->get($str);
			}
			
			$this->report_msg[] = $msg;
		}

		public function create()	{

			if (! isset($this->MONTH)) return 'usererror';
			
			if (isset($this->MONTHLY_IS_SET) && $this->MONTH_PART) {$this->report('both_salary_request'); return FALSE;}

			# to prevent errors set time limit to zero

			$default_time_limit = ini_get('max_execution_time');

			set_time_limit(0);

			# rock and roll
			
			$this->read_open_years();

			# read company data

			$this->SQL->query("SELECT MAX(`personID`) AS `personID` FROM ebag.companydata");

			list($this->companyID) = $this->SQL->RESULT->fetch_row();

			if (! $this->companyID)	{$this->report('nocompanydata'); return FALSE;}

			# read salary globals

			$this->SQL->query("	SELECT `value`
						FROM ebag.settings
						WHERE `key`='salary_constants' LIMIT 1	");

			if (! $this->SQL->num_rows()) {$this->report('nosalaryglobalsdefined'); return FALSE;}

			$RESULT	= $this->SQL->RESULT->fetch_row();

			$this->GLOBALS	= unserialize($RESULT[0]);

			# if no employee defined read them

			if (! $this->employeeIDs) $this->employees_read();

			if (! $this->employeeIDs) {$this->report('noemployeeswithsalarydata'); return FALSE;}
			
			$PAYROLL_CREATED = FALSE;

			foreach ($this->employeeIDs as $employeeID)	{
			
				$this->SQL->transaction();

				$this->lock();

				# delete previous salary or check existenst

				if ($this->DELETE_PREVIOUS) 	{

					$this->delete_previous($employeeID);

				}	else	{

				 	if ($this->check_for_previous($employeeID))	{
				 	
						$this->report("previoussalarydetected->$employeeID");

						$this->rollback_and_wait();

						continue;
					}
				}

				# step over if second type found & calculate to rest
			
				if ($this->second_type_exists($employeeID))	{
				
					$this->report("nosalarycreatedothertypes->$employeeID");
				
					$this->rollback_and_wait();
				
					continue;
				}
				
				# calculate

				$RESULT = $this->calculate($employeeID);

				if ($RESULT !== TRUE)	{
				
					$this->report($RESULT);
				
					$this->rollback_and_wait();
				
				}	else 	  {
				
					$this->SQL->commit();

					$this->unlock();
					
					usleep(500000);
					
					$PAYROLL_CREATED = TRUE;
				}
			}
			
			if (! $this->report_msg) $this->report('salarywithouterrors');

			return $PAYROLL_CREATED;
		}
	}

?>
