<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag order delete
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class ORDERDELETE	{

		function __construct()	{

			global $__SQL;

			$this->SQL		=	&$__SQL;

			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES	$this->BASE.orders_header WRITE, 
							$this->BASE.orders_data WRITE, 
							$this->BASE.offers_header WRITE, 
							$this->STOCKBASE.finished_goods_stock WRITE	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}


		# note: the state is checked only when order is deleted
		#	at the modify the locked rows solves this problem
	
		private function state($ID)	{

			# exist or not

			$this->SQL->query("	SELECT `contactname` 
						FROM $this->BASE.orders_header 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	return 'unexistentorder';

			# partially delivered or not

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.orders_data 
						WHERE `orderID`='$ID' AND `deliverylistID` IS NOT NULL AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	return 'partiallydeliveredorder';

			# in production or not

			$this->SQL->query("	SELECT `personID` 
						FROM $this->BASE.orders_data 
						WHERE `orderID`='$ID' AND `productionorderID` IS NOT NULL AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	return 'productioninpartorder';

			return FALSE;
		}


		public function delete($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			$this->SQL->transaction();
		
			$this->lock();

			if ($STATE = $this->state($ID))	{

				$this->SQL->rollback();

				$this->unlock();

				return $STATE;
			}

			# if is connected with order

			$this->SQL->query("	SELECT `connected_with_offer`
						FROM $this->BASE.orders_header
						WHERE `personID`='$ID' LIMIT 1	");

			$RESULT	= $this->SQL->RESULT->fetch_row();

			if ($offerID = $RESULT[0])		{

				$this->SQL->query("	UPDATE $this->BASE.offers_header
							SET `ordered`='0'
							WHERE `personID`='$offerID' LIMIT 1	");
			}

			$delete_reason	=	$this->SQL->n_escape($DATA['delete_reason']);

			# delete order header

			$this->SQL->query("	UPDATE $this->BASE.orders_header
						SET `deleted`=NULL , `delete_reason`=$delete_reason
						WHERE `personID`='$ID' LIMIT 1	");

			# read and correct ordered articles into stock

			$this->SQL->query("	SELECT `code`, `quantity`
						FROM $this->BASE.orders_data
						WHERE `orderID`='$ID' AND `deleted` IS NOT NULL	");

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				$code		=	$this->SQL->nr_escape($RESULT['code']);
				$quantity	=	$RESULT['quantity'];

				$this->SQL->query("	UPDATE $this->STOCKBASE.finished_goods_stock 
							SET quantity_ordered=quantity_ordered-$quantity 
							WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");
			}

			unset($this->SQL->IT1_RESULT);

			# delete order data

			$this->SQL->query("	UPDATE $this->BASE.orders_data 
						SET `deleted`=NULL 
						WHERE `orderID`='$ID'	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;	
		}
	}
?>
