<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 5.0.0
	 */

	/**
	 * eBag reads order data for create new production order
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PRODUCTIONORDERDEFAULT	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->SQLFORMAT	=	$__CONF->get('date', 'sql_format');

			$this->FORMAT		=	$__CONF->get('date', 'dateformat');

			$this->BASE		=	$_SESSION['BASE'];
	
			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	{

			$LOCKS	= array();

			foreach ($this->YEARS as $YEAR)	$LOCKS[] = " ebagdata$YEAR.production_orders_header WRITE, ebagdata$YEAR.production_orders_data WRITE ";

			if (count($LOCKS) >= 1) $LOCKS = implode(',', $LOCKS);

			$this->SQL->query("LOCK TABLES	$this->STOCKBASE.finished_goods_stock WRITE,
							$this->BASE.orders_header WRITE,
							$this->BASE.orders_data WRITE, ".$LOCKS);
		}

		private function unlock()	{
		
			$this->SQL->query('UNLOCK TABLES');
		}

		private function readyears()	{
		
			$this->YEARS = array();

			$this->SQL->query("	SELECT `year`
						FROM ebag.years ORDER BY `year` DESC	");

			while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[] = $RESULT[0];
		}

		public function read($orderID, $personID)	{

			$DATA['orderID']		=	$orderID;

			$DATA['rowID']			=	$personID;

			$DATA['date_of_creation']	=	date("$this->FORMAT");

			$this->readyears();

			$this->lock();

			# read orders data & check existens

			$this->SQL->query("	SELECT `code` AS `articalcode`, `quantity` AS `articalquantity`
						FROM $this->BASE.orders_data 
						WHERE `personID`='$personID' LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'unexistentorder';
			}

			$RESULT	=	$this->SQL->RESULT->fetch_assoc();

			foreach ($RESULT as $key=>$val) $DATA[$key] = $val;

			# read artical data & check existens

			$code	=	$this->SQL->nr_escape($DATA['articalcode']);
	
			$this->SQL->query("	SELECT `articalname`
						FROM $this->STOCKBASE.finished_goods_stock 
						WHERE `code`= $code AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'articalnotexist';
			}

			$RESULT			=	$this->SQL->RESULT->fetch_row();

			$DATA['articalname']	=	$RESULT[0];

			# read orders header data

			$this->SQL->query("	SELECT `contactname`, DATE_FORMAT(`date_of_deadline` , '$this->SQLFORMAT') AS `date_of_deadline`
						FROM $this->BASE.orders_header 
						WHERE `personID`='$orderID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'unexistentorder';
			}

			$RESULT = $this->SQL->RESULT->fetch_assoc();

			foreach ($RESULT as $key=>$val) $DATA[$key] = $val;

			# if is produced before read the last technology

			foreach ($this->YEARS as $YEAR)		{

				$this->SQL->query("	SELECT MAX(`personID`) 
							FROM ebagdata$YEAR.production_orders_header 
							WHERE `code`=$code AND `deleted` IS NOT NULL	");

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				if ($RESULT[0])		{

					$productionorderID	=	$RESULT[0];
					$productionYEAR		=	$YEAR;
					
					break;
				}
			}

			$DATA['technology']	=	'';
			$DATA['drawingID']	=	'';

			if (isset($productionorderID))		{

				# read technology

				$this->SQL->query("	SELECT `technology`, `drawingID` 
							FROM ebagdata$productionYEAR.production_orders_header
							WHERE `personID`='$productionorderID' AND `deleted` IS NOT NULL LIMIT 1	");

				$RESULT	=	$this->SQL->RESULT->fetch_row();

				$DATA['technology']	=	$RESULT[0];
				$DATA['drawingID']	=	$RESULT[1];

				# also read the feedstocks & articles
	
				$this->SQL->query("	SELECT `code`, `name`, `unit`, `quantity`, `type`  
							FROM ebagdata$productionYEAR.production_orders_data
							WHERE `productionorderID`='$productionorderID' AND `deleted` IS NOT NULL ORDER BY `personID` ");

				if ($this->SQL->num_rows())	{
				
					$DATA['code'] = $DATA['name'] = $DATA['quantity'] = $DATA['unit'] = $DATA['type'] = array();

					while ($RESULT = $this->SQL->RESULT->fetch_assoc())	{

						$DATA['code'][]		=	$RESULT['code'];
						$DATA['name'][]		=	$RESULT['name'];
						$DATA['quantity'][]	=	$RESULT['quantity'];
						$DATA['unit'][]		=	$RESULT['unit'];
						$DATA['type'][]		=	$RESULT['type'];
					}
				}
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
