<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag read default data for phase change form
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class PHASECHANGEDEFAULT	{

		function __construct()	{

			global $__SQL, $__LANG, $__CONF;

			$this->SQL	=	&$__SQL;

			$this->LANG	=	&$__LANG;

			$this->BASE	=	$_SESSION['BASE'];

			$this->FORMAT	=	$__CONF->get('date', 'sql_format');
			
			$this->APC	=	$__CONF->get('cache', 'use_apc_cache');
		}

		private function lock()	{

			$this->SQL->query("LOCK TABLES 	$this->BASE.production_orders_header WRITE, 
							$this->BASE.production_orders_phases WRITE,
							$this->BASE.addressbook WRITE, 
							$this->BASE.employees WRITE 	");
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		public function read($ID)	{

			$ID		=	$this->SQL->escape($ID);
			
			# read phases
			
			$__PHASES	=	new PHASEloader($this->APC);

			$PHASES		=	$__PHASES->getall();

			unset($__PHASES);

			$this->lock();

			$DATA				=	'unexistentproductionorder';

			$this->SQL->query("	SELECT	`code`, `articalname`, `contactname`, `quantity`, `production_phase`,
							DATE_FORMAT(`date_of_creation`, '$this->FORMAT') AS `date_of_creation`,
							DATE_FORMAT(`date_of_finishing`, '$this->FORMAT') AS `date_of_finishing`
						FROM $this->BASE.production_orders_header
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows()) 	{

				$this->unlock();

				return 'unexistentproductionorder';
			}

			$DATA	=	$this->SQL->RESULT->fetch_assoc();

			$DATA['productionorderID']	=	$ID;

			if ($DATA['date_of_finishing'])		{

				$this->unlock();

				return 'finishedproductionorder';
			}

			if ($DATA['production_phase'])	{

				$DATA['current_phase_name']	=	$PHASES[$DATA['production_phase']];

				unset($PHASES);
			}

			$current_phase	=	$this->SQL->nr_escape($DATA['production_phase']);
			
			# read the last record
			
			$this->SQL->query("	SELECT MAX(`personID`) AS `personID`
						FROM $this->BASE.production_orders_phases
					  	WHERE `productionorderID`='$ID' AND `production_phase`=$current_phase");
				
			$RESULT	= $this->SQL->RESULT->fetch_row();
			
			$maxID = $RESULT[0];
			
			$this->SQL->query("	SELECT `personID`, `finisher`, `process_time`  
						FROM $this->BASE.production_orders_phases
					  	WHERE `personID`='$maxID' LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$RESULT	= $this->SQL->RESULT->fetch_assoc();

				$DATA['phasepersonID']	=	$RESULT['personID'];
				$DATA['process_time']	=	$RESULT['process_time'];
				$DATA['finisher']	=	$RESULT['finisher'];

				# read finisher name	

				if ($DATA['finisher'])	{

					list($TYPE, $FINISHERID)	=	explode('_', $DATA['finisher']);

					if ($TYPE == 'employee')	{

						$COMMAND = "SELECT `employeename` FROM $this->BASE.employees WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";

					}	else	   {

						$COMMAND = "SELECT `contactname` FROM $this->BASE.addressbook WHERE `personID`='$FINISHERID' AND `deleted` IS NOT NULL LIMIT 1";
					}

					$this->SQL->query($COMMAND);

					if ($this->SQL->num_rows())	{

						$RESULT	= $this->SQL->RESULT->fetch_row();
						$DATA['finishername']	=	$RESULT[0];

					}	else	 {

						$DATA['finishername']	=	$this->LANG->get('finisherwasdeleted');
					}
				}
				
			}	else	  {
			
				$DATA = 'unknownerror';
			}

			$this->unlock();

			return $DATA;
		}
	}

?>
