<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag operating suplies read
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class SALARYCOMMENT	{

		function __construct()	{

			global $__SQL;

			$this->SQL   =	&$__SQL;

			$this->BASE  = $_SESSION['BASE'];
			
			$this->_employeeID = FALSE;
			
			$this->_personID   = FALSE;
			
			$this->_month 	   = FALSE;
			
			$this->_part 	   = 0;
		}
		
		public function employeeID($id)	{
		
			$id = (integer)$id;
		
			if ($id > 0) $this->_employeeID = $id;
		}
		
		public function salaryID($id)	{
		
			$id = (integer)$id;
			
			if ($id > 0) $this->_personID = $id;
		}
		
		public function month($month)	{
		
			$month = (integer)$month;
		
			if ($month > 0) $this->_month = $month;
		}

		public function semimonth($semimonth)	{
		
			$semimonth = (integer)$semimonth;
			
			if ($semimonth <= 0) return;
		
			$this->_month = ceil($semimonth/2);
	
			if ($semimonth % 2) {$this->_part = 1;} else {$this->_part = 2;}
		}
		
		public function getID()	{
		  
			return $this->_personID;
		}

		public function write($comment, $annotation)	{
		
			if (isset($_SESSION['year_is_closed']))	return 'yearisclosed';
			
			if ((! $this->_employeeID) or ((! $this->_personID) && (! $this->_month) && (! $this->_part))) return 'usererror';
			
			foreach(array('personID', 'employeeID', 'month', 'part') as $key)	{
			
				if ($this->{'_'.$key}) $this->{'_'.$key} = $this->SQL->escape($this->{'_'.$key});
			}

			if (! $this->_personID)	{
			
				if ($this->_part) {$PART = " AND `month_part`='$this->_part' ";} else {$PART = '';}
			
				$this->SQL->query("	SELECT `personID`
							FROM $this->BASE.salarys
							WHERE `employeeID`='$this->_employeeID' 
							  AND `month`='$this->_month' 
							  $PART 
							  AND `deleted` IS NOT NULL LIMIT 1	");
							
				if (! $this->SQL->num_rows()) return 'unexistentsalary';

				list($this->_personID) = $this->SQL->RESULT->fetch_assoc();
			}
			
			$comment = $this->SQL->n_escape($comment);
			
			$annotation = $this->SQL->n_escape($annotation);
		
			$this->SQL->query("	UPDATE $this->BASE.salarys
						SET `comment`=$comment, `annotation`=$annotation
						WHERE `personID`='$this->_personID' AND `deleted` IS NOT NULL LIMIT 1	");
						
			if (! $this->SQL->affected_rows()) return 'unexistentsalary';

			return TRUE;
		}
	}

?>
