<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('addtax');

	load_f('is_real_positive');
	
	load_f('is_real_tax');
	
	load_f('is_longer');

	class SERVICEUPDATE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;
			
			$this->BASE		=	$_SESSION['BASE'];

			$this->STOCKBASE	=	'ebagstock';
		}

		private function lock()	  {

			$this->get_open_years();

			$TO_LOCK	=	'';

			foreach ($this->OPENED as $YEAR) $TO_LOCK .= ", ebagdata$YEAR.services_data WRITE";

			$this->SQL->query("LOCK TABLES 	ebag.years WRITE, 
							$this->BASE.employees_items_bonuses WRITE,
							ebagstock.services WRITE".$TO_LOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function get_open_years()	{

			$this->SQL->query('	SELECT `year` 
						FROM ebag.years 
						WHERE `closed` IS NULL	');

			$this->OPENED	=	array();

			while ($RESULT = $this->SQL->RESULT->fetch_row())	$this->OPENED[] = $RESULT[0];
		}

		private function prepare($DATA)	{

			unset($DATA['submit'], $DATA['ID']);

			if ((is_empty($DATA['code'])) or 
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['servicename'])) or
			    (is_empty($DATA['unit'])) or 
			    (is_empty($DATA['price'])) or
			    (is_empty($DATA['tax']))) return FALSE;

			if ((! is_real_positive($DATA['price'])) or 
			    (! is_real_tax($DATA['tax']))) return FALSE;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;
		}

		/**
		 * Update exists service
		 */

		public function update($ID, $DATA)	{

			$ID	=	$this->SQL->escape($ID);

			$this->lock();

			if (! $DATA = $this->prepare($DATA)) 	{

				$this->unlock();

				return 'usererror';
			}

			extract($DATA); unset($DATA);

			# check the code maybe exist

			$this->SQL->query("	SELECT `servicename` 
						FROM $this->STOCKBASE.services 
						WHERE `personID`!='$ID' AND `code`=$code AND `deleted` IS NOT NULL LIMIT 1");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'serviceexists';
			}	

			# check the record is not deleted in meantime

			$this->SQL->query("	SELECT `code` 
						FROM $this->STOCKBASE.services 
						WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");

			if (! $this->SQL->num_rows())	{

				$this->unlock();

				return 'deletedinmeantime';
			}

			$RESULT	= $this->SQL->RESULT->fetch_assoc();
		
			if ($code != "'".$RESULT['code']."'")	{

				$OLDCODE = $this->SQL->r_escape($RESULT['code']);

				foreach ($this->OPENED as $YEAR)	{

					$this->SQL->query("	SELECT `personID` 
								FROM ebagdata$YEAR.services_data
								WHERE `code`='$OLDCODE' AND `deleted` IS NOT NULL LIMIT 1	");

					if ($this->SQL->num_rows())	{

						$errtxt	= "ordered_service->year->$YEAR";

						break;
					}
				} 
				
				# check employees_bonuses
				
				if (! isset($errtxt))	{
				
					$this->SQL->query("	SELECT `personID`
								FROM $this->BASE.employees_items_bonuses
								WHERE `stock_type`='2' AND `stockID`='$ID' AND `deleted` IS NOT NULL LIMIT 1	");
								
					if ($this->SQL->num_rows()) $errtxt = 'bonusdefined2item';
				}
			}

			if (isset($errtxt))	{

				$this->unlock();

				return $errtxt;
			}
			
			$price_with_tax =	addtax(str_replace("'", '', $price), str_replace("'", '', $tax));

			$COMMAND	=	"UPDATE $this->STOCKBASE.services SET	`code`=$code, 
											`servicename`=$servicename, 
											`unit`=$unit, 
											`price`=$price,
											`tax`=$tax,
											`price_with_tax`='$price_with_tax',
											`comment`=$comment
						 WHERE `personID`=$ID LIMIT 1";

			$this->SQL->query($COMMAND);

			$this->unlock();

			return TRUE;
		}

	}
?>
