<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag service write
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	load_f('addtax');

	load_f('is_real_positive');
	
	load_f('is_real_tax');
	
	load_f('is_longer');

	class SERVICEWRITE	{

		function __construct()	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->STOCKBASE	=	'ebagstock';
		}

		public function prepare($DATA)	{

			unset($DATA['submit'], $DATA['ID']);

			if ((is_empty($DATA['code'])) or 
			    (is_longer($DATA['code'], 25)) or
			    (is_empty($DATA['servicename'])) or
			    (is_empty($DATA['unit'])) or 
			    (is_empty($DATA['price'])) or
			    (is_empty($DATA['tax']))) return FALSE;

			if ((! is_real_positive($DATA['price'])) or 
			    (! is_real_tax($DATA['tax']))) return FALSE;

			# Escape the data

			foreach ($DATA as $key=>$val)	$DATA[$key] = $this->SQL->n_escape($val);

			return $DATA;
		}

		/**
		 * Add new service
		 */

		public function write($DATA)	{

			if (! $DATA = $this->prepare($DATA)) return 'usererror';

			# check the code maybe exists

			$this->SQL->query("LOCK TABLES $this->STOCKBASE.services WRITE");

			extract($DATA); unset($DATA);

			$this->SQL->query("	SELECT `personID` 
						FROM $this->STOCKBASE.services 
						WHERE `code`=$code AND `deleted` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->SQL->query('UNLOCK TABLES');

				return 'serviceexists';
			}
			
			$price_with_tax =	addtax(str_replace("'", '', $price), str_replace("'", '', $tax));

			$COMMAND	=	"INSERT INTO $this->STOCKBASE.services VALUES (NULL, $code, $servicename, $unit, $price, $tax, '$price_with_tax', $comment, '0')";

			$this->SQL->query($COMMAND);

			$this->SQL->query('UNLOCK TABLES');

			return TRUE;
		}

		public function copy($DATA)	{

			$RESULT	= $this->write($DATA);

			return $RESULT;
		}
	}
?>
