<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 3.0.2
	 */

	/**
	 * eBag stock enter read (stock, feedstock, operating_suplies)
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}

	class STOCKENTERREAD	{

		function __construct($STOCKTABLE)	{

			global $__SQL, $__CONF;

			$this->SQL		=	&$__SQL;

			$this->CONF		=	&$__CONF;

			$this->STOCKTABLE	=	$STOCKTABLE;

			$this->ENTERTABLE	=	$STOCKTABLE.'_enter';

			$this->BASE 		=	$_SESSION['BASE'];

			if (isset($_SESSION['year_is_closed'])) {$this->STOCKBASE = $this->BASE;} else {$this->STOCKBASE = 'ebagstock';}
		}

		public function read($ID)	{

			$DATA	=	FALSE;

			$ID	=	$this->SQL->escape($ID);

			# read enter data
			$this->SQL->query("SELECT `delivery_list_number`, `bill_number`, `order_to_stockID`, `code`, `quantity`, 
						   DATE_FORMAT(`date`, '".$this->CONF->get('date', 'sql_format')."') AS `date`, `username` 
					   FROM $this->BASE.$this->ENTERTABLE WHERE `personID`='$ID' AND `deleted` IS NOT NULL LIMIT 1");

			if ($this->SQL->num_rows())	{

				$DATA = $this->SQL->RESULT->fetch_assoc();

				# read and change username to real name

				$username	=	$this->SQL->r_escape($DATA['username']);

				$this->SQL->query("	SELECT `surname`, `lastname` 
							FROM ebag.users 
							WHERE `username`='$username' AND DELETED IS NOT NULL LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$RESULT = $this->SQL->RESULT->fetch_row();

					$DATA['username'] = $RESULT[0].' '.$RESULT[1];
				}

				# read item name, unit and id from stock

				$NAMES	=	array	(	'feedstock'		=>	'feedstockname',
								'finished_goods_stock'	=>	'articalname',
								'operating_suplies'	=>	'supliename'	);

				$ITEMNAME	=	$NAMES[$this->STOCKTABLE];

				$code	=	$this->SQL->r_escape($DATA['code']);

				$this->SQL->query("SELECT `personID`, `$ITEMNAME`, `unit` FROM $this->STOCKBASE.$this->STOCKTABLE WHERE `code`='$code' AND `deleted` IS NOT NULL LIMIT 1");

				if ($this->SQL->num_rows())	{

					$RESULT = $this->SQL->RESULT->fetch_assoc();

					$DATA['id']	=	$RESULT['personID'];
					$DATA[$ITEMNAME]=	$RESULT[$ITEMNAME];
					$DATA['unit']	=	$RESULT['unit'];
				}
			}

			return $DATA;
		}
	}

?>
