<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag unit setings (add, change, delete, set to default);
	 */
	 
	if (! defined('eBag'))	{
	
	      include('../views/logout.php'); 
	      
	      exit();
	}
	
	load_f('is_longer');

	class UNITSETTINGS	{

		function __construct()	{

			global $__SQL;

			$this->SQL	=	&$__SQL;

			$this->readyears();
		}

		private function lock()	 {

			$TOLOCK	= '';

			foreach ($this->YEARS as $YEAR)	$TOLOCK .= ", ebagdata$YEAR.services_data WRITE, ebagdata$YEAR.offers_data WRITE, ebagdata$YEAR.orders_data WRITE ";

			$this->SQL->query('LOCK TABLES ebag.years WRITE, ebag.units WRITE'.$TOLOCK);
		}

		private function unlock()	{

			$this->SQL->query('UNLOCK TABLES');
		}

		private function readyears()	{

			$this->SQL->query("	SELECT `year` 
						FROM ebag.years 
						ORDER BY `year`	");

			$this->YEARS = array();
			
			while ($RESULT = $this->SQL->RESULT->fetch_row()) $this->YEARS[] = $RESULT[0];

		}

		private function is_in_use($unit)	{

			$FOUND = FALSE;

			foreach ($this->YEARS as $YEAR)	{

				$this->SQL->query("	(
								SELECT `personID` 
								FROM ebagdata$YEAR.services_data
								WHERE `unit`='$unit' AND `deleted` IS NOT NULL LIMIT 1
							)
							UNION ALL
							(
								SELECT `personID` 
								FROM ebagdata$YEAR.offers_data
								WHERE `unit`='$unit' AND `deleted` IS NOT NULL LIMIT 1
							)
							UNION ALL
							(
								SELECT `personID` 
								FROM ebagdata$YEAR.orders_data
								WHERE `unit`='$unit' AND `deleted` IS NOT NULL LIMIT 1
							)	");

				if ($this->SQL->num_rows())	{

					$FOUND = TRUE;

					break;
				}
			}

			return $FOUND;
		}

		public function defaultunit($UNIT)	{

			$UNIT	=	$this->SQL->escape($UNIT);

			$this->SQL->transaction();

			# note: no need to lock all tables

			$this->SQL->query('LOCK TABLES ebag.units WRITE');

			$this->SQL->query("	UPDATE ebag.units
						SET `default`=NULL
						WHERE `default` IS NOT NULL	");

			$this->SQL->query("	UPDATE ebag.units
						SET `default`='1' 
						WHERE `name`='$UNIT' LIMIT 1	");

			$this->SQL->commit();

			$this->unlock();

			return TRUE;
		}

		public function change($OLD, $NEW, $INTTYPE)	{

			if (is_empty($OLD)) return 'usererror';

			$OLD = $this->SQL->escape($OLD);

			if (! is_empty($NEW))	{
			
				if (is_longer($NEW, 40)) return 'usererror';

				$this->lock();

				if ($this->is_in_use($OLD))	{

					$this->unlock();

					return 'cannotchangeusedunit';
				}
		
				$NEW = $this->SQL->n_escape($NEW);

				# check the new name not exists once

				$this->SQL->query("	SELECT `name`
							FROM ebag.units
							WHERE `name`=$NEW LIMIT 1	");

				if ($this->SQL->num_rows())	{

					$this->unlock();

					return 'unitexists';
				}

				$this->SQL->query("	UPDATE ebag.units
							SET `name`=$NEW
							WHERE `name`='$OLD'	LIMIT 1");
			}

			if (! is_empty($NEW)) {$NAME = $NEW;} else {$NAME = "'".$OLD."'";}

			if ($INTTYPE) {$TYPE = "'int'";} else {$TYPE = "''";}

			$this->SQL->query("	UPDATE ebag.units
						SET `type`=$TYPE
						WHERE `name`=$NAME LIMIT 1	");

			
			$this->unlock();
	
			return TRUE;
		}

		public function delete($UNIT)	{

			$UNIT	=	$this->SQL->escape($UNIT);

			$this->lock();

			if ($this->is_in_use($UNIT))	{

				$this->unlock();

				return 'cannotdeleteusedunit';
			}

			# check that is not default

			$this->SQL->query("	SELECT `name` 
						FROM ebag.units
						WHERE `name`='$UNIT' AND `default` IS NOT NULL LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'cannotdeletedefaultunit';
			}

			# check that is not the last

			$this->SQL->query("	SELECT `name`
						FROM ebag.units	");

			if ($this->SQL->num_rows()==1)	{

				$this->unlock();

				return 'cannotdeletelastunit';
			}

			$this->SQL->query("	DELETE 
						FROM ebag.units
						WHERE `name`='$UNIT' LIMIT 1	");

			$this->unlock();

			return TRUE;
		}

		public function addnew($NEW, $INT)	{

			if (is_empty($NEW) or (is_longer($NEW, 40))) return 'usererror';

			# note: no need to lock all tables

			$this->SQL->query('LOCK TABLES ebag.units WRITE');

			$NEW	=	$this->SQL->n_escape($NEW);

			# check the new name not exists once

			$this->SQL->query("	SELECT `type`
						FROM ebag.units
						WHERE `name`=$NEW LIMIT 1	");

			if ($this->SQL->num_rows())	{

				$this->unlock();

				return 'unitexists';
			}

			if ($INT) {$TYPE = "'int'";} else {$TYPE = "''";}

			$this->SQL->query("	INSERT INTO ebag.units
						VALUES
						($NEW, $TYPE, NULL)	");

			$this->unlock();
	
			return TRUE;
		}
	}

?>
