<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * save eBag phase bonus data
	 */
	 
	# Turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);
	
	if (get_magic_quotes_gpc())	{
	
		if (isset($_POST) && $_POST)	{
	
		      foreach ($_POST as $key=>$val) $_POST[$key] = stripslashes($val);
		}
	}
	
	# translate
	
	foreach(array('employee_id'=>'employeeID', 'stock_id'=>'stockID', 'phase_id'=>'phaseID') as $key=>$val)	{
	
		if (isset($_POST[$key])) {$_POST[$val]=$_POST[$key]; unset($_POST[$key]);}
	}

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# Sets session handler (important to refresh the session)

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	if (isset($_SESSION['permission'])) {$_SESSION['permission'] = $_SESSION['permission'];} else {exit;}
	
	# not permitted to write (only to read)
	
	if (isset($_SESSION['year_is_closed'])) exit;
	
	# create connection
	
	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;
	
	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");

	# define custom error handler

	function errorhandler($errno, $errstr)	{

		global $mysqli;
		
		$mysqli->query('UNLOCK TABLES');
		
		return FALSE;
	}

	set_error_handler('errorhandler');

	new Bonus;
	
	# exit codes 1=Set, 2=Unset, 3=Not found, 4=Invalid bonus set, 5=Not product

	class Bonus	{
		
		var $_bonuses 		=  array( 1=>'percent_phases',
						  2=>'fix_phases'  );
					
		var $_personID 		= FALSE;
		
		var $_deleteID		= FALSE;
		
		var $_percent_phases 	= FALSE;
		
		var $_fix_phases 	= FALSE;
		
		var $_empty_row		= FALSE;
					  
		function __construct()	{
		  
			global $mysqli, $__CONF;
			
			$this->SQL  = &$mysqli;
			
			# read & verify $_POST

			foreach (array('employeeID', 'setting_type', 'bonus_type', 'phaseID') as $varname) {if (! isset($_POST[$varname])) {exit('3');}}

			foreach (array('employeeID', 'setting_type', 'stockID', 'code', 'bonus_type', 'bonus_value', 'phaseID') as $varname)	{
			
				if (! isset($_POST[$varname]))	{
				
					$this->{'_'.$varname} = FALSE;
					  
				}	else	  {
				
					$this->{'_'.$varname} = $this->SQL->real_escape_string(htmlspecialchars($_POST[$varname], $__CONF->get('specialchars', 'flag'), 'UTF-8', FALSE));
				}
			}
			
			if (($this->_setting_type == 2) && (! $this->_stockID) && ($this->_code === FALSE)) exit('3');

			if (! $this->_bonus_value) $this->_bonus_value = FALSE;
			
			if (($this->_bonus_value) && ((! is_numeric($this->_bonus_value)) or ($this->_bonus_value < 0))) exit('4');

			# Set base variables
		
			$this->_base = 'ebagdata'.$_SESSION['year'];
			
			$this->transaction();
			
			$this->verify_employee();
			
			if ($this->rewrite_bonus_values())	{
		
				if ($this->_setting_type == 2) $this->verify_stock_item();
			
				$this->set_bonus();
			}
			
			$this->commit();
			
			if ($this->_bonus_value) exit('1');
			
			exit('2');
		}
		
		function rewrite_bonus_values($spec=FALSE)	{
		
			if ($this->_setting_type == 1) {$product = '';} else {$product = " AND `stockID`='$this->_stockID' ";}

			$result = $this->SQL->query("	SELECT  `personID`, `percent_phases`, `fix_phases` FROM $this->_base.employees_phases_bonuses
							WHERE	`employeeID`='$this->_employeeID'
							  AND	`setting_type`='$this->_setting_type'
							  AND	`phaseID`='$this->_phaseID'
							  $product
							  AND	`deleted` IS NOT NULL
							LIMIT 1	");
			if ($result->num_rows)	{
	
				list($this->_personID, $this->_percent_phases, $this->_fix_phases) = $result->fetch_row();
				
			}	else	{
			
				if ($this->_setting_type == 2)	{
				
					# if not found specific then see for all
			
					$result = $this->SQL->query("	SELECT  `personID` FROM $this->_base.employees_phases_bonuses
									WHERE	`employeeID`='$this->_employeeID'
									  AND	`setting_type`='1'
									  AND	`phaseID`='$this->_phaseID'
									  AND	`deleted` IS NOT NULL
									LIMIT 1	");
									
					if ($result->num_rows) {list($this->_deleteID) = $result->fetch_row();}
				}
			}
			
			if ($this->_bonus_type == 1)	{
			
				if (($this->_percent_phases == $this->_bonus_value) && $this->_personID) return FALSE; # unchanged
			
				$this->_percent_phases 	= $this->_bonus_value;
				$this->_fix_phases 	= FALSE;
			
			}	else	  {

				if (($this->_fix_phases	== $this->_bonus_value) && $this->_personID) return FALSE; # unchanged

				$this->_fix_phases 	= $this->_bonus_value;
				$this->_percent_phases 	= FALSE;
			}
			
			if ((! $this->_fix_phases) && (! $this->_percent_phases)) $this->empty_row = TRUE;
	
			return TRUE;
		}
		  
		function _exit($exitcode)	{
		
			# rollback first
		
			$this->SQL->rollback();

			$this->SQL->query('UNLOCK TABLES');
			
			exit("$exitcode");
		}
		
		function transaction()	{
		
			# start new transaction
		
			$this->SQL->query("LOCK TABLES	ebagstock.finished_goods_stock WRITE, 
							$this->_base.employees WRITE,
							$this->_base.employees_phases_bonuses WRITE	");
							
			$this->SQL->autocommit(FALSE);
		}
		
		function commit()	{
		
			# commit
		
			$this->SQL->commit();

			$this->SQL->query('UNLOCK TABLES');
		}
		
		function verify_employee()	{
		    
			$result = $this->SQL->query("	SELECT  `personID` FROM $this->_base.employees
							WHERE	`personID`='$this->_employeeID'
							    AND `deleted` IS NOT NULL  
							LIMIT 1	");
						
			if (! $result->num_rows) $this->_exit(3);
		}							 
		
		
		function verify_stock_item()	{
		
			$result = $this->SQL->query("	SELECT  `personID`, `origin` FROM ebagstock.finished_goods_stock
							WHERE	`personID`='$this->_stockID'
							    AND `code`='$this->_code'
							    AND `deleted` IS NOT NULL  
							LIMIT 1	");
							
			if (! $result->num_rows) $this->_exit(3);
			
			$tmp = $result->fetch_assoc();
			
			if ($tmp['origin'] != 1) $this->_exit(6);
		}
		
		function insert_bonus_row()	{
		
			$this->SQL->query("   	SELECT `phase`
						INTO @phasename
						FROM ebag.production_phases 
						WHERE `personID`='$this->_phaseID' LIMIT 1 ");
						
			if ($this->_setting_type == 1)	{$stockID = $code = 'NULL';} else {$stockID = "'$this->_stockID'"; $code = "'$this->_code'";}
			
			foreach (array('percent_phases', 'fix_phases') as $phase)	{
			
				if (! $this->{'_'.$phase}) {${$phase} = 'NULL';} else {${$phase} = "'".$this->{'_'.$phase}."'";}
			}
			
			$this->SQL->query("	INSERT INTO $this->_base.employees_phases_bonuses
						VALUES
						(	NULL, '$this->_employeeID', '$this->_setting_type', $stockID, $code, '$this->_phaseID', 
							@phasename, $percent_phases, $fix_phases, '{$_SESSION['userID']}', '0'	)	");
		}
		
		function remove_bonus_row($id)	{
		
			$this->SQL->query("	UPDATE $this->_base.employees_phases_bonuses
						SET `deleted`=NULL
						WHERE `personID`='$id' LIMIT 1 " );
		}
		
		function remove_bonus_rows()	{
		
			$this->SQL->query("	UPDATE $this->_base.employees_phases_bonuses
						SET `deleted`=NULL
						WHERE	`employeeID`='$this->_employeeID'
						  AND	`phaseID`='$this->_phaseID'
						  AND 	`deleted` IS NOT NULL	"	);
		}
		
		function set_bonus()	{
		
			if ($this->empty_row && $this->_personID)	{
			
				$this->remove_bonus_row($this->_personID);
				
				return;
			}
			
			if ($this->_setting_type == 1)	{
			
				$this->remove_bonus_rows();
				
			}	else	{
			
				if ($this->_personID) $this->remove_bonus_row($this->_personID);
				
				if ($this->_deleteID) $this->remove_bonus_row($this->_deleteID);
			}
			
			$this->insert_bonus_row();
		}
	}
			
?>