<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * Generate list of eBag logged users accessed by xmlHttprequest
	 */
	 
	if (! isset($_GET['from'])) exit;

	ob_start('ob_gzhandler');

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);
	
	$FROM	=	$_GET['from'];
	$inc	=	0;
	
	if (get_magic_quotes_gpc()) $FROM = stripslashes($FROM);

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# header
	
	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT');
	header('Last-Modified: '.@gmdate( 'D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/plain');
	
	# read

	ob_start();
	
	# create connection

	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));
	
	if ($mysqli->connect_error) exit;

	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");
	
	$RESULT = $mysqli->query("	SELECT users.surname, users.lastname
					FROM ebag.users
					INNER JOIN ebagtemp.loggeds
					ON users.personID = loggeds.user
					WHERE loggeds.user IS NOT NULL 
					  AND users.deleted IS NOT NULL "); 
			
	if (! $RESULT->num_rows) exit;
	
	$USERS = array();
	
	while (list($surname, $lastname) = $RESULT->fetch_row()) $USERS[] = $surname.' '.$lastname;

	unset($RESULT);

	sort($USERS, SORT_STRING);
	
	echo '<div class="loggeds-list">'."\n";
	
	foreach ($USERS as $user) echo '<a class="call-link" href="#" onclick="Javascript: UserCall(\''.md5($user).'\')">'.$user.'</a><br>'."\n";

	echo '</div><a class="call-close" href="#" onclick="Javascript: UserCall(\'thishide\')">[x]</a>'."\n";

	ob_end_flush();

?>
