<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag write new chat message accessed by xmlHttprequest
	 */

	ob_start('ob_gzhandler');

	define('CHATFILE', "../tmp/chat.tmp");

	define('MAXLINES', 100); // max number of lines to keep

	/**
	 * Turn off magic quotes runtime
	 */

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	/**
	 * Get the post
	 */

	if ((! isset($_GET['msg'])) or ((! is_numeric($_GET['msg'])) && (! $_GET['msg']))) exit;

	/**
	 * If magic quotes is enabled strip slashes form POSTS
	 */

	if (get_magic_quotes_gpc())	{

		$_GET['msg'] 	=	stripslashes($_GET['msg']);
		$_GET['user']	=	stripslashes($_GET['user']);
	}
	
	include('../functions/specialchars_flag.php');

	$POST	=	htmlspecialchars($_GET['msg'], specialchars_flag(), 'UTF-8', FALSE);
	$NAME	=	$_GET['user'];

	/**
	 * Read chat file
	 */

	$COUNT 		= 	0;
	$LINES		= 	array();
	$STYLES		=	array();
	$HANDLER	=	@fopen(CHATFILE, 'r');

	if ($HANDLER !== FALSE)		{

		$inc = 0;

		while (! flock($HANDLER, LOCK_SH))	{

			$inc++; usleep(500);

			if ($inc > 100000)	{

				fclose($HANDLER); 
				exit;
			}
		}

		while (TRUE)	{

			$LINES[$COUNT] = fgets($HANDLER);

			if ($LINES[$COUNT]===FALSE)	{

				unset($LINES[$COUNT]);
				break;
			}

			/**
			 * Check for style
			 */

			$PARTS1	= mb_split('<', $LINES[$COUNT]);
			$PARTS2 = mb_split('>', $PARTS1[1]);
			
			if (! isset($STYLES[$PARTS2[1]])) $STYLES[$PARTS2[1]] = str_replace('DIV class="user" ', '', $PARTS2[0]);

			$COUNT++;
		}

		flock($HANDLER, LOCK_UN);

		fclose($HANDLER);
	}

	if ($COUNT > MAXLINES)	{

		$DIFF 	= $COUNT-MAXLINES;
		$LINES 	= array_slice($LINES, $DIFF);
	}

	/**
	 * If style is not defined create new one
	 */

	if (isset($STYLES[$NAME]))	{
	
		$STYLE  = 	$STYLES[$NAME];
	
	}	else	  {

		$COLORS	=	array(	'2F4F4F', '2B3856', '006400', '800000', '4B0082', '7E587E', '8B4513', 'FF4500', '000000', 'FF0000',
					'FF00FF', 'C0C0C0', '00FF00', '0000FF', 'FFFF00', '00FFFF', '6E6A6B', '254117', 'FFF8C6');
		$inc	=	0;
		$count	=	count($COLORS);

		while (TRUE)	{

			if ($inc < $count)	{

				$COLOR = $COLORS[$inc];

			}	else	{

				for ($i=0; $i<6; $i++) $COLOR .=  dechex(rand(0,15));
			}

			$STYLE = "style=\"color: #$COLOR;\"";

			if ((! count($STYLES)) or (! in_array($STYLE, $STYLES))) break;

			$inc++;
		}
	}

	array_push($LINES, "<DIV class=\"user\" $STYLE>$NAME</DIV><DIV class=\"message\" $STYLE>$POST</DIV>".PHP_EOL);

	$HANDLER	=	fopen(CHATFILE, 'w');

	if ($HANDLER === FALSE) exit;

	$inc = 0;

	while (! flock($HANDLER, LOCK_EX))	{

		$inc++; usleep(500);

		if ($inc > 100000)	{

			fclose($HANDLER); 
			exit;
		}
	}

	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT');
	header('Last-Modified: '.@gmdate('D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/plain');

	ob_start();

	foreach ($LINES as $LINE)	{

		fwrite($HANDLER, $LINE);
		echo $LINE."\r\n";
	}

	flock($HANDLER, LOCK_UN);

	fclose ($HANDLER);

	ob_end_flush();

?>
