<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag request to set personal service and article discount
	 */
	 
	if ((! isset($_GET['type'])) or (! isset($_GET['value'])) or (! isset($_GET['base'])) or (! isset($_GET['id']))) exit;

	# turn off magic quotes runtime

	if (get_magic_quotes_runtime())	set_magic_quotes_runtime(false);

	# if magic quotes is enabled strip slashes from code

	if (get_magic_quotes_gpc())	{

		foreach($_GET as $key=>$val) $_GET[$key] = stripslashes($val);
	}

	$type		=	$_GET['type'].'_discount';
	$discount	=	$_GET['value'];
	$BASE		=	$_GET['base'];
	$ID		=	$_GET['id'];

	# read configuration

	include('../classes/INIload.class.php');

	$__CONF	= new INI_load('../conf/eBag.ini');
	
	# Sets session handler

	include('../classes/Sessionhandler.class.php');

	$__SESS	=	new MysqlSession();
	$__SESS	->	set_session_handler();
	
	register_shutdown_function('session_write_close');

	session_start();
	
	# Check for session protect from unathorized data write
	
	if (isset($_SESSION['permission']))	{
	
		# refresh
	
		$_SESSION['permission'] = $_SESSION['permission'];
		
	}	else	  {
	
		exit;
	}
	
	# send headers
	
	header('Expires: Sun, 10 Jan 2010 12:00:00 GMT');
	header('Last-Modified: '.@gmdate('D, d M Y H:i:s').' GMT');
	header('Cache-Control: no-cache, no-store, must-revalidate');
	header('Pragma: no-cache');
	header('Content-Type: text/plain');

	# create access to current language

	include('../classes/Language.class.php');
	
	$lang 	= strtolower($__CONF->get('language', 'lang'));

	$__LANG	= new Lang("../lang/$lang/language.$lang", $__CONF->get('cache', 'use_apc_cache'));
	
	unset($lang);

	# check the user input

	if ((! is_numeric($discount)) or ($discount < 0) or ($discount >= 100)) exit('error::'.$__LANG->get('discountvalueerror'));

	# create connection

	$mysqli = new mysqli($__CONF->get('connection', 'host'), $__CONF->get('connection', 'user'), $__CONF->get('connection', 'password'));

	if ($mysqli->connect_error) exit;

	$mysqli->set_charset("utf8");

	$mysqli->query("SET NAMES 'utf8' COLLATE 'utf8_bin'");

	# define custom error handler 

	function errorhandler($errno, $errstr)	{

		global $mysqli;
		
		$mysqli->query('UNLOCK TABLES');

		return FALSE;
	}

	set_error_handler('errorhandler');

	# set the discount

	$mysqli->query("LOCK TABLES $BASE.addressbook WRITE");

	$RESULT = $mysqli->query("	SELECT `contactname` 
					FROM $BASE.addressbook 
					WHERE `personID`='$ID' LIMIT 1	");

	if ($RESULT->num_rows)	{

		$mysqli->query("	UPDATE $BASE.addressbook 
					SET `$type`='$discount' 
					WHERE `personID`='$ID' LIMIT 1	");

		echo number_format($discount, 2, '.', '');

	}	else	  {

		echo 'error::'.$__LANG->get('cannotread');
	}

	$mysqli->query('UNLOCK TABLES');

?>
