<?php
	/**
	 *	eBag
	 *
	 *	Open source company administration manager
	 *
	 *	@package	eBag
	 *	@author		Eper Kalman
	 *	@copyright	Copyright (c) 2012-2015, Eper Kalman
	 *	@license	GNU Affero General Public License Version 3 (http://www.gnu.org/licenses/agpl-3.0.html)
	 *	@since		Version 6.0.0
	 */

	/**
	 * eBag feedstock exploiting statistic
	 */

	load_f('pagination');

	load_f('mb_wrap');

	class FEEDSTOCKEXPLOIT	{

		var $COLUMN_names	=	array(	'code', 'name', 'used_quantity', 'enter_quantity', 'unit' );

		var $COLUMN_names_AS	=	array();

		var $ROW_LABEL		=	'';
		var $TABLE_BODY		=	'';
		var $COLUMNS		=	FALSE;
		var $PAGE		=	0;
		var $WHOLE		=	FALSE;
		var $COMMAND		=	'';

		function __construct($INCREMENT)	{

			$this->INC		=	$INCREMENT;

			$this->BASE		=	$_SESSION['BASE'];

			if (isset($_SESSION['year_is_closed']))	{

				$this->STOCKBASE = $this->BASE;

			}	else	  {

				$this->STOCKBASE = 'ebagstock';
			}

			global $__SQL, $__LANG, $__BOX;

			$this->SQL		=	&$__SQL;

			$this->LANG		=	&$__LANG;

			$this->BOX		=	&$__BOX;

			unset($_SESSION['ID']);

			foreach ($this->COLUMN_names as $COLUMN) $this->COLUMN_names_AS[$COLUMN] = $this->LANG->get($COLUMN);
		}

		/**
		 * Create table row with column names
		 */

		private function TABLEHEADER()	{

			$this->ROW_LABEL	.=	'<tr class="list-column-names">'."\n";

			foreach ($this->COLUMN_names_AS as $key=>$COLUMN)	{

				$this->ROW_LABEL .= '<td class="column-names">'.mb_wrap($COLUMN, 7, '<br>')."</td>\n";

			}

			$this->ROW_LABEL	.=	'<td class="filters" height="57">'."\n"
							.'<div id="print" class="list-print-div-hide">'."\n"
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=view" onclick="Javascript: printhide()">'.$this->LANG->get('printview').'</a>&nbsp;&nbsp;&nbsp;'
							.'<a class="print-link" target="_blank" href="../controllers/print.php?id=all" onclick="Javascript: printhide()">'.$this->LANG->get('printall').'</a></div>'
						 	.'<input class="button-print" name="PRINT" type="button" value="'.$this->LANG->get('PRINT_B').'" onclick="Javascript: printmenu();">'."\n"
							.'</td>'."\n"
							.'</tr>'."\n";
		}

		/**
		 * Form command 2 sql
		 */

		private function FORMCOMMAND()	{

			# read from production

			$_SESSION['TEMPTABLE1']	=	"	(	
									SELECT `code`, `name`, `unit`, SUM(quantity) AS `used_quantity` 
									FROM $this->BASE.production_orders_data
									WHERE `deleted` IS NOT NULL GROUP BY `code`	
								)
								UNION ALL
								(
									SELECT `code`, `feedstockname` AS `name`, `unit`, SUM(quantity) AS `used_quantity`
									FROM $this->BASE.feedstock_requests
									WHERE `deleted` IS NOT NULL GROUP BY `code`	
								)";

			$_SESSION['TEMPTABLE1']	=	"	CREATE TEMPORARY TABLE $this->BASE.temptable_1 ".$_SESSION['TEMPTABLE1'];

			$this->SQL->query($_SESSION['TEMPTABLE1']);

			# create sum

			$_SESSION['TEMPTABLE2']	=	"	SELECT `code`, `name`, `unit`, SUM(used_quantity) AS `used_quantity` 
								FROM $this->BASE.temptable_1 
								WHERE `code` IS NOT NULL GROUP BY `code`	";

			$_SESSION['TEMPTABLE2']	=	"	CREATE TEMPORARY TABLE $this->BASE.temptable_2 ".$_SESSION['TEMPTABLE2'];

			$this->SQL->query($_SESSION['TEMPTABLE2']);

			# read enters

			$_SESSION['TEMPTABLE3']	=	"	SELECT `code`, SUM(quantity) AS `enter_quantity` 
								FROM $this->BASE.feedstock_enter
								WHERE `deleted` IS NOT NULL GROUP BY `code`	";

			$_SESSION['TEMPTABLE3']	=	"	CREATE TEMPORARY TABLE $this->BASE.temptable_3 ".$_SESSION['TEMPTABLE3'];

			$this->SQL->query($_SESSION['TEMPTABLE3']);

			$this->COMMAND = $_SESSION['COMMAND'] = "	SELECT SQL_CALC_FOUND_ROWS 	temptable_2.code, temptable_2.name, temptable_2.used_quantity, 
													temptable_3.enter_quantity, temptable_2.unit
									FROM $this->BASE.temptable_2 
									INNER JOIN $this->BASE.temptable_3 
									ON temptable_2.code=temptable_3.code
									ORDER BY `used_quantity` DESC	";

			$LIMIT			=	' LIMIT '.($this->PAGE * $this->INC).', '.$this->INC;

			$_SESSION['LIMIT']	=	$LIMIT;

			$this->COMMAND		.=	$LIMIT;
		}

		/**
		 * Count the pages
		 */

		private function PAGECOUNT()	{

			if (! $this->WHOLE) return;

			if ($this->WHOLE < $this->INC)	{

				$this->PAGENUM	=	0;

			}	else 	{ 

				if ($this->WHOLE % $this->INC==0) {$correct=1;} else {$correct=0;}

				$this->PAGENUM = floor($this->WHOLE / $this->INC)-$correct;
			}

			unset($this->WHOLE);
		}

		/**
		 * Fetch query result to table
		 */

		private function TABLEBODY()	{

			$this->SQL->query($this->COMMAND);

			$this->WHOLE = $this->SQL->calc_rows();

			if (! $this->WHOLE)	{

				$SPAN	=	count($this->COLUMN_names) + 1;
				$ERRTXT	=	$this->LANG->get('noresult');	

				$this->TABLE_BODY .= "<tr><td class=\"link\" colspan=\"$SPAN\">$ERRTXT</td></tr>\n";

				return;
			}
	
			$this->PAGECOUNT();

			$CLASS		=	'list-dark';
			$DETAILS	=	$this->LANG->get('details');

			$this->SQL->IT1_RESULT = $this->SQL->RESULT;

			while ($RESULT = $this->SQL->IT1_RESULT->fetch_assoc())	{

				if ($CLASS=='list-dark')	{$CLASS = 'list-light';} else {$CLASS = 'list-dark';}

				$this->TABLE_BODY .= "<tr class=\"$CLASS\" onmouseover=\"Javascript: mark(this);\" onmouseout=\"Javascript: unmark(this);\">\n";

				foreach ($this->COLUMN_names as $COLUMN)	{

					$VALUE = $RESULT[$COLUMN];

					if ($COLUMN == 'code')	{

						$this->SQL->query("	SELECT `personID` 
									FROM $this->STOCKBASE.feedstock 
									WHERE `code`='".$this->SQL->r_escape($VALUE)."' AND `deleted` IS NOT NULL LIMIT 1");
						$ID	=	0;

						if ($this->SQL->num_rows())	{

							$ID	=	$this->SQL->RESULT->fetch_row();
							$ID	=	$ID[0];
						}
					}

					$this->TABLE_BODY .= "<td><input class=\"list-input\" style=\"width: ".$this->BOX->size($COLUMN)."px;\" readonly value=\"$VALUE\"></td>\n";
				}

				$this->TABLE_BODY .= 	"<td class=\"link\" colspan=\"1\">\n"
							."<a class=\"list-link\" href=\"loader.php?cat=feedstockdetails&amp;id=$ID\">$DETAILS</a>\n"
							."</td>\n";

				$this->TABLE_BODY .= "</tr>\n";
			}

			$this->SQL->free();

			unset($this->SQL->IT1_RESULT);
		}

		private function GETPOST()	{

			if (isset($_GET['new']))	{

				$_SESSION['LISTPAGE']	=	0;

				return;
			}

			if (isset($_GET['page']))	{

				$this->PAGE = $_SESSION['LISTPAGE'] = (integer)$_GET['page'];

			}	else	  {

				$this->PAGE = $_SESSION['LISTPAGE'];
			}
		}

		/**
		 * Displays the table;
		 */

		public function create()	{

			$_SESSION['DROPTABLE1']	= "DROP TEMPORARY TABLE IF EXISTS $this->BASE.temptable_1";
			$_SESSION['DROPTABLE2']	= "DROP TEMPORARY TABLE IF EXISTS $this->BASE.temptable_2 ";
			$_SESSION['DROPTABLE3']	= "DROP TEMPORARY TABLE IF EXISTS $this->BASE.temptable_3 ";

			$this->SQL->query($_SESSION['DROPTABLE1']);
			$this->SQL->query($_SESSION['DROPTABLE2']);
			$this->SQL->query($_SESSION['DROPTABLE3']);

			$this->GETPOST();

			$this->TABLEHEADER();

			$this->FORMCOMMAND();

			$this->TABLEBODY();
			
			$this->TABLE = "<div class=\"border\">\n<div class=\"padding-list\">\n<table id=\"data\" class=\"list\">\n$this->ROW_LABEL $this->TABLE_BODY\n</table>\n</div>\n</div>\n";

			if (isset($this->PAGENUM)) $this->TABLE = $this->TABLE.pagination($this->PAGE, $this->PAGENUM, $this->INC, backward());

			unset($this->ROW_LABEL, $this->ROW_FILTER, $this->TABLE_BODY);

			$this->SQL->query($_SESSION['DROPTABLE1']);
			$this->SQL->query($_SESSION['DROPTABLE2']);
			$this->SQL->query($_SESSION['DROPTABLE3']);
		}
	}

?>
